;JOURNEY TO ANOTHER WORLD                          (ANTES LIVING IN ANOTHER WORLD)
;JB 2015


;Este juego es un pequeo homenaje al genial juego de ric Chahi para Delphine Software de 1991 "ANOTHER WORLD", con el que tanto disfrut hace ya 24 aos.

;He usado Context (www.contexteditor.org), PASMO (www.pasmo.speccy.org), BEEPOLA (www.freestuff.grok.co.uk/beepola/) y ZX-Paintbrush y ZX-Blockeditor de Claus Jahn(www.zx-modules.de).

;-------------

;Las personas mayores nunca son capaces de comprender las cosas por s mismas, y es muy aburrido para los nios tener que darles una y otra vez explicaciones.   Saint-Exupry  "El Principito"




ORG 32768

LD SP,65535    ;PILA AL FINAL

XOR A
OUT (254),A
LD (23624),A    ;BORDER NEGRO



;**************************************************************************
;*****************************   PREVIO  **********************************
;**************************************************************************


JP ANIMACION_PREVIA


;**************************************************************************
;*****************************    MENUS   *********************************
;**************************************************************************


;**************************************************************************
;**************************************************************************
MENU_PRINCIPAL:

XOR A
LD (JOKER4),A         ;USO JOKER4 COMO CONTADOR DE LA TORMENTA

CALL CELESEJUEGO

CALL COPITRANS        ;COPIAMOS TITULO DE LA PARTE INFERIOR OCULTA
LD BC,773
LD DE,2563
LD A,68
CALL COLOREA
LD BC,785
LD DE,2564
LD A,65
CALL COLOREA
LD BC,1295
LD DE,770
LD A,71
CALL COLOREA          ;Y LO COLOREAMOS

LD BC,1797
LD DE,5633
LD A,40
LD HL,VACIO1X1+152
CALL RELLENA          ;DEGRADADO

LD BC,2053
LD DE,5641
LD A,40
CALL COLOREA          ;FONDO AZUL

LD BC,2061
LD DE,TORMENTAS+76
LD A,255
CALL DIBUJA
LD BC,2066
LD DE,TORMENTAS+76
LD A,255
CALL DIBUJA           ;DOS NUBES



LD BC,2824
LD DE,LESTER1
LD A,255
CALL DIBUJA
LD BC,3079
LD DE,LESTER2
LD A,255
CALL DIBUJA
LD BC,3337
LD DE,LESTER3
LD A,255
CALL DIBUJA
LD BC,4360
LD DE,LESTER4
LD A,255
CALL DIBUJA           ;LESTER


LD A,71
LD(COLORFUENTE),A

LD BC,4613
LD DE,TEXTOS+195       ;"JB"
CALL UNAFRASE

;**************************************************************************
MENU_PRINCIPAL_BIS:

LD BC,4632
LD DE,769
CALL BORRAZONA
CALL BORRAMENU

LD A,40
LD(COLORFUENTE),A

LD BC,3088
LD DE,TEXTOS+179       ;"J-JUGAR"
CALL UNAFRASE

LD BC,3600
LD DE,TEXTOS+187       ;"A-AYUDA"
CALL UNAFRASE




BUCLE_MENU_PRINCIPAL:

LD BC, $BFFE                ; Semifila "H" a "ENTER"
IN A, (C)                   ; Leemos el puerto
BIT 3, A                    ; Testeamos el bit 3  "J"
JP Z, JUEGOENSIMISMO        ; Si est a 0 (pulsado) IR A JUEGO

LD BC, $FDFE                ; Semifila "G" a "A"
IN A, (C)                   ; Leemos el puerto
BIT 0, A                    ; Testeamos el bit 0  "A"
JP Z, MENU_AYUDA            ; Si est a 0 (pulsado) IR AYUDA.

CALL TORMENTOSO

JR BUCLE_MENU_PRINCIPAL

;**************************************************************************
;**************************************************************************
MENU_AYUDA

CALL BORRAMENU



LD BC,2321
LD DE,TEXTOS+274    ;"Q"
CALL UNAFRASE
LD BC,3345
LD DE,TEXTOS+276    ;"A"
CALL UNAFRASE
LD BC,2831
LD DE,TEXTOS+278    ;"O"
CALL UNAFRASE
LD BC,2835
LD DE,TEXTOS+280    ;"P"
CALL UNAFRASE
LD BC,3854
LD DE,TEXTOS+282    ;"I-INVENTARIO"
CALL UNAFRASE
LD BC,4110
LD DE,TEXTOS+295    ;"M-ACCION"
CALL UNAFRASE

LD BC,2576
LD DE,ROSA_VIENTOS
LD A,255
CALL DIBUJA         ;ROSA DE LOS VIENTOS

LD BC,4632
LD DE,K_EXIT
LD A,255
CALL DIBUJA         ;K ->SALIR




BUCLE_MENU_AYUDA:

LD BC, $BFFE                ; Semifila "H" a "ENTER"
IN A, (C)                   ; Leemos el puerto
BIT 2, A                    ; Testeamos el bit 3  "K"
JP Z, MENU_PRINCIPAL_BIS    ; Si est a 2 (pulsado) IR A MENU PRINCIPAL

CALL TORMENTOSO

JR BUCLE_MENU_AYUDA

;**************************************************************************
;**************************************************************************
;TORMENTAS
TORMENTOSO:

LD A,(JOKER4)
INC A
LD (JOKER4),A
CP 250
RET NZ

XOR A
LD (JOKER4),A

LD BC,250
CALL LIMITE
CP 3
JR NC,DESPEJADO

LD DE,38
CALL Mul8              ; this routine performs the operation HL=DE*A
LD DE,TORMENTAS
ADD HL,DE
EX DE,HL
LD BC,2070
LD A,255
CALL DIBUJA
;CALL FX_TRUENO                       ;---->>> EFECTO TRUENO...
CALL PAUSADE5

DESPEJADO:
LD BC,2070
LD DE,1026
LD A,40
LD HL,VACIO1X1
CALL RELLENA

RET

;SIGUE_TORMENTA:
;CALL PAUSADE5
;RET



;********** DEFINICION DE TECLAS Y SELECCION DE JOYSTICK              <----- EL MINIJUEGO SNAKE Y OTRAS CUESTIONES HACEN QUE AL FINAL USE SOLO "QAOPMI", QUIZS EN EL SIGUIENTE SER
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;*****************************************************

;XOR A
;LD (KEMPSTON),A           ;KEMPSTON INICIALMENTE NO SELECCIONADO

;********************** D E F I N I R      T E C L A S   **********************
;Q-37      SINCLAIR 1-36    SINCLAIR 6-3     (AVERIGUAR COMO SE IDENTIFICAN EN MENUS)
;A-38      PORT 2   2-28    PORT 1   7-11
;O-26      INTERF 1 3-20    INTERF 2 8-19
;P-34               4-12             9-27
;M-16               5-4              0-35

;LOS TEXTOS SON PROVISIONALES !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!       --- PONER EN ALGUN SITIO QUE INVENTARIO ES "I", SI O SI

;LD HL,TECLAS_DEFECTO+0    ;TECLADO POR DEFECTO QAOPM,     SI ES SINCLAIR1   TECLAS_DEFECTO+5         SINCLAIR2    TECLAS_DEFECTO+10
;LD DE,TECLA_O
;LD BC,5
;LDIR
;JP  JUEGOENSIMISMO

;LD A,71
;LD (COLORFUENTE),A
;LD BC,2569
;LD DE,TEXTOS+0          ;"PULSA PARA..."
;CALL UNAFRASE

;LD A,70
;LD (COLORFUENTE),A

;LD BC,3597
;LD DE,TEXTOS+14         ;"ARRIBA"
;CALL UNAFRASE

;QUIERO_ARRIBA:
;CALL Find_Key            ;OBTENEMOS EN "D"  "PUERTO BIT012" Y "POSICION BIT345"
;JR NZ, QUIERO_ARRIBA     ; Repetir si la tecla no es vlida
;INC D
;JR Z, QUIERO_ARRIBA      ; Repetir si no se puls ninguna tecla
;DEC D
;LD A, D
;LD (TECLA_Q), A
;CALL EFECTO2

;LD BC,3597
;LD DE,TEXTOS+21         ;"ABAJO"
;CALL UNAFRASE

;QUIERO_ABAJO:
;CALL Find_Key            ;OBTENEMOS EN "D"  "PUERTO BIT012" Y "POSICION BIT345"
;JR NZ, QUIERO_ABAJO      ; Repetir si la tecla no es vlida
;INC D
;JR Z, QUIERO_ABAJO       ; Repetir si no se puls ninguna tecla
;DEC D
;LD A, D
;LD (TECLA_A), A
;CALL EFECTO2

;LD BC,3596
;LD DE,TEXTOS+27         ;"IZQUIERDA"
;CALL UNAFRASE

;QUIERO_IZQUIERDA:
;CALL Find_Key            ;OBTENEMOS EN "D"  "PUERTO BIT012" Y "POSICION BIT345"
;JR NZ, QUIERO_IZQUIERDA     ; Repetir si la tecla no es vlida
;INC D
;JR Z, QUIERO_IZQUIERDA      ; Repetir si no se puls ninguna tecla
;DEC D
;LD A, D
;LD (TECLA_O), A
;CALL EFECTO2

;LD BC,3597
;LD DE,TEXTOS+37         ;"DERECHA"
;CALL UNAFRASE

;QUIERO_DERECHA:
;CALL Find_Key            ;OBTENEMOS EN "D"  "PUERTO BIT012" Y "POSICION BIT345"
;JR NZ, QUIERO_DERECHA     ; Repetir si la tecla no es vlida
;INC D
;JR Z, QUIERO_DERECHA      ; Repetir si no se puls ninguna tecla
;DEC D
;LD A, D
;LD (TECLA_P), A
;CALL EFECTO2

;LD BC,3597
;LD DE,TEXTOS+45         ;"ACCION"
;CALL UNAFRASE

;QUIERO_ACCION:
;CALL Find_Key            ;OBTENEMOS EN "D"  "PUERTO BIT012" Y "POSICION BIT345"
;JR NZ, QUIERO_ACCION     ; Repetir si la tecla no es vlida
;INC D
;JR Z, QUIERO_ACCION      ; Repetir si no se puls ninguna tecla
;DEC D
;LD A, D
;LD (TECLA_M), A
;CALL EFECTO2

;CALL CELESE



;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
;                                    -- INICIO DEL JUEGO --
;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
;*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

JUEGOENSIMISMO:

LD BC,1793
LD DE,778
CALL BORRAZONA        ;BORRAMOS ESPACIO DE VIDAS Y DE INVENTARIO
LD BC,1821
LD DE,514
CALL BORRAZONA


CALL COLOREAR_MARCO         ;COLOREAMOS EL MARCO


LD A,(23672)                ;TIEMPO TRANSCURRIDO
LD (SEED),A                 ;SEMILLA NUMEROS ALEATORIOS



;********** RESTAURAR VALORES
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;*****************************************************

LD HL,HISTORIA        ;TABLAS Y VARIABLES A CERO...
LD B,65
CALL TABLAACERO


;********** JUEGO PREVIO ANOTHER WORLD
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;*****************************************************


                 ; P R O V I S I O N A L 
                 ;JP JUEGO_PRINCIPAL                   ;LANZAMOS JUEGO PRINCIPAL


;LD HL,MARCO1     ;MARCO N1
;LD A,69
;CALL MARCOS


LD A,104
LD (X),A
LD A,120
LD(Y),A

LD HL,ELBUENO
LD (BRAULIO),HL
LD A,48            ;BUENO FONDO AMARILLO TINTA NEGRA
LD (COLORBUENO),A
LD A,54            ;FONDO AMARILLO TINTA AMARILLA
LD (FONDO),A

LD A,111
LD (PANTALLA),A

PREVIO_0:
CALL CELESEJUEGO
;LD A,6
;LD (23695),A      ;COLOR DRAW
;DRAWING:
;LD BC, ALTO , LARGO
;LD DE, 1/-1 , 1/-1
;COORDS  23677 X   23678 Y   (OJO DE 0 A 175)
;CALL 9402
CALL LINEAS_HORIZONTE
CALL PINTAR_PP_PREVIA
CALL PINTAR_PP_141
CALL PINTABUENO
;TEXTO
LD A,50                  ;FONDO AMARILLO TINTA ROJA
LD (COLORFUENTE),A
LD BC,3337               ;Y13 X9
LD DE,TEXTOS+153         ;"DONDE ESTOY?"
CALL UNAFRASE

CALL FX_TORIRORI


CALL ESPERATECLA
LD BC,3337
LD DE,3073
CALL BORRAZONA

;CALL EFECTO2
CALL FX_BIPBIP
CALL PAUSADE50
LD BC,3863
LD DE,770
CALL BORRAZONA

PREVIO_1:

CALL PINTAR_PP_PREVIA

LD A,(PANTALLA)
CP 101
CALL Z,PINTAR_PP_101
CP 141
CALL Z,PINTAR_PP_141

CALL PINTABUENO

JP BUCLE_JUEGO_PREVIO


;********** JUEGO PRINCIPAL
;*****************************************************
;*****************************************************

JUEGO_PRINCIPAL:

;**************************************************************************
;************    VALORES INICIALES   **************************************
;**************************************************************************

LD A,184
    ;LD A,96
LD (X),A
LD A,88
LD(Y),A

LD HL,ELBUENO+80    ;SALE MIRANDO IZQUIERDA
LD (BRAULIO),HL
LD A,71
LD (COLORBUENO),A
LD A,1              ;FONDO NEGRO TINTA BLUE
LD (FONDO),A

LD A,91
     ;LD A,49
LD (PANTALLA),A

LD A,65             ;PINTURA CARGADA INICIAL EN MQUINA DE PINTAR
LD(ESTADOS+12),A

LD A,5
LD (VIDAS),A
LD (VIDAS_SNAKE),A
LD (VIDAS_HORACE),A

               ;B O R R A R  - ES PARA QUE SALGA ELEFANTE DE SU JAULA
               ;LD A,1
               ;LD HL,ESTADOS+10
               ;LD (HL),A

               ;LD A,1
               ;LD HL,ESTADOS+24
               ;LD (HL),A



;**************************************************************************
;********************   DIBUJO INTERFAZ JUEGO   ***************************
;**************************************************************************

CALL PINTA_VIDA_PRINCIPAL        ;PINTAMOS VIDAS
CALL PINTA_VIDA_SNAKE
CALL PINTA_VIDA_FROG

LD BC,1821                       ;BORRAMOS INVENTARIO
LD DE,VACIO2X2
LD A,255
CALL DIBUJA



;**************************************************************************
;*******************   C A R G A P A N T A L L A   ************************
;**************************************************************************

CARGAPANTALLA:

CALL CELESEJUEGO


LD HL,FONDITO        ;TABLAS Y VARIABLES A CERO EN CADA CARGAPANTALLA
LD B,168             ;6 FONDITO + 121 EVENTOS + 36 MALVADOS+ 5 EVENTOS VEX
CALL TABLAACERO


CALL NILAMANTAPORCALOR
LD DE,MAPAX
ADD HL,DE
CALL PINTAPANTALLA

;**************************************************************************
;**********************   CARGAR FONDOS ANIMADOS   ************************
;**************************************************************************

CALL CARGAFONDOS

;**************************************************************************
;**********************   CARGAR EVENTOS   ********************************
;**************************************************************************

CALL CARGAEVENTOS

;**************************************************************************
;**********************   CARGAR GUARDIANES   ********************************
;**************************************************************************

CALL CARGAGUARDIANES

;LD IX,MALVADOS
;LD A,(IX+0)
;CP 0
;JR Z,FINAR

;       LD B,3
;       JJKL:
;       PUSH BC

;       LD C,(IX+0)         ;X
;       LD B,(IX+1)         ;Y
;       LD A,(IX+6)         ;COLOR
;       LD H,(IX+7)         ;SPRITE
;       LD L,(IX+8)         ;SPRITE
;       CALL HR2X2B

;       LD DE,12
;       ADD IX,DE


;       POP BC
;       DJNZ JJKL

;FINAR:



;**************************************************************************
;**********************   PINTAR ESTADOS   ********************************
;**************************************************************************

CALL PINTAR_ESTADOS

;CORRECCION PANTALLA 99 DEBAJO DE BOMBILLA
LD A,(PANTALLA)
CP 99
JR NZ,NO_NIAPA
LD A,(ESTADOS+9)   ;BANQUETA PUESTA O NO
CP 1
JR Z,NO_NIAPA
   LD BC,3345
   LD DE,514
   LD A,0
   LD HL,VACIO1X1
   CALL RELLENA
NO_NIAPA:

;**************************************************************************
;*****   PINTAR ESTADOS VIDAS EXTRA EN MAPA  Y CARGAR EVENTOS_VIDEX  ******
;**************************************************************************

CALL PINTAR_ESTADOS_VEXT

CALL CARGAEVENTOS_VEXT

;**************************************************************************
;************************   ESPECIALES   **********************************
;**************************************************************************

;PINTURA CARGADA EN MQUINA PINTAR (ESTADO N12)
;OBJETO RESULTADO MAQUINA PINTAR   (ESTADO N13)
LD A,(PANTALLA)
CP 64
JR NZ,NO_PANTALLA64

LD HL,ESTADOS+12
LD A,(HL)           ;COLOR EN ESTADO N12
LD BC,2576          ;Y=10 X=16
LD DE,DEPOSITO
CALL DIBUJA

LD HL,ESTADOS+13
LD A,(HL)           ;COLOR EN ESTADO N12
CALL SACA_DE_OBJETO
LD BC,2061          ;Y=8 X=13
LD A,255
CALL DIBUJA

NO_PANTALLA64:


;POSICIN MIOPE EN PANTALLA 77
LD A,(PANTALLA)
CP 77
JR NZ,NO_PANTALLA77

LD HL,ESTADOS+8
LD A,(HL)           ;ESTADO MIOPE
CP 0
JR NZ,CHKKKIO
LD DE,TARRO+532
LD BC,3343          ;Y=13 X=15
JR CHKKKIO2
CHKKKIO:
LD DE,TARRO+570
LD BC,2319          ;Y=9 X=15
CHKKKIO2:
LD A,255
CALL DIBUJA

NO_PANTALLA77:

;LUZ TELETRANSPORTE FUNCIONA
LD A,(PANTALLA)
CP 70
JR NZ,NO_PANTALLA70

LD HL,ESTADOS+14
LD A,(HL)           ;ESTADO TELETRANSPORTE
CP 3
JR NZ,NO_PANTALLA70

LD DE,OBJETOX+1080
LD BC,2581          ;Y=10 X=21
LD A,194            ;ROJO FONDO NEGRO BRILLO Y FLASH
CALL DIBUJA

NO_PANTALLA70:


;**************************************************************************
;**********************   PINTAR BUENO   **********************************
;**************************************************************************

CALL PINTABUENO


JP BUCLE_PRINCIPAL

;**************************************************************************
;*******************   BUCLE PRINCIPAL   **********************************
;**************************************************************************

INCLUDE TRANSICIONES.ASM
INCLUDE BUCLE.ASM
INCLUDE PERSECUCION.ASM
INCLUDE SNAKE.ASM
INCLUDE MISIL.ASM
;INCLUDE TABLERO.ASM
INCLUDE FROG.ASM
INCLUDE RUTINAS.ASM
INCLUDE RUTINASII.ASM
INCLUDE ESCRIBIR.ASM
INCLUDE GRAFICOS.ASM
INCLUDE MAPAX.ASM
INCLUDE DATOX.ASM
INCLUDE ESPRITES.ASM
INCLUDE SONIDOS.ASM


END 32768