

;*******************************************
;**********      M I S I L      ************
;*******************************************

;BASADO EN EL JUEGO "Cassette 7 - Air/Sea Battle" DE LA CONSOLA VC 4000 INTERTRON

MISIL:


;/////////////////////////////////////////////////////////////// C L A V E ///////////////////////////////////////////////////////////////////////////////

;////////////// PINTAMOS CLAVE

CALL CELESEJUEGO

;PONDRA ALGN ADORNO O DIBUJO MAS ELABORADO... SI SOBRA ESPACIO...

LD BC,773
LD DE,2824
LD A,255
LD HL,VACIO2X2+608
CALL RELLENA2D

LD BC,1801
LD DE,3591
XOR A
LD HL,VACIO1X1
CALL RELLENA

LD BC,3860
LD DE,1283
XOR A
LD HL,VACIO1X1
CALL RELLENA

LD BC,4117
LD A,255
LD DE,K_EXIT       ;EXIT LETRA K
CALL DIBUJA

LD BC,1031
LD DE,4609
LD A,69
LD HL,VACIO1X1+80  ;ESLABONES
CALL RELLENA

LD BC,1039
LD A,255
LD DE,CANDADO2X2   ;CERROJO 2X2
CALL DIBUJA

LD BC,2315
LD A,255
LD DE,OBJETOX+745
CALL DIBUJA

LD BC,2317
LD A,255
LD DE,OBJETOX+745
CALL DIBUJA

LD BC,2319
LD A,255
LD DE,OBJETOX+745
CALL DIBUJA

LD BC,2321
LD A,255
LD DE,OBJETOX+745
CALL DIBUJA

LD BC,2580
LD A,255
LD DE,CERRADURA
CALL DIBUJA

;////////////// CLAVE A 0

LD HL,ESPEJO        ;USAMOS  4 PRIMEROS BITES ESPEJO PARA GESTIONAR LA CLAVE
LD B,4              ;
CALL TABLAACERO

;////////////// PINTAMOS NUMEROS

CALL PINTACLAVE

;////////////// BUCLE CLAVE

LD IX,POSICIONES_CLAVE
CALL COLOREA_PUNTERO_CLAVE_ROJO


BUCLE_CLAVE:


CALL LEER_TECLADO

           ;INTERPRETAMOS LECTURA
           CP 0
           JP Z,FIN_CLAVICORDIO


           CLAVE_ARRIBA:
                   CP 1
                   JR NZ,CLAVE_ABAJO
                   LD A,(IX+0)
                   CP 11
                   JP NZ,FIN_CLAVICORDIO
                     CALL COLOREA_PUNTERO_CLAVE_AMARILLO
                     LD BC,-12
                     ADD IX,BC
                     CALL COLOREA_PUNTERO_CLAVE_ROJO
                     CALL BIP
                     CALL PAUSADE5
                   JP FIN_CLAVICORDIO

            CLAVE_ABAJO:
                   CP 2
                   JR NZ,CLAVE_DERECHA
                   LD A,(IX+0)
                   CP 9
                   JP NZ,FIN_CLAVICORDIO
                     CALL COLOREA_PUNTERO_CLAVE_AMARILLO
                     LD BC,12
                     ADD IX,BC
                     CALL COLOREA_PUNTERO_CLAVE_ROJO
                     CALL BIP
                     CALL PAUSADE5
                   JP FIN_CLAVICORDIO

            CLAVE_DERECHA:
                   CP 3
                   JR NZ,CLAVE_IZQUIERDA
                   LD A,(IX+1)
                   CP 20
                   JP Z,FIN_CLAVICORDIO
                     CALL COLOREA_PUNTERO_CLAVE_AMARILLO
                     LD BC,3
                     ADD IX,BC
                     CALL COLOREA_PUNTERO_CLAVE_ROJO
                     CALL BIP
                     CALL PAUSADE5
                   JP FIN_CLAVICORDIO

            CLAVE_IZQUIERDA:
                   CP 4
                   JR NZ,CLAVE_ACCION
                   LD A,(IX+1)
                   CP 11
                   JP Z,FIN_CLAVICORDIO
                     CALL COLOREA_PUNTERO_CLAVE_AMARILLO
                     LD BC,-3
                     ADD IX,BC
                     CALL COLOREA_PUNTERO_CLAVE_ROJO
                     CALL BIP
                     CALL PAUSADE5
                   JP FIN_CLAVICORDIO

            CLAVE_ACCION:
                  CP 5
                  JR NZ,FIN_CLAVICORDIO

               CALL FX_BIP

               ZALIBA:
                  LD A,(IX+0)
                  CP 9
                  JR NZ,ZABAJO

                     LD HL,ESPEJO
                     LD D,0
                     LD E,(IX+2)
                     ADD HL,DE
                     LD A,(HL)
                     INC A
                     CP 10
                     JR NZ,KUSKUS0
                     XOR A
                   KUSKUS0:
                     LD (HL),A
                     JR ZE_PINTA
                     CALL BIP
                     CALL PAUSADE10


               ZABAJO:
                  CP 11
                  JR NZ,ZELECCION
                     LD HL,ESPEJO
                     LD D,0
                     LD E,(IX+2)
                     ADD HL,DE
                     LD A,(HL)
                     DEC A
                     CP -1
                     JR NZ,KUSKUS1
                     LD A,9
                   KUSKUS1:
                     LD (HL),A
                     JR ZE_PINTA
                     CALL BIP
                     CALL PAUSADE10

               ZELECCION:

                     LD HL,ESPEJO
                     LD A,(HL)
                     CP 3
                     JR NZ,NO_CERTASTE
                     INC HL
                     LD A,(HL)
                     CP 2
                     JR NZ,NO_CERTASTE
                     INC HL
                     LD A,(HL)
                     CP 9
                     JR NZ,NO_CERTASTE
                     INC HL
                     LD A,(HL)
                     CP 1
                     JR NZ,NO_CERTASTE

                  SI_CERTASTE:

                     JR MISIL2

                  NO_CERTASTE:
                     ;TEXT ESA NO ES LA CLAVE
                     CALL EFECTO_CAGADA
                     JR FIN_CLAVICORDIO    ;PODRA SALIR A PANTALLA JUEGO...

               ZE_PINTA:
                     CALL PINTACLAVE
                     CALL PAUSADE10       ;PRUEBA DE FRENO

FIN_CLAVICORDIO:

                LD BC, $BFFE                ; Semifila "H" a "ENTER"
                IN A, (C)                   ; Leemos el puerto
                BIT 2, A                    ; Testeamos el bit 2  "K"
                JP Z, SALIMOS_MISIL        ; Si est a 0 (pulsado) salir.

JP BUCLE_CLAVE



;*******************************************
;**********      M I S I L      ************
;*******************************************

MISIL2:


;*******************************************
; INTRO MISIL   *******************************************
;*******************************************

CALL CELESEJUEGO

CALL PINTAR_TITULO

LD A,70
LD (COLORFUENTE),A
LD BC,3603
LD DE,TEXTOS+83       ;"GAME OF"
CALL UNAFRASE

LD A,68
LD (COLORFUENTE),A
LD BC,4115
LD DE,TEXTOS+91       ;"VC-4000"
CALL UNAFRASE

;*********  Y DIBUJITO @ MUSIQUILLA

LD BC,2319
LD A,255
LD DE,ROCKET    ;DIBUJITO DE UN COHETE
CALL DIBUJA

CALL ESQUELETOS_SONG
CALL ESPERATECLA

;*******************************************
; INICIAMOS VARIABLES DEL JUEGO   ***********************************
;*******************************************

LD HL,ESPEJO        ;VAMOS A USAR EL ESPACIO RESERVADO EN ESPEJO
LD B,100            ;100 BYTES RESERVAMOS
CALL TABLAACERO

LD A,1
LD (ESPEJO+0),A     ;PRIMERA FASE

;*******************************************
; INTRO FASE   *******************************************
;*******************************************

FASE_MISIL:

CALL CELESEJUEGO

CALL PINTAR_TITULO

CALL DEDESTADO2       ;PONEMOS EN "DE" DIRECCIONDE PINTURA ROSA O ED VIDA EXTRA SNAKE SEGUN VALOR ESTADO+2
LD BC,3348
LD A,255
CALL DIBUJA


LD A,69
LD (COLORFUENTE),A
LD BC,2316
LD DE,TEXTOS+65        ;"FASE -"
CALL UNAFRASE

LD A,(ESPEJO+0)        ;N FASE
LD BC,2323
CALL UNNUMERO

LD A,(ESPEJO+0)        ;OBTENEMOS PUNTOS OBJETIVO
LD HL,PTOS_OBJETIVO
LD D,0
LD E,A
ADD HL,DE
LD A,(HL)
LD (ESPEJO+1),A

XOR A
LD (ESPEJO+2),A        ;PTOS OBTENIDOS
LD (ESPEJO+4),A        ;OBJETIVO CONSEGUIDO

LD A,10
LD (ESPEJO+3),A        ;N DE MISILES POR DISPARAR

LD B,4   ;CUADRADITOS BLANCOS
PIOPIO:
PUSH BC
        LD A,B
        SLA A
        ADD A,10
        LD C,A
        LD B,14
        LD A,255
        LD DE,CUADRO_LIMPIO
        CALL DIBUJA
POP BC
DJNZ PIOPIO


LD A,(ESPEJO+0)  ;CUADRADITOS TACHADOS
CP 1
JR Z,PIOPIO3
DEC A
LD B,A
PIOPIO2:
PUSH BC
        LD A,B
        SLA A
        ADD A,10
        LD C,A
        LD B,14
        LD A,255
        LD DE,CUADRO_TACHAO
        CALL DIBUJA
POP BC
DJNZ PIOPIO2
PIOPIO3:

;*********  Y  MUSIQUILLA
CALL FX_TORIRORI
CALL ESPERATECLA

;*******************************************
; DIBUJO PANTALLA   *******************************************
;*******************************************

CALL CELESEJUEGO

LD BC,1797
LD DE,5635
LD A,15             ;TINTA BLANCA, FONDO AZUL
CALL COLOREA

LD BC,2565
LD DE,5635
LD A,42             ;TINTA ROJA, FONDO CYAN
CALL COLOREA

LD BC,3333
LD DE,5635
LD A,48             ;TINTA NEGRA, FONDO AMARILLO
CALL COLOREA

LD BC,4101
LD DE,5635
LD A,16             ;TINTA NEGRA, FONDO ROJO
CALL COLOREA

LD BC,34936
LD A,16
LD HL,LANZADERA
CALL HR1X1B

LD BC,34984
LD A,22
LD HL,FILIGRANA_I
CALL HR1X1B

LD BC,35016
LD A,22
LD HL,FILIGRANA_D
CALL HR1X1B

LD A,20             ;TINTA VERDE, FONDO ROJO
LD (COLORFUENTE),A
LD BC,4374
LD A,(ESPEJO+1)
CALL TRESNUMEROS

LD A,71
LD (COLORFUENTE),A
LD BC,1030
LD DE,TEXTOS+99     ;"MISILES"
CALL UNAFRASE

LD A,66
LD (COLORFUENTE),A
LD BC,1043
LD DE,TEXTOS+107    ;"PTOS"
CALL UNAFRASE

CALL PUNTUACION     ;PINTAMOS N DE MISILES Y PTOS


;*******************************************
; BUCLE JUEGO   *******************************************
;*******************************************


BUCLE_MISIL:



;//////////////////////////////////////////  LECTURA TECLADO

CALL LEER_TECLADO
CP 5
JR NZ,NO_ACTIVAS_DISPARO

   LD A,(ESPEJO+5)    ;DISPARO ACTIVADO 0/1
   CP 1
   JR Z,NO_ACTIVAS_DISPARO

   LD A,1
   LD (ESPEJO+5),A   ;ACTIVAMOS DISPARO

   LD A,(ESPEJO+3)   ;MISILES POR DISPARAR
   DEC A
   LD (ESPEJO+3),A
   CALL PUNTUACION

   LD A,135          ;COORDENADA Y INICIAL DISPARO
   LD (ESPEJO+10),A

NO_ACTIVAS_DISPARO:


;//////////////////////////////////////////  GESTIN DISPARO

LD A,(ESPEJO+5)
CP 0
JR Z,NO_HAY_DISPARO

             ;0 CONTADOR PARA QUE VAYA DESPACITOR

             LD A,(ESPEJO+6)
             INC A
             LD (ESPEJO+6),A
             CP 20
             JR NZ,NO_HAY_DISPARO

             XOR A
             LD (ESPEJO+6),A

             ;1BORRAMOS DISPARO ACTUAL

             CALL BORRAR_DISPARO_ACTUAL

             ;2DECREMENTAMOS COORDENADA
             LD A,(ESPEJO+10)
             DEC A
             LD (ESPEJO+10),A

             ;3 SI "Y" ES = 47 DESACTIVAR Y COMPROBAMOS QUE NO ERA LA LTIMA BALA
             CP 47
             JR NZ,NOTECHO
             XOR A
             LD (ESPEJO+5),A   ;DESACTIVAMOS DISPARO

             LD A,(ESPEJO+3)   ;COMPROBAMOS QUE NO ERA LA LTIMA BALA
             CP 0
             JR NZ,NO_HAY_DISPARO

             JP SIN_CARCHUTOS  ;SI ERA EL LTIMO VAMOS A VER SI HAS CONSEGUIDO OBJETIVO O NO...

             NOTECHO:

             ;4 PINTAR EL DISPARO
             
             LD B,A
             LD C,122
             CALL COLOCAR
             LD A,(HL)
             SET 5,A          ;ACTIVAMOS BIT 5
             LD (HL),A

             ;4 SONIDO????????????????????????


NO_HAY_DISPARO:


;//////////////////////////////////////////  GESTIN OBJETIVOS


LD IX,TABLA_MALOS_MISIL

LD B,4
KLIKLO:
PUSH BC

          ;CONTADOR VELOCIDAD
          LD A,(IX+3)
          INC A
          LD (IX+3),A
          LD B,(IX+4)
          CP B
          JR NZ,OTRO_BICHIN
          
          XOR A
          LD (IX+3),A

          ;ACTIVADO?
          LD A,(IX+2)
          CP 0
          JR NZ,SI_ACTIVADO_MALO

                ;ACTIVAR
                LD BC,250
                CALL LIMITE        ;A ENTRE 0 Y 249
                LD B,(IX+5)        ;PROBABILIDAD
                CP B
                JR NC,OTRO_BICHIN  ;NO ACTIVO

                LD A,(IX+1)        ;X INICIAL
                LD(IX+2),A         ;ACTIVADO

          SI_ACTIVADO_MALO:


          ;CONTADOR FRAMES
          CALL CONTADOR_DE_FRAMES_OBJETIVOS

          ;VARIACION X
          LD A,(IX+2)
          ADD A,(IX+9)
          LD (IX+2),A

                ;DESACTIVAR EN SU CASO Y BORRAR
                LD B,(IX+12)
                CP B
                JR NZ,NO_FIN_RECORRIDO
                XOR A
                LD(IX+2),A         ;DESACTIVADO

                LD B,(IX+0)        ;BORRAR
                LD C,(IX+12)
                LD A,(IX+6)
                LD HL,VACIO2X2+2
                CALL HR2X1B
                JR OTRO_BICHIN
                
                NO_FIN_RECORRIDO:

          ;DIBUJAR
          LD B,(IX+0)
          LD C,(IX+2)

          LD DE,MALOS_MISIL
          LD H,0
          LD A,(ESPEJO+15)
          LD L,(IX+7)
          ADD A,L
          LD L,A
          ADD HL,DE
          LD A,(IX+6)
          CALL HR2X1B

          ;ACIERTO?

          CALL LEDI

          OTRO_BICHIN:
          LD BC,11
          ADD IX,BC

POP BC
DJNZ KLIKLO





;HALT


JP BUCLE_MISIL








SALIMOS_MISIL:

LD A,136
LD (X),A
LD A,112
LD (Y),A
JP CARGAPANTALLA




;*******************************************
; RUTINILLAS MISIL   ***********************************
;*******************************************

;*******************************************
;*******************************************

PINTAR_TITULO:
LD A,66
LD (COLORFUENTE),A
LD BC,1291
LD DE,TEXTOS+72       ;"AIR BATTLE"
CALL UNAFRASE
RET

;*******************************************
;*******************************************

PUNTUACION:
;PINTAMOS N DE MISILES Y N DE PUNTOS
LD A,71
LD (COLORFUENTE),A
LD BC,1038
LD A,(ESPEJO+3)
CALL DOSNUMEROS

LD A,66
LD (COLORFUENTE),A
LD BC,1047
LD A,(ESPEJO+2)
CALL TRESNUMEROS
RET

;*******************************************
;*******************************************

CONTADOR_DE_FRAMES_OBJETIVOS:
;CONTADOR FRAMES DE LOS OBJETOS

          LD A,(IX+10)
          INC A
          LD (IX+10),A
          CP 10
          JR NZ,NOVARIA_FRAME_EN10

              XOR A
              LD (ESPEJO+15),A
              RET

          NOVARIA_FRAME_EN10:
          CP 20
          RET NZ

              XOR A
              LD (IX+10),A
              LD A,16
              LD (ESPEJO+15),A
              RET

;*******************************************
;*******************************************

LEDI:
;COMPROBAMOS ACIERTO

    ;COORDENADA X
    LD A,(IX+2)
    ADD A,2           ;A=XMALO+2
    SUB 111           ;RESTAMOS 111
    CP 12             ;COMPARAMOS CON 12 SI HAY C HAY ACIERTO EN EL EJE X
    RET NC            ;SI HAY NC NO HAY ACIERTO EN EL EJE X

    ;COORDENADA Y
    LD B,(IX+0)       ;Y DEL MALO
    LD A,(ESPEJO+10)  ;Y DEL BUENO
    SUB B             ;A=Y DEL BUENO-Y DEL MALO
    CP 7              ;COMPARAMOS CON 7 SI HAY C HAY ACIERTO EN EL EJE Y
    RET NC            ;SI HAY NC NO HAY ACIERTO EN EL EJE Y
    
    ACIERTO:

    ;SUBIMOS PUNTOS
    LD A,(ESPEJO+2)
    LD B,(IX+8)
    ADD A,B
    LD (ESPEJO+2),A
    CALL PUNTUACION

    ;COMPROBAMOS SI SUPERA LIMITE PARA MARCARLO Y FLASEARLO

    LD A,(ESPEJO+1)        ;PTOS PARA PASAR DE FASE
    LD B,A
    LD A,(ESPEJO+2)        ;PTOS ACTUALES
    CP B
    JR C,NO_CONSIGUES_OBJETIVO

    LD A,1                 ;OBJETIVO CONSEGUIDO
    LD (ESPEJO+4),A
    LD BC,4374
    LD DE,769
    LD A,150               ;FONDO ROJO, PINTURA AMARILLA, FLASH 1
    CALL COLOREA

    NO_CONSIGUES_OBJETIVO:

    ;EXPLOSION
    LD C,122
    LD A,(ESPEJO+10)
    LD B,A
    CALL EXPLOSION

    ;DESACTIVAMOS BALA
    CALL BORRAR_DISPARO_ACTUAL
    XOR A
    LD (ESPEJO+5),A
    LD (ESPEJO+10),A

    ;COMPROBAMOS QUE NO ERA LA LTIMA BALA
    LD A,(ESPEJO+3)
    CP 0
    JR NZ,NO_ULTIMO_CARCHUTO
    POP DE   ;(PARA ESQUIVAR LA SALIDA DE UN CALL SIN RET)
    JP SIN_CARCHUTOS
    NO_ULTIMO_CARCHUTO:

    ;VUELTA AL BUCLE PRINCIPAL ESQUIVANDO EL CALL
    POP DE   ;(PARA ESQUIVAR LA SALIDA DE UN CALL SIN RET)
    JP BUCLE_MISIL


;*******************************************
;*******************************************

;*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*//*/*/*/*/*/*/*/*/*/*/*/*/*/*
;RUTINA EXPLOSION
;ENTRADA "BC"    "YX"


EXPLOSION:
;1 CARGAMOS "MATRIZ EXPLOSION" SEGN LOS VALORES DE YX

PUSH BC                   ;YX(**)
LD HL,GUIA_EXPLOSION
LD DE,MATRIZ_EXPLOSION

LD A,8

CACOTA:
LD (JOKER4),A

POP BC                    ;YX(**)
PUSH BC                   ;YX(**)
LD A,(HL)
ADD A,B                   ;Y
LD (DE),A
INC HL
INC DE
LD A,(HL)
ADD A,C                   ;X
LD (DE),A
INC DE
INC DE
INC DE
INC HL


LD A,(JOKER4)
DEC A
JR NZ,CACOTA

POP BC                    ;YX(**)  PARA QUE NO PETE

;BUCLE DE PINTADO BORRADO

LD B,8        ;DISTANCIA EXPLOSIN
CAQUITA:
PUSH BC

LD IX,MATRIZ_EXPLOSION

      LD B,8
      CAQUILLA:
      PUSH BC

      ;PINTAMOS
      LD B,(IX+0)
      LD C,(IX+1)
      CALL COLOCAR     ;HL DIRECCION Y EN A BITPOSX (SIN VITPOSX)
      LD B,A
      ;INC B
      LD A,(HL)
      LD D,A
      LD A,128
      REVOGIRO:
      RRCA
      DJNZ REVOGIRO
      OR D	         ;JUNTAMOS ROTADO CON FONDO
      LD (HL),A          ;PINTAMOS

      LD A,(IX+0)        ;SUMAMOS A Y SU VARIACIN
      ADD A,(IX+2)
      LD (IX+0),A

      LD A,(IX+1)        ;SUMAMOS A X SU VARIACIN
      ADD A,(IX+3)
      LD (IX+1),A

      EXX                ;USAMOS REGISTROS ALTERNATIVOS
      CALL EFECTOGALOPE
      EXX

      ;BORRAMOS

      LD A,D
      LD (HL),A        ;PINTAMOS

      INC IX
      INC IX
      INC IX
      INC IX

      POP BC
      DJNZ CAQUILLA


POP BC
DJNZ CAQUITA
RET


GUIA_EXPLOSION:
DEFB   0,0,   0,1,   0,2,   1,0,  1,2,   2,0,   2,1,   2,2

MATRIZ_EXPLOSION:
DEFB   0,0,-2,-2,   0,0,-2,0,   0,0,-2,2,   0,0,0,-2,   0,0,0,2,   0,0,2,-2,   0,0,2,0,   0,0,2,2


;*******************************************
;*******************************************

BORRAR_DISPARO_ACTUAL:
;BORRAMOS BALA DISPARADA
LD A,(ESPEJO+10)
LD B,A
LD C,122
CALL COLOCAR
LD A,(HL)
RES 5,A          ;DESACTIVAMOS BIT 5
LD (HL),A
RET

;*******************************************
;*******************************************

SIN_CARCHUTOS:
;SIN BALAS, COMPROBAMOS OBJETIVO CONSEGUIDO O NO

     CALL CELESEJUEGO
     CALL PINTAR_TITULO

LD A,(ESPEJO+4)
CP 1
JR Z,ANDA_SI

     ANDA_NO:         ;NO HAS CONSEGUIDO PUNTUACIN NECESARIA

     LD BC,2315
     LD A,67
     LD (COLORFUENTE),A
     LD DE,TEXTOS+111   ;"GAME OVER"
     CALL UNAFRASE

     LD BC,3337
     LD A,71
     LD (COLORFUENTE),A
     LD DE,TEXTOS+122   ;"LO INTENTAMOS?"
     CALL UNAFRASE

     LD BC,3854
     LD A,69
     LD (COLORFUENTE),A
     LD DE,TEXTOS+137   ;"S  N"
     CALL UNAFRASE

     CALL ESPERATECLA

     ;ESTAMOS AQUI, FORZANDO MAYUSCULAS....
     ;LD A,(23658)
     ;SET 3,A               ;FORZAMOS MAYUSCULAS
     ;LD (23658),A

     RIDIELA:
     LD A,(23560)          ;LAST K
     CP 91
       JR C,KLUIKLUI       ;EN VEZ DE FORZAR MAYSCULAS RESTO 32 AL ASCCI SI VEO QUE SON MINUSCULAS, GANO ESPACIO Y RAPIDEZ.
     SUB 32
     KLUIKLUI:
     CP 78                 ;"N"
     JP Z,SALIMOS_MISIL    ;SALIMOS SIN NADA
     CP 83                 ;"S"  EN INGLS "Y" ES LA 89
     JP Z,MISIL2           ;REPETIMOS EL JUEGO
     JR RIDIELA

     ANDA_SI:         ;SI HAS CONSEGUIDO PUNTUACION NECESARIA

     ;COMPROBAMOS SI ES FINAL DEL JUEGO
     LD A,(ESPEJO+0)   ;FASE
     CP 4
     JR Z,VICTORIA_MISIL

     ;SI NO LO ES SUBIMOS FASE Y LANZAMOS OTRA VEZ

     INC A
     LD (ESPEJO+0),A
     JP FASE_MISIL

     VICTORIA_MISIL:

     LD BC,2315
     LD A,71
     LD (COLORFUENTE),A
     LD DE,TEXTOS+142      ;"VICTORIA !"
     CALL UNAFRASE

     CALL DEDESTADO2               ;PINTURA ROSA O VIDA EXTRA SNAKE
     LD BC,3343
     LD A,255
     CALL DIBUJA

     CALL EFECTO4
     CALL EFECTO7
     CALL EFECTO2

     LD A,(ESTADOS+2)
     CP 0
     JR Z,SALIR_MISIL_PINTURAROSA

     SALIR_MISIL_VIDAEXTRA:
     
     CALL INCREMENTA_VIDA_SNAKE
     JP SALIMOS_MISIL

     SALIR_MISIL_PINTURAROSA:

     LD A,1
     LD (ESTADOS+2),A

     CALL ESPERATECLA
     LD A,14
     CALL METE_INVENTARIO    ; Y METEMOS EN INVENTARIO PINTURA ROSA

     JP SALIMOS_MISIL


;*******************************************
;*******************************************

DEDESTADO2:
;PONEMOS EN "DE" DIRECCION DE PINTURA ROSA O ED VIDA EXTRA SNAKE SEGUN VALOR ESTADO+2

LD A,(ESTADOS+2)      ;PINTURA ROSA COGIDA (0 NO 1 SI)
CP 0
JR Z, TRETREW

LD DE,VIDA_EXTRA+38
RET

TRETREW:
LD DE,TARRO+494    ;PINTURA ROSA
RET


;*******************************************
; TABLAS MISIL   *******************************************
;*******************************************

PTOS_OBJETIVO:
DEFB 0,50,65,85,100

TABLA_MALOS_MISIL:
DEFB  48,40,0,0,   20,2,6,0,20,1,15
DEFB  64,200,0,0,  25,4,15,32,15,-1,15
DEFB  88,40,0,0,   30,6,42,64,10,1,15
DEFB  112,200,0,0, 35,8,48,96,5,-1,15


DEFB  0,40




;*******************************************
; SPRITES MISIL   *******************************************
;*******************************************

CUADRO_LIMPIO:
DEFB  1,1, 255,129,129,129,129,129,129,255,  71
CUADRO_TACHAO:
DEFB  1,1, 255,195,165,153,153,165,195,255,  66
LANZADERA:
DEFB  32,32,32,32,118,118,255,0
FILIGRANA_I:
DEFB  15,28,24,240,240,24,28,15
FILIGRANA_D:
DEFB  240,56,24,15,15,24,56,240

ROCKET:      ;MISIL DIBUJITO INTRODUCCION JUEGO
DEFB  2,3, 1,0,3,128,3,128,7,192,0,0,7,192,7,192,1,64,7,192,7,64,3,64,7,64,23,80,23,88,55,216,115,156,1,0,1,128,2,128,5,192,2,128,5,80,0,128,10,32,  71,5,71,5,66,2

MALOS_MISIL:
DEFB  3,224,4,16,8,72,8,40,8,40,31,252,53,86,31,252          ;+0   OVNI
DEFB  3,224,4,16,9,8,10,8,10,8,31,252,58,174,31,252          ;+16
DEFB  0,0,6,132,12,12,127,252,255,252,12,0,6,36,0,0          ;+32  AVION
DEFB  0,0,6,68,12,12,127,252,255,252,12,0,6,160,0,0          ;+48
DEFB  15,254,32,160,51,248,63,132,38,226,3,254,1,16,7,252    ;+64  HELICOPTERO
DEFB  3,248,32,160,51,248,63,132,38,226,3,254,1,16,7,252     ;+80
DEFB  0,40,0,80,0,160,0,84,13,168,23,92,13,248,0,240         ;+96  PAJARO
DEFB  0,0,0,0,0,244,13,184,23,84,13,168,0,80,0,8             ;+112

