;-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
;-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
;-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
;-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
; RUTINAS II JBGV
;-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
;-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
;-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
;-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

; 1-  DEFINICIN DE TECLAS Y LECTURA TECLADO
; 2-  CARGATABLAS
; 3-  INVERSO
; 4-  CARGAPANTALLA
; 5-  MUERTES E INCREMENTOS VIDAS
; 6-  CARGAFONDOS ANIMADOS
; 7-  CARGA EVENTOS
; 8-  COPIYUPI @ COPITRANS
; 9-  PINTAR SEGN ESTADOS  + AUXILIAR ESTADOS
; 10- MARCOS
; 11- ESCROLES
; 12- ANIMACIONES RUTINAS
; 13- ANIMACIONES HISTORIA

;++++++++++++++++++++++
;++++++++++++++++++++++
; 1-  DEFINICIN DE TECLAS Y LECTURA TECLADO
;++++++++++++++++++++++
;++++++++++++++++++++++

;AL FINAL NO LO IMPLEMENTO EN JOURNEY TO ANOTHER WORLD

;***********************************
;Find_Key
;***********************************
;DEL CURSO DE COMPILER WN WIKI DE SPECCY.ORG, RUTINAS DE "DAVID WEBB"
; Devuelve un cdigo en el registro D que indica:
;;
;  Bits 0, 1 y 2 de "D": Fila de teclas (puerto) detectada.
;  Bits 3, 4 y 5 de "D": Posicin de la tecla en esa media fila
;;
; El registro D valdr 255 ($FF) si no hay ninguna tecla pulsada.
;;
;Flags: ZF desactivado: Ms de una tecla pulsada
;       ZF activado: Tecla correctamente leda

;Find_Key:

;CALL ESPERATECLA

;LD DE, $FF2F ; Valor inicial "ninguna tecla"
;LD BC, $FEFE ; Puerto
;NXHALF:
;IN A, (C)
;CPL
;AND $1F
;JR Z, NPRESS ; Saltar si ninguna tecla pulsada
;INC D ; Comprobamos si hay ms de 1 tecla pulsada
;RET NZ ; Si es as volver con Z a 0
;LD H, A ; Clculo del valor de la tecla
;LD A, E
;KLOOP:
;SUB 8
;SRL H
;JR NC, KLOOP
;RET NZ ; Comprobar si ms de una tecla pulsada
;LD D, A ; Guardar valor de tecla en D
;NPRESS: ; Comprobar el resto de semifilas
;DEC E
;RLC B
;JR C, NXHALF ; Repetimos escaneo para otra semifila
;CP A ; Ponemos flag a zero
;RET Z ; Volvemos

;***********************************
;Check_Key
;***********************************
;DEL CURSO DE COMPILER WN WIKI DE SPECCY.ORG, RUTINAS DE "DAVID WEBB"
; Chequea el estado de una tecla concreta, aquella de scancode
; codificado en A (como parametro de entrada).
;;
;Devuelve: CARRY FLAG = 0 -> Tecla pulsada
; CARRY FLAG = 1 y BC = 0 -> Tecla no pulsada

;Check_Key:
;LD C, A ; Copia de A
;AND 7
;INC A
;LD B, A ; B = 16 - (num. linea direccin)
;SRL C
;SRL C
;SRL C
;LD A, 5
;SUB C
;LD C, A ; C = (semifila + 1)
;LD A, $FE
;CKHiFind: ; Calcular el octeto de mayor peso del puerto
;RRCA
;DJNZ CKHiFind
;IN A, ($FE) ; Leemos la semifila
;CKNXKey:
;RRA
;DEC C
;JR NZ, CKNXKey ; Ponemos el bit de tecla en el CF
;RET

;***********************************
;LEER_TECLADO
;***********************************

;LEE TECLAS Y JOYSTICK, SALIDA "PULSACION" Y A CON VALORES:
;     0  NADA
;     1  ARRIBA
;     2  ABAJO
;     3  DERECHA
;     4  IZQUIERDA
;     5  ACCION

;LEER_TECLADO:

;XOR A
;LD (PULSACION),A        ;SI NO HAY PULSACION NO HACEMOS NADA

;LECTURA DE JOYSTICK "KEMPSTON" Jonathan Cauldwell
;LD A,(KEMPSTON)
;CP 0
;JR Z,TECLA_IZQUIERDA


;       ld bc,31            ; Kempston joystick port.

;       in a,(c)            ; read input.
;       and 2               ; check "left" bit.
;       JR nz,K4            ; move left.

;       in a,(c)            ; read input.
;       and 1               ; test "right" bit.
;       JR nz,K3            ; move right.

;       in a,(c)            ; read input.
;       and 8               ; check "up" bit.
;       JR nz,K1            ; move up.

;       in a,(c)            ; read input.
;       and 4               ; check "down" bit.
;       JR nz,K2            ; move down.

;       in a,(c)            ; read input.
;       and 16              ; try the fire bit.
;       JR nz,K5            ; fire pressed.

;       JR FIN_LECTURA


;LECTURA DEL TECLADO Y JOYSTICK SINCLAIR

;TECLA_IZQUIERDA:
;LD A, (TECLA_O)
;CALL Check_Key
;JR C, TECLA_DERECHA     ; Carry = 1, tecla no pulsada
;(acciones a realizar si se pulso izq)
;K4:
;LD A,4
;JR FIN_LECTURA


;TECLA_DERECHA:
;LD A, (TECLA_P)
;CALL Check_Key
;JR C, TECLA_ARRIBA ; Carry = 1, tecla no pulsada
;(acciones a realizar si se pulso der)
;K3:
;LD A,3
;JR FIN_LECTURA


;TECLA_ARRIBA:
;LD A, (TECLA_Q)
;CALL Check_Key
;JR C, TECLA_ABAJO ; Carry = 1, tecla no pulsada
;(acciones a realizar si se pulso arriba)
;K1:
;LD A,1
;JR FIN_LECTURA


;TECLA_ABAJO:
;LD A, (TECLA_A)
;CALL Check_Key
;JR C, TECLA_ACCION ; Carry = 1, tecla no pulsada
;;(acciones a realizar si se pulso abajo)
;K2:
;LD A,2
;JR FIN_LECTURA


;TECLA_ACCION:
;LD A, (TECLA_M)
;CALL Check_Key
;JR C, FIN_LECTURA ; Carry = 1, tecla no pulsada
;(acciones a realizar si se pulso accion)
;K5:
;LD A,5

;FIN_LECTURA:
;LD (PULSACION),A     ;LA GUARDO POR SI ACASO LUEGO LA NECESITO .............. SI NO BORRAR 
;RET

LEER_TECLADO:


TECLAO:

       LD BC, $DFFE         ; SEMIFILA Y - P
       IN A, (C)            ; LEER PUERTO
       BIT 1, A             ; COMPROBAR BIT 1 "O"
       JR NZ, TECLAP        ; SI NO EST PULSADO VAMOS A TECLA "P"
       ;HAS PULSADO "O" ENTONCES:
       LD A,4
       JR FIN_LECTURA

TECLAP:

       LD BC, $DFFE         ; SEMIFILA Y - P
       IN A, (C)            ; LEER PUERTO
       BIT 0, A             ; COMPROBAR BIT 0 "P"
       JR NZ, TECLAQ        ; SI NO EST PULSADO VAMOS A TECLA "Q"
       ;HAS PULSADO "P" ENTONCES:
       LD A,3
       JR FIN_LECTURA

TECLAQ:

       LD BC, $FBFE         ; SEMIFILA T - Q
       IN A, (C)            ; LEER PUERTO
       BIT 0, A             ; COMPROBAR BIT 0 "Q"
       JR NZ, TECLAA        ; SI NO EST PULSADO VAMOS A TECLA "A"
       ;HAS PULSADO "Q", ENTONCES:
       LD A,1
       JR FIN_LECTURA

TECLAA:

       LD BC, $FDFE         ; SEMIFILA G - A
       IN A, (C)            ; LEER PUERTO
       BIT 0, A             ; COMPROBAR BIT 0 "A"
       JR NZ, TECLAM        ; SI NO EST PULSADO VAMOS A TECLA "M"
       ;HAS PULSADO "A", ENTONCES:
       LD A,2
       JR FIN_LECTURA

TECLAM:

       LD BC, $7FFE         ; SEMIFILA B - SPACE
       IN A, (C)            ; LEER PUERTO
       BIT 2, A             ; COMPROBAR BIT 3 "M"
       JR NZ, NO_PULSACION  ; SI NO EST PULSADO VAMOS A NO_PULSACION
       ;HAS PULSADO "M", ENTONCES:
       LD A,5
       JR FIN_LECTURA

NO_PULSACION:

       XOR A

FIN_LECTURA:
LD (PULSACION),A        ;LA GUARDO POR SI ACASO LUEGO LA NECESITO .............. SI NO BORRAR 
RET

;++++++++++++++++++++++
;++++++++++++++++++++++
; 2- CARGATABLAS
;++++++++++++++++++++++
;++++++++++++++++++++++

;CARGAGUARDIANES:

;CARGA_LATABLA:

     ;SI (HL)=255 HEMOS ACABADO --------------------------------------
;     LD A,(HL)
;     LD B,A
;     CP 255
;     RET Z

     ;COMPARAMOS 1VALOR CON VALOR PANTALLA -------------------------------
;     LD A,(PANTALLA)
;     CP B
;     JP NZ,SIGUIENTEPANDA

     ;SI COINCIDE CON PANTALLA, CARGAMOS VALORES ---------

;     INC HL               ;ORIGEN
     ;LD DE,MALVADOS      ;DESTINO
;     LD BC,8              ;TAMAO
;     LDIR                 ;COPIAR

     ;"HL" SALE EN SIGUIENTE TANDA
     ;"DE" NO PORQUE ME SALTO DOS BITS PARA AVANCE Y CONTADOR Y SENTIDO
;     INC DE
;     INC DE
;     INC DE
;     JR CARGA_LATABLA

;SIGUIENTEPANDA:

;LD BC,9
;ADD HL,BC
;JR CARGA_LATABLA


;++++++++++++++++++++++
;++++++++++++++++++++++
; 3- INVERSO
;++++++++++++++++++++++
;++++++++++++++++++++++

;OBTENEMOS EN "ESPEJO" UN SPRITE ROTADO, USAMOS "INVERSO" PARA OBTENER DATOS TAMAO PARA RUTINA "DIBUJA", E "INVERSA" PARA SLO DATOS RUTINAS HR 2X2
;ENTRADA EN HL LA DIRECCIN DEL SPRITE A ROTAR
;SALIDA EN "ESPEJO" EL SPRITE ROTADO

INVERSA:

LD DE, ESPEJO-1
LD A,2
LD (GUDAR),A
LD (JOKER),A
LD B,A
LD A,32         ;MALOS SON DOS ESPRITES
JR SUMOLAR

INVERSO:

LD DE, ESPEJO
LD A,(HL)         ;ANCHO EN CARACTERES
LD B,A            ;ANCHO B PARA PRIMER BUCLE
LD (JOKER),A
LD (DE),A
INC DE
INC HL
LD A,(HL)         ;BAJO EN CARACTERES
LD (GUDAR),A
LD (DE),A         ;GRABAMOS LOS DOS VALORES DEL TAMAO DEL SPRITE PARA RUTINA "DIBUJA"
SLA A
SLA A
SLA A             ;A=BAJO EN SCANLINES
INC HL

SUMOLAR:          ;(*) B=ANCHO EN CARACTERES
INC DE
DJNZ SUMOLAR      ;INCREMENTAMOS LA DIRECCION DE INVERSO AL FINAL DEL LARGO

   LD B,A         ;BUCLE SCANLINE
   BUCLEBAR:
   PUSH BC

   LD A,(JOKER)   ;BUCLE ANCHO
   LD B,A
   BUCLELAR:
   PUSH BC

   LD C, (HL)       ;CARGO HL CON DATO BYTE ORIGEN Y LO PONGO EN "C"

   XOR A            ; PONGO A CERO QUE ES DONDE VOY A GUARDAR EL BYTE ROTADO

   LD B,8
   VOLTEANDO:
   RL   C           ;Rotacin a la IZQUIERDA de BYTE ORIGEN EL 7 BIT PASA TOO A ACARREO
   RRA              ;Rotacin a la DERECHA de "A" ALIMENTNDOLO CON EL ACARREO Y YA EST
   DJNZ VOLTEANDO

   LD (DE),A

   INC HL
   DEC DE

   POP BC
   DJNZ BUCLELAR

   LD A,(JOKER)
   LD B,A
   SLA  B        ;CARGAMOS B CON EL DOBLE DE LAR
   SUMOLAR2:
   INC DE
   DJNZ SUMOLAR2      ;INCREMENTAMOS LA DIRECCION DE INVERSO AL FINAL DEL LARGO

   POP BC
   DJNZ BUCLEBAR

;ATRIBUTOS       ;COMO MXIMO SON 4X4 PONGO 16 Y ME AHORRO MULTIPLICACIN


   LD A,(GUDAR)
   LD B,A
   AYAYAIS:
   PUSH BC

   LD A,(JOKER)
   LD B,A
   AYAYAYAI:
   LD A,(HL)
   LD (DE),A
   INC HL
   DEC DE
   DJNZ AYAYAYAI

   LD A,(JOKER)
   LD B,A
   SLA  B        ;CARGAMOS B CON EL DOBLE DE LAR
   SUMOLAR3:
   INC DE
   DJNZ SUMOLAR3      ;INCREMENTAMOS LA DIRECCION DE INVERSO AL FINAL DEL LARGO

   POP BC
   DJNZ AYAYAIS

RET


;++++++++++++++++++++++
;++++++++++++++++++++++
; 4- CARGAPANTALLAS
;++++++++++++++++++++++
;++++++++++++++++++++++


;=================================================================================

NILAMANTAPORCALOR:             ;1 HACEMOS LA SUMA DE MAPA HASTA PANTALLA-1
LD DE,PUNTERO_MAPAX
LD HL,0
LD A,(PANTALLA)
  TRUCO_CONTADOR_FRASES:
DEC A
LD B,A
CP 0                           ;SI PANTALLA=1 HL A SUMAR A FASE ES CERO
RET Z
  WUCLE:
  PUSH BC
      LD A,(DE)
      LD B,0
      LD C,A
      ADD HL,BC
      INC DE
  POP BC
  DJNZ WUCLE                   ;HL=VALOR A SUMAR A LA BASE DEL MAPA PARA OBTENER PRIMER VALOR DEL MAPA
RET

;=================================================================================

;ENTRADA "A", OBJETO
;OBTENEMOS EN "HL" LA DIRECCIN DEL ESPRITE INDEXADO EN "OBJETOX" (O SU INVERSA) Y EN "JOKER3" EL COLOR

QUEOBJETOES:

CALL SELECCION_OBJETO

   LD A,(IX+2)
   CALL SACADIM

     LD A,D              ;COLOR
     CP 0
     JR Z,RIMBOMBANTE
     CP 8
     JR Z,RIMBOMBANTE_BIS
     ADD A,64
     JR RIMBOMBANTE2
  RIMBOMBANTE:
     LD A,255
     JR RIMBOMBANTE2
  RIMBOMBANTE_BIS:
     LD A,254
  RIMBOMBANTE2:
     LD (JOKER3),A

     LD A,E              ;INVERSA?
     CP 0
     RET Z

     CALL INVERSO
     LD HL,ESPEJO

RET




;=================================================================================
SELECCION_OBJETO:
   LD DE, TABLAOBJETO            ;BASE DE LA TABLA CON EL TAMAO DE CADA OBJETO
   LD HL,OBJETOX
   CP 150                           ;EN "A" EST EL N DE OBJETO
   JR Z,FINESCOGEOBJETO             ;SI OBJETO=150, HL YA EST BIEN.
   SUB 150
   LD B,A
 CARCAMUSERO:
   PUSH BC

   LD A,(DE)
   LD B,0
   LD C,A
   ADD HL,BC
   INC DE                           ;HL=1 BITE DEL OBJETO

   POP BC
 DJNZ CARCAMUSERO

 FINESCOGEOBJETO:

   ;AQUI YA TENGO EL HL DEL OBJETO
RET

;=================================================================================

PINTAPANTALLA:

; EN HL ENTRA EL PRIMER VALOR DE LA PANTALLA

INICIOPINTAR:

PUSH HL       ;CONSERVAMOS EN PILA HL -------------------------------------------------------------------------------------------------------***
PUSH HL
POP IX        ;INDEXAMOS PANTALLA

LD A,(IX)
CP 255        ;SI VALOR =255 HEMOS TERMINADO, ES LA NICA FORMA DE SALIR DE PINTAPANTALLA
JR NZ,PLASTI
POP HL        ;QUE NO PETE LA PILA AL SALIR
RET
PLASTI:

;********************************************************************************************************
;COLOREAR UNA ZONA  (0 -   )
;********************************************************************************************************

PP_COLOREAR:
CP 0
JR NZ,PP_LINEASHV

CALL AUXILIAR_COORDENADAS   ;OBTENEMOS COORDENADAS Y/X EN BC
LD D,(IX+2)
LD E,(IX+3)
LD A,(IX+4)
CALL COLOREA
POP HL        ;SACAMOS DE LA PILA HL -------------------------------------------------------------------------------------------------------***
LD BC,5       ;APARTIR DE 4 (INCLUIDO) YA COMPENSA FRENTE A LOS INC HL
ADD HL,BC
JR INICIOPINTAR


;********************************************************************************************************
;LINEAS 2X2 HORIZONTALES O VERTICALES  (1 - 25)
;********************************************************************************************************
PP_LINEASHV:
CP 26
JR NC,PP_ZONAS2x2

   LD DE,38
   LD A,(IX)
   DEC A
   CALL Mul8      ;MULTIPLICACIN    HL=38*TIPO
   LD DE,VACIO2X2
   ADD HL,DE      ;SPRITE EN HL

   LD A,(IX+1)
   CALL SACADIM   ;DEVUELVE EN "D" LOCALIZACION  y EN "E" HORIZONTAL 1 / VERTICAL 2
   LD A,E
   CP 2
   JR Z,VERTICAL2X2

 HORIZONTAL2X2:
   LD C,5
   LD A,D
   ADD A,3
   LD B,A
   LD D,11
   LD E,1
   JR YAPINTAMOS2X2

 VERTICAL2X2:
   LD A,D
   SLA A
   ADD A,5          ;A=(A*2)+5
   LD C,A
   LD B,3
   LD D,1
   LD E,8
   JR YAPINTAMOS2X2

   YAPINTAMOS2X2: ;----- COMUN ATRIBUTO HORIZONTAL Y VERTICAL

   LD A,255       ;ATRIBUTOS EN DEFB

   CALL RELLENA2D

   POP HL        ;SACAMOS DE LA PILA HL -------------------------------------------------------------------------------------------------------***
   INC HL
   INC HL
   JP INICIOPINTAR



;********************************************************************************************************
;ZONAS 2X2   (26-50)
;********************************************************************************************************
PP_ZONAS2x2:
CP 51
JR NC,PP_ZONAS2x2INV

LD A,(IX+2)
CALL SACADIM
PUSH DE

LD A,(IX)
SUB 26
LD DE,38
CALL Mul8      ;MULTIPLICACIN    HL=38*TIPO
LD DE,VACIO2X2
ADD HL,DE      ;SPRITE EN HL

ESLOPISPO:       ;USAMOS PARA ZONAS INVERSAS EL MISMO TROZITO DE CDIGO

CALL AUXILIAR_COORDENADAS   ;OBTENEMOS COORDENADAS Y/X

POP DE

LD A,255

CALL RELLENA2D

FINZONAS:

POP HL        ;SACAMOS DE LA PILA HL -------------------------------------------------------------------------------------------------------***
INC HL
INC HL
INC HL
JP INICIOPINTAR


;********************************************************************************************************
;ZONAS 2X2 INVERSAS   (51-75)
;********************************************************************************************************
PP_ZONAS2x2INV:
CP 76
JR NC,PP_ZONAS1X1

LD A,(IX+2)
CALL SACADIM
PUSH DE

LD A,(IX)
SUB 51
LD DE,38
CALL Mul8      ;MULTIPLICACIN    HL=38*TIPO
LD DE,VACIO2X2
ADD HL,DE      ;SPRITE EN HL

CALL INVERSO
LD HL,ESPEJO
JR ESLOPISPO


;********************************************************************************************************
;ZONAS 1X1    (76-99)
;********************************************************************************************************
PP_ZONAS1X1:

CP 100
JR NC,PP_COMBOS

LD A,(HL)
SUB 76
SLA A
SLA A
SLA A  ;X8
LD D,0
LD E,A
LD HL, VACIO1X1
ADD HL,DE

CALL AUXILIAR_COORDENADAS   ;OBTENEMOS COORDENADAS Y/X
PUSH BC

LD A,(IX+2)
CALL SACADIM

POP BC

LD A,(IX+3)

CALL RELLENA

POP HL        ;SACAMOS DE LA PILA HL -------------------------------------------------------------------------------------------------------***
LD BC,4       ;APARTIR DE 4 (INCLUIDO) YA COMPENSA FRENTE A LOS INC HL
ADD HL,BC
JP INICIOPINTAR



;********************************************************************************************************
;COMBOS  (100-129)
;********************************************************************************************************
PP_COMBOS:
CP 130
JP NC,ELEFANTES


	LD HL,COMBOJETOS		;ORIGEN BUSQUEDA
	LD BC, 59		        ;N DE BYTES A BUSCAR      ACTUALIZARLO 
	LD A,(IX+0)		        ;VALOR A BUSCAR
	CPIR		                ;BUSCAR (SIEMPRE ENCONTRAR)	-> HL YA EN DIRECCIN CORRECTA DE TABLA COMBOJETOS, EN VALOR DISPOSICION

        CALL AUXILIAR_COORDENADAS       ;OBTENEMOS COORDENADAS B=Y/C=X
        LD A,B                          ;LAS GUARDAMOS EN JOKER3 Y JOKER4
        LD (JOKER3),A
        LD A,C
        LD (JOKER4),A

	LD D,0
	LD E,(HL)
	LD IX,COMBOCOLOCA
	ADD IX,DE		        ;COLOCAMOS IX EN LUGAR CORRECTO SEGN LA DISTRIBUCIN DEL COMBO, OJO IX YA NO ES CODIGO MAPAX



    GUALKITOLKI:

        INC HL
        LD A,(HL)
        CP 255
        JR Z,FINCOMBO

        PUSH HL

        LD A,(HL)                       ;CARGAMOS OBJETO A PINTAR
        CALL SELECCION_OBJETO           ;OBTENEMOS EN "HL" LA DIRECCIN DEL ESPRITE INDEXADO EN "OBJETOX"

        LD A,(JOKER3)
        LD B,(IX+0)
        ADD A,B
        LD B,A
        LD (JOKER3),A

        LD A,(JOKER4)
        LD C,(IX+1)
        ADD A,C
        LD C,A
        LD (JOKER4),A

        EX DE,HL
        LD A,255
        CALL DIBUJA

       INC IX
       INC IX
       POP HL

    JR GUALKITOLKI



FINCOMBO:
POP HL        ;SACAMOS DE LA PILA HL -------------------------------------------------------------------------------------------------------***
INC HL
INC HL
JP INICIOPINTAR


;********************************************************************************************************
;ELEFANTES  (130-131)
;********************************************************************************************************
ELEFANTES:
CP 132
JP NC,PP_ZONAS1X1_SINCOMP

CALL AUXILIAR_COORDENADAS   ;OBTENEMOS COORDENADAS Y/X EN BC

LD A,(IX+0)                 ;COLOR 130=SECO  COLOR 130=EN EL AGUA
CP 130
JR NZ,MOJADO
LD A,71
JR FINMOJADO
MOJADO:
LD A,79
FINMOJADO:

LD HL,OLIFANTE
LD D,0
LD E,(IX+2)
ADD HL,DE
EX DE,HL

CALL DIBUJA

POP HL        ;SACAMOS DE LA PILA HL -------------------------------------------------------------------------------------------------------***
INC HL
INC HL
INC HL
JP INICIOPINTAR


;********************************************************************************************************
;1X1 SIN COMPRIMIR (132-137)
;********************************************************************************************************
PP_ZONAS1X1_SINCOMP:
CP 138
JR NC,SIN_DETERMINAR


LD A,(HL)
SUB 132
SLA A
SLA A
SLA A  ;X8
LD D,0
LD E,A
LD HL, VACIO1X1+48
ADD HL,DE

LD B,(IX+1)
LD C,(IX+2)
LD D,(IX+3)
LD E,(IX+4)
LD A,(IX+5)

CALL RELLENA

POP HL        ;SACAMOS DE LA PILA HL -------------------------------------------------------------------------------------------------------***
LD BC,6       ;APARTIR DE 4 (INCLUIDO) YA COMPENSA FRENTE A LOS INC HL
ADD HL,BC
JP INICIOPINTAR

;********************************************************************************************************
;SIN DETERMINAR (138-149)
;********************************************************************************************************
SIN_DETERMINAR:



;********************************************************************************************************
;OBJETOS SUELTOS  (150 EN ADELANTE)
;********************************************************************************************************
OBJETOSUELTO:

LD A,(IX)
CALL QUEOBJETOES     ;OBTENEMOS EN HL SPRITE CORRECTO (INVERTIDO O NO) Y EN JOKER3 EL COLOR

CALL AUXILIAR_COORDENADAS   ;OBTENEMOS COORDENADAS Y/X EN BC

LD A,(JOKER3)
EX DE,HL      ;ESPRITE EN "DE"
CALL DIBUJA

POP HL        ;SACAMOS DE LA PILA HL -------------------------------------------------------------------------------------------------------***
INC HL
INC HL
INC HL
JP INICIOPINTAR



;********************************************************************************************************
;FIN PINTAR OTRA VUELTA
;********************************************************************************************************
SIGUIENTEDATO:

JP INICIOPINTAR



;******* RUTINA IGUAL EN VARIOS BLOQUES

AUXILIAR_COORDENADAS:

LD A,(IX+1)
CALL SACADIM
LD A,D
ADD A,3
LD B,A        ;Y=Y+3
LD A,E
SLA A
ADD A,5
LD C,A        ;X=X*2+5

RET



;++++++++++++++++++++++
;++++++++++++++++++++++
; 5-  MUERTES E INCREMENTOS VIDAS
;++++++++++++++++++++++
;++++++++++++++++++++++


;*+*+*+*+*+*+*+*+**+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*
MUERTE_PARCIAL:     ;(DEL JUEGO PRINCIPAL)

;EFECTO
CALL EFECTO_CAGADA

;QUITAMOS Y PINTAMOS VIDA

LD A,(VIDAS)
DEC A
LD (VIDAS),A
CP 0
JR Z,MUERTE_TOTAL

CALL PINTA_VIDA_PRINCIPAL

;COORDENADAS RESURRECCION
LD A,(PANTALLA)
LD B,A
LD HL,BIBEN

PAYAVOY:
LD A,(HL)
CP B
JR NZ,OTRASIGUE

   INC HL
   LD A,(HL)
   LD (X),A
   INC HL
   LD A,(HL)
   LD (Y),A
   JP CARGAPANTALLA      ;EN JUEGO PRINCIPAL SOLO PUEDO MORIR EN PANTALLAS CON MALOS

OTRASIGUE:
INC HL
INC HL
INC HL
JR PAYAVOY

;*+*+*+*+*+*+*+*+**+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*
MUERTE_TOTAL:     ;(DEL JUEGO PRINCIPAL-SNAKE-HORACE, ES LA MISMA PARA TODOS)

CALL PANTALLA_MUERTE    ;LEON + GAME OVER

;AQUI PONER MUSIQUITA
CALL ESPERATECLA
JP MENU_PRINCIPAL


;*+*+*+*+*+*+*+*+**+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*
INCREMENTA_VIDA_FROG:
LD A,(VIDAS_HORACE)
INC A
CP 10
RET Z
LD (VIDAS_HORACE),A
CALL PINTA_VIDA_FROG
RET

;*+*+*+*+*+*+*+*+**+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*
INCREMENTA_VIDA_SNAKE:
LD A,(VIDAS_SNAKE)
INC A
CP 10
RET Z
LD (VIDAS_SNAKE),A
CALL PINTA_VIDA_SNAKE
RET
;*+*+*+*+*+*+*+*+**+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*
INCREMENTA_VIDA_PRINCIPAL:
LD A,(VIDAS)
INC A
LD (VIDAS),A
CALL PINTA_VIDA_PRINCIPAL
RET

;*+*+*+*+*+*+*+*+**+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*
PINTA_VIDA_PRINCIPAL:
LD C,1          ;X
CALL BORRA_VIDAX
LD C,1          ;X
LD A,(VIDAS)
LD E,A          ;BAJO
LD B,A
LD A,17
SUB B
LD B,A          ;Y
LD A,71         ;COLOR
JR PINTA_VIDAX

PINTA_VIDA_SNAKE:
LD C,2          ;X
CALL BORRA_VIDAX
LD C,2          ;X
LD A,(VIDAS_SNAKE)
LD E,A          ;BAJO
LD B,A
LD A,17
SUB B
LD B,A          ;Y
LD A,68         ;COLOR
JR PINTA_VIDAX

PINTA_VIDA_FROG:
LD C,3          ;X
CALL BORRA_VIDAX
LD C,3          ;X
LD A,(VIDAS_HORACE)
LD E,A          ;BAJO
LD B,A
LD A,17
SUB B
LD B,A          ;Y
LD A,70         ;COLOR

PINTA_VIDAX:
LD D,1
LD HL,VIDAX
CALL RELLENA
RET

BORRA_VIDAX:
LD B,7            ;Y
LD DE,266
LD A,0
LD HL,VACIO1X1
CALL RELLENA
RET

;*+*+*+*+*+*+*+*+**+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*



;++++++++++++++++++++++
;++++++++++++++++++++++
; 6-  CARGAFONDOS ANIMADOS
;++++++++++++++++++++++
;++++++++++++++++++++++

CARGAFONDOS:

        LD HL,TABLA_FONDOS

CARGA_ELFONDO:

        ;SI (HL)=255 HEMOS ACABADO --------------------------------------
        LD A,(HL)
        LD B,A
        CP 255
        RET Z

        ;COMPARAMOS 1VALOR CON VALOR PANTALLA -------------------------------
        LD A,(PANTALLA)
        CP B
        JP NZ,SIGUIENTEMANDA

        ;SI COINCIDE CON PANTALLA, CARGAMOS VALORES ---------
        PUSH HL
        POP IX
        LD HL,FONDITO

           LD A,(IX+1)        ;1 DATO
           CALL SACADIM
           LD A,D
           ADD A,3            ;AJUSTO LA COORDENADA Y
           LD (HL),A
           LD A,E
           CP 0
           JR Z,LESGOU
           CP 8
           JR NZ,NOLESGOU
           LD A,77            ;EN ESTE CASO FONDO BLUE TINTA CYAN
           JR NOLESGOU
           LESGOU:
           LD A,255
           NOLESGOU:
           LD (FONDITO+3),A   ;COLOR

           LD A,(IX+3)
           LD (FONDITO+1),A   ;COORDENADA X

           LD A,(IX+2)
           CALL SACADIM
           INC HL
           INC HL
           LD (HL),E          ;VELOCIDAD

           LD A,D             ;TIPO

                                    ;POR EL TIPO SACAMOS EL ESPRITE BASE

                                    LD DE, TABLAFONDO                ;BASE DE LA TABLA CON EL TAMAO DE CADA OBJETO
                                    LD HL,FONDOX
                                    CP 0                             ;EN "A" EST EL N DE TIPO
                                    JR Z,FINESCOGEFONDO              ;SI TIPO=0, HL YA EST BIEN.

                                    LD B,A
                                   KARKAMUSERO:                      ;BUCLE QUE VA SUMANDO PUNTERO A HL
                                    PUSH BC

                                    LD A,(DE)
                                    LD B,0
                                    LD C,A
                                    ADD HL,BC
                                    INC DE                           ;HL=1 BITE DEL OBJETO

                                    POP BC
                                   DJNZ KARKAMUSERO

                                    FINESCOGEFONDO:

           LD (FONDITO+4),HL  ;ESPRITE BASE

           LD A,(HL)          ;  (HL)*(HL+1)=JOKER             JOKER*8 +JOKER + 2=FATAMANIO    TAMAO DE LOS ESPRITES PARA RUTINA "DIBUJA"
           LD B,A
           DEC B
           INC HL
           LD A,(HL)
           LD C,A
         PINGO:
           ADD A,C
         DJNZ PINGO

           LD B,A             ;GUARDO EL RESULTADO EN B

           SLA A
           SLA A
           SLA A              ;JOKER*8
           
           ADD A,B            ;+JOKER
           ADD A,2            ;+2
           LD (FATAMANIO),A


           XOR A              ;CONTADORES FONDO ANIMADO A CERO
           LD (FAVELOCIDAD),A
           LD (FAPINTAR),A

           RET

     SIGUIENTEMANDA:
     LD BC,4
     ADD HL,BC
     JR CARGA_ELFONDO



;++++++++++++++++++++++
;++++++++++++++++++++++
; 7-  CARGA EVENTOS
;++++++++++++++++++++++
;++++++++++++++++++++++

CARGAEVENTOS:

LD HL,TABLA_EVENTOS
LD DE,EVENTOS

CARGANDO_EVENTOS:

     ;SI (HL)=255 HEMOS ACABADO --------------------------------------
     LD A,(HL)
     LD B,A
     CP 255
     RET Z

     ;COMPARAMOS 1VALOR CON VALOR PANTALLA -------------------------------
     LD A,(PANTALLA)
     CP B
     JP NZ,SIGUIENTEPLANDA

     ;SI COINCIDE CON PANTALLA, CARGAMOS VALORES ---------

     INC HL               ;ORIGEN
     ;LD DE,EVENTOS       ;DESTINO
     LD BC,12             ;TAMAO
     LDIR                 ;COPIAR

     JR CARGANDO_EVENTOS

SIGUIENTEPLANDA:

LD BC,13
ADD HL,BC
JR CARGANDO_EVENTOS







;++++++++++++++++++++++
;++++++++++++++++++++++
; 8- COPIYUPI @ COPITRANS
;++++++++++++++++++++++
;++++++++++++++++++++++

COPIYUPI:

;ESTA VERSION COPIA UN TROZO DE PANTALLA EN "ESPEJO", RESPETANDO EL FORMATO DE LA RUTINA "DIBUJA" PARA LUEGO IMPRIMIRLA. NO PUEDEN SER MAS DE 32 CARACTERES EN ANOTHER WORLD

;          ENTRADA   "BC"  "YX" ESQUINA SUPERIOR IZQUIERDA A COPIAR
;                    "DE"  LARGO/BAJO


              ;1 PRIMEROS DOS BITES ES DIMENSION ESPRITE
              LD HL,ESPEJO
              LD A,D
              LD (HL),A
              LD (JOKER),A    ;GUARDO LARGO PARA LUEGO
              LD A,E
              INC HL
              LD (HL),A
              LD (GUDAR),A    ;GUARDO BAJO PARA LUEGO

              ;2 DATOS PIXELS
              CALL RESIDENCIA;ENTRADA  BC(YX) SALIDA HL-> 1 DIRECCION A COPIAR
              PUSH HL        ;PUSEO PARA LUEGO ATRIBUTOS(***)

              LD A,D         ;GUARDO EN "A" CARACTERES A LO LARGO

              SLA E          ;Ex2    E=CARACTERES HACIA ABAJO
              SLA E          ;Ex4
              SLA E          ;Ex8
              LD B,E         ;N DE SCAN A COPIAR HACIA ABAJO

              LD DE,ESPEJO+2   ;SACO DIRECCIN DESTINO  (**1)

              COPIYUPI2:
              PUSH BC

              PUSH HL
                              ;HL ->ORIGEN
                              ;DE ->DESTINO
              LD B,0          ;BC ->TAMAO
              LD A,(JOKER)
              LD C,A
              LDIR            ;COPIAR

              POP HL
              CALL EMPANADAHR ;BAJO UN SCAN

              POP BC
              DJNZ COPIYUPI2

             ;3 DATOS ATRIBUTOS

              POP HL          ;POPEO 1 DIRECCION PIXELES (***)
              CALL RESIDENCIATRIBUTO
              ;"DE" 1 DIRECCION CORRECTA DE ATRIBUTOS

              LD A,(GUDAR)
              LD B,A
              A_LO_BAJO:
              PUSH BC

              PUSH HL

              LD A,(JOKER)
              LD B,A
              A_LO_LARGO:
              LD A,(HL)
              LD (DE),A
              INC HL
              INC DE
              DJNZ A_LO_LARGO

              POP HL                          ;BAJAMOS A SIGUIENTE FILA DE ATRIBUTOS
              LD BC,32
              ADD HL,BC
              LD (HUCHA),HL

              POP BC
              DJNZ A_LO_BAJO

              RET


COPITRANS:
;ESTA RUTINA COPIA EL TITULO SITUADO EN PARTE INFERIOR EN LA PARTE ALTA DE LA PANTALLA DE JUEGO

            LD HL,20613         ;ORIGEN    Y=20  X=5
            LD DE,16485         ;DESTINO   Y=3   X=5


       LD B,4
       LULIPOPI:
       PUSH BC

       PUSH HL
       PUSH DE

            LD B,8
            LILIPOP:
            PUSH BC

            PUSH HL
            PUSH DE

            LD BC,22
            LDIR

            POP DE
            POP HL

            INC H
            INC D

            POP BC
            DJNZ LILIPOP

       POP DE
       POP HL

       LD A,L
       ADD A,32
       LD L,A
       LD A,E
       ADD A,32
       LD E,A

       POP BC
       DJNZ LULIPOPI

RET



;++++++++++++++++++++++
;++++++++++++++++++++++
; 9-  PINTAR SEGN ESTADOS  + AUXILIAR ESTADOS
;++++++++++++++++++++++
;++++++++++++++++++++++


PINTAR_ESTADOS:

LD HL,TABLA_PINTAR_ESTADOS


INIZZIO:

LD A,(HL)
CP 255
RET Z

LD B,A  ;GUARDAMOS 1 VALOR
LD A,(PANTALLA)
CP B
JR NZ,ZIGUIENTE_TANDA

PUSH HL  ;(***)
PUSH HL
POP IX

LD A,(IX+1)    ;ESTADO
CALL PESTADOS

CP 0
JR NZ,JITKOCH
LD A,(IX+4)    ;N OBJETO A PINTAR CUANDO ESTADO VALE 0
CP 99          ;FONDO TELETRANSPORTE
JR Z,ESQUENO   ;SI VALE 99 NO PINTAREMOS NADA CON VALOR 0, ESTO ES SOLO PARA EL FONDO DE TELETRANSPORTE
JR JITKOCH2
JITKOCH:
LD A,(IX+5)    ;N OBJETO A PINTAR CUANDO ESTADO VALE 1
JITKOCH2:
CALL SACA_DE_OBJETO   ;PONEMOS EN "DE" ESPRITE SEGN SU NMERO

LD B,(IX+2)
LD C,(IX+3)
LD A,255
CALL DIBUJA

ESQUENO:

POP HL ;(***)

ZIGUIENTE_TANDA:

LD BC,6
ADD HL,BC
JR INIZZIO

              ;**********************************  AUXILIAR ESTADOS

              PESTADOS:  ;ENTRADA "A" N ESTADO  SALIDA "HL" DIRECCION ESTADO "A" VALOR DE ESTADO , usa "HL" - "DE" - "A"
              LD DE,ESTADOS
            XIUCCO:      ;TRUKO PAR USAR ESTA RUTINA EN VIDAS EXTRA TANIEN
              LD H,0
              LD L,A
              ADD HL,DE      ;HL EN ESTADO CORRECTO
              LD A,(HL)      ;CARGAMOS VALOR ESTADO EN "A"
              RET




;++++++++++++++++++++++
;++++++++++++++++++++++
; 10- MARCOS
;++++++++++++++++++++++
;++++++++++++++++++++++

;MARCOS:

;ENTRADA "HL" = ESPRITES DEL MARCO     "A"=COLOR

;1 PINTAMOS ESQUINAS

;LD (JOKER),A
;LD (JORCAS2),HL


;LD BC,4128         ;ESQUINA ARRIBA IZQUIERDA
;CALL HR1X1

;LD BC,4312         ;ESQUINA ARRIBA DERECHA
;CALL SUBESPRITE
;CALL HR1X1

;LD BC,38944        ;ESQUINA ABAJO IZQUIERDA
;CALL SUBESPRITE
;CALL HR1X1

;LD BC,39128        ;ESQUINA ABAJO IZQUIERDA
;CALL SUBESPRITE
;CALL HR1X1

;1 PINTAMOS TIRAS

;CALL SUBESPRITE   ;ARRIBA
;LD BC,517
;LD DE,5633
;CALL RELLENA

;CALL SUBESPRITE   ;ABAJO
;LD BC,4869
;LD DE,5633
;CALL RELLENA

;CALL SUBESPRITE   ;IZQUIERDA
;LD BC,772
;LD DE,272
;CALL RELLENA

;CALL SUBESPRITE   ;DERECHA
;LD BC,795
;LD DE,272
;CALL RELLENA

;RET


;SUBESPRITE:
;LD HL,(JORCAS2)
;LD DE,8
;ADD HL,DE
;LD (JORCAS2),HL   ;SUBO ASPRITE+8
;LD A,(JOKER)      ;PONGO COLOR
;RET



;++++++++++++++++++++++
;++++++++++++++++++++++
; 11- ESCROLES
;++++++++++++++++++++++
;++++++++++++++++++++++

;********************************************
;********************************************
ESCROLL_IZQUIERDA_CICLO:
CALL GUARDACARACTER
CALL ESCROL_IZQUIERDA
CALL SACACARACTERIZQ
RET

;---------------------------------------------------
GUARDACARACTER:
;ENTRADA BC ->DIRECCION DE ATRIBUTOS DEL CARACTER - ME AHORRO EL CLCULO
;ENTRADA HL ->1 DIRECCION DEL CARACTER - ME AHORRO EL CLCULO
;SALIDA CON CARACTER GUARDADO EN ESPEJO (0-8) y HL y BC IGUAL
PUSH HL
PUSH BC
LD DE,ESPEJO
LD B,8
CHACHIX:
   LD A,(HL)
   LD (DE),A
   INC DE
   INC H
DJNZ CHACHIX
POP BC
POP HL
LD A,(BC)
LD (DE),A
RET
;---------------------------------------------------
ESCROL_IZQUIERDA:
;ENTRADA "HL"  ->PRIMERA DIRECCION DEL CARACTER DONDE DESAPARECE, LARGO QUE ESCROLEA 22 CARACTERES
;ENTRADA "BC" -> PRIMERA DIRECCION ATRIBUTOS DEL CARACTER QDONDE DESAPARECE, LARGO QUE ESCROLEA 22 CARACTERES

PUSH HL                 ;(******B)  CARACTER
PUSH BC                 ;(******A)  ATRIBUTOS

LD D,H
LD E,L
INC HL

LD B,8
CHACHI:
PUSH BC
	PUSH HL
	PUSH DE
	LD BC,21
	LDIR
	POP DE
	POP HL
	INC D
	INC H
POP BC
DJNZ CHACHI

POP HL                 ;(******A)  ATRIBUTOS

LD D,H
LD E,L
INC HL
LD BC,21
LDIR
POP HL                 ;(******B)  CARACTER
RET
;---------------------------------------------------

SACACARACTERIZQ:
LD BC,21
TRETATETA:
ADD HL,BC
PUSH HL               ;(*****C)
LD DE,ESPEJO
LD B,8
CHACHIXX:
   LD A,(DE)
   LD (HL),A
   INC DE
   INC H
DJNZ CHACHIXX
POP HL                ;(*****C)
CALL RESIDENCIATRIBUTO
LD A,(DE)
LD (HL),A
RET

;********************************************
;********************************************

ESCROLL_DERECHA_CICLO:
CALL GUARDACARACTER
CALL ESCROL_DERECHA
CALL SACACARACTERDERE
RET


;---------------------------------------------------
SACACARACTERDERE:
LD BC,-21
JR TRETATETA

;---------------------------------------------------
ESCROL_DERECHA:
;ENTRADA "HL"  ->ULTIMA DIRECCION DEL CARCTER DE LA CADENA, LARGO QUE ESCROLEA 22 CARACTERES
;ENTRADA "BC" -> ULTIMA DIRECCION ATRIBUTOS DEL CARCTER DE LA CADENA, LARGO QUE ESCROLEA 22 CARACTERES

PUSH HL                 ;(******B)  CARACTER
PUSH BC                 ;(******A)  ATRIBUTOS

LD D,H
LD E,L
DEC HL

LD B,8
CHACHI2:
PUSH BC
	PUSH HL
	PUSH DE
	LD BC,21
	LDDR
	POP DE
	POP HL
	INC D
	INC H
POP BC
DJNZ CHACHI2

POP HL                 ;(******A)  ATRIBUTOS

LD D,H
LD E,L
DEC HL
LD BC,21
LDDR
POP HL                 ;(******B)  CARACTER
RET



;++++++++++++++++++++++
;++++++++++++++++++++++
; 12- ANIMACIONES RUTINAS
;++++++++++++++++++++++
;++++++++++++++++++++++

;*******************************************
;*******************************************

QUE_CARACTER:

;ENTRADA IX ->POSICION DE LA TABLA DONDE SE GUARDAN VALORES
;        DE ->BASE ESPRITE
;MUEVE SPRITE ANIMADO SEGN TABLA
;NO EST NADA OPTIMIZADA


;ESTOY AQUI, AADIMOS LA OPCION DE QUE DESAPAREZCA O NO Y ANIMACIONES YA SERA 1 MAS, ARREGLA OLIFANTE..
;HAZ RUTINA TODONEGRO



;PASAMOS 1 VALORES  A XY Y GUARDAMOS BASE ESPRITE
LD A,(IX+0)
LD (IX+2),A
LD A,(IX+1)
LD (IX+3),A
LD (JORCAS),DE


;BUCLE
LD B,(IX+8)
BARRUNTA:
PUSH BC
     
        LD A,B
        LD (JOKER3),A

        ;0 JOKER=0 SI ES PAR E (IX+7) SI NO LO ES
        BIT 0, B           ; Que valor tiene el bit 0?
        JR Z, PAR          ; Saltar si esta Z activado
           LD A,(IX+7)
           JR FINPAR
        PAR:
           XOR A
        FINPAR:
           LD (JOKER),A

        ;1PINTAMOS
        LD B,(IX+3)
        LD C,(IX+2)
        LD DE,(JORCAS)
        LD H,0
        LD A,(JOKER)
        LD L,A
        ADD HL,DE
        EX DE,HL
        LD A,(IX+6)
        CALL DIBUJA

        ;2SONIDO Y RETARDO
        LD A,(IX+9)
        CP 0
        JR Z,JIARIS
        CALL BIP
        JIARIS:

        LD B,(IX+10)
        OOOOH:
        PUSH BC
        HALT
        POP BC
        DJNZ OOOOH

        ;3BORRAMOS

        LD A,(JOKER3)
        CP 1
        JR NZ,SI_SE_VORRA

        LD A,(IX+11)
        CP 1
        JR Z,NO_SE_VORRA

        SI_SE_VORRA:

        LD B,(IX+3)
        LD C,(IX+2)
        LD A,(IX+12)
        LD DE,(JORCAS)
        CALL DIBUJA

        NO_SE_VORRA:

        ;4NUEVAS COORDENADAS
        LD A,(IX+2)
        ADD A,(IX+4)
        LD (IX+2),A

        LD A,(IX+3)
        ADD A,(IX+5)
        LD (IX+3),A

POP BC
DJNZ BARRUNTA
RET

;*******************************************
;*******************************************

DESINTEGRACION:
;BORRA 8 PIXELS EN 16 FILAS CON COORDENADAS DEL BUENO

LD A,(X)
LD C,A
LD A,(Y)
LD B,A
CALL COLOCAR    ;HL DE DIRECCION BUENO

        LD B,16
        DESINTEGRANDO:
        PUSH BC

        XOR A
        LD (HL),A
        
        CALL EMPANADAHR

        PUSH HL
        CALL EFECTO4
        POP HL

        POP BC
        DJNZ DESINTEGRANDO
RET

;*******************************************
;*******************************************

PARPADEA_BUENO:

LD B,10
KLIKEANDO2:
PUSH BC
LD B,7
KLIKEA2:
PUSH BC

     LD A,(COLORBUENO)
     ADD A,B
     LD (JOKER),A

     LD A,(Y)
     LD B,A
     LD A,(X)
     LD C,A
     LD A,(JOKER)
     LD HL,(BRAULIO)
     CALL HR1X2B

     HALT

POP BC
DJNZ KLIKEA2
POP BC
DJNZ KLIKEANDO2

CALL PINTABUENO

RET

;*******************************************
;*******************************************
EFECTO_COGER:

;BORRA 2X2 CON ANIMACIN DE NUBECITAS
;ENTRADA IX+0 IX+1 COORDENADAS BR DE ACTIVACIN

LD B,4
JOBATU:
PUSH BC
            LD DE,DRAMA2
            CALL FOTOGRAMEA   ;(*) CAMBIA FOTOGRAMA DE+0 O DE+38 SEGN B DEL BUCLE SEA PAR O IMPAR
            LD B,(IX+10)
            LD C,(IX+11)
            LD A,255

            CALL DIBUJA
            CALL EFECTO4

POP BC
DJNZ JOBATU

LD B,(IX+10)
LD C,(IX+11)
CALL BORRA2X2            ;BORRAMOS LO COGIDO

RET


FOTOGRAMEA:   ;(*) CAMBIA FOTOGRAMA DE+0 O DE+38 SEGN B DEL BUCLE SEA PAR O IMPAR
LD HL,0
BIT 0,B
;CP 0
JR Z, andaconioX
LD HL,38
andaconioX:
ADD HL,DE
EX DE,HL
RET


;*******************************************
;*******************************************

PANTALLA_MUERTE:
;LEON ANOTHER WORLD + GAME OVER + MUSIQUILLA
XOR A
LD (FONDO),A
CALL CELESEJUEGO

LD BC,2061
LD DE,1542
LD A,72
CALL COLOREA

LD A,66
LD(COLORFUENTE),A
LD BC,1291
LD DE,TEXTOS+111     ;"GAME  OVER"
CALL UNAFRASE

LD BC,2318
LD DE,LEON
LD A,255
CALL DIBUJA

LD HL,LEON
CALL INVERSO

LD BC,2320
LD DE,ESPEJO
LD A,255
CALL DIBUJA

CALL MISSION_SONG

RET


;*******************************************
;*******************************************
; COLOREAR EL MARCO DEL JUEGO


COLOREAR_MARCO:

LD HL,22528
LD DE,ATRIBUTOS_RECUADRO1
LD B,96
MORLAK:
LD A,(DE)
LD (HL),A
INC HL
INC DE
DJNZ MORLAK

LD HL,22624
LD DE,ATRIBUTOS_RECUADRO2
LD B,16
MORLAK1:
PUSH BC
    LD B,5
    MORLAK2:
    LD A,(DE)
    LD (HL),A
    INC HL
    INC DE
    DJNZ MORLAK2
    CALL ATRAS5_ABAJO
POP BC
DJNZ MORLAK1

LD HL,22651
LD DE,ATRIBUTOS_RECUADRO3
LD B,16
MORLAK3:
PUSH BC
    LD B,5
    MORLAK4:
    LD A,(DE)
    LD (HL),A
    INC HL
    INC DE
    DJNZ MORLAK4
    CALL ATRAS5_ABAJO
POP BC
DJNZ MORLAK3

LD HL,23136
LD DE,ATRIBUTOS_RECUADRO4
LD B,160
MORLAK5:
LD A,(DE)
LD (HL),A
INC HL
INC DE
DJNZ MORLAK5

RET

ATRAS5_ABAJO:   ;BAJAMOS LINEA ATRIBUTOS Y RETROCEDEMOS 5 COLUMNAS
LD BC,32
ADD HL,BC
DEC HL
DEC HL
DEC HL
DEC HL
DEC HL
RET



;++++++++++++++++++++++
;++++++++++++++++++++++
; 13- ANIMACIONES HISTORIA
;++++++++++++++++++++++
;++++++++++++++++++++++

ANIMACION_OLIFANTE:
; AL LIBERAR ELEFANTE...     OJO PONEMOS DATOS MAPAX QUE SE PUEDEN VER AFECTADOS SI CAMBIAS MAPA POR DEBAJO DE PANTALLA 76

   ;SUBIDO AL ELEFANTE

   LD BC,2325
   LD A,255
   LD DE,ESPRITES_CINEMATICAS+0
   CALL DIBUJA

   CALL EFECTO3

   ;ANIMACION PANTALLA 98
   LD IX,DATOS_CINEMATICAS+0
   LD DE,ESPRITES_CINEMATICAS+0
   CALL QUE_CARACTER

   ;ANIMACION PANTALLA 76
   CALL CELESEJUEGO
   LD HL,MAPAX+1204
   CALL PINTAPANTALLA

   LD IX,DATOS_CINEMATICAS+13
   LD DE,ESPRITES_CINEMATICAS+0
   CALL QUE_CARACTER

   ;ANIMACION PANTALLA 52
   CALL CELESEJUEGO
   LD HL,MAPAX+843
   CALL PINTAPANTALLA
   LD IX,DATOS_CINEMATICAS+26
   LD DE,ESPRITES_CINEMATICAS+0
   CALL QUE_CARACTER

   ;SALIDA PANTALLA 23
   
   LD A,104
   LD (Y),A
   LD A,128
   LD (X),A
   LD A,23
   LD (PANTALLA),A
   JP CARGAPANTALLA

