
AUXEFECTO:      DEFB 0,0
PISADA:         DEFB 0


;**************************************************
;PASOS
;**************************************************


PASITO:                  ;ANDANDO


LD A,(PISADA)
INC A
CP 20
JR Z,SUENAPISADA1
CP 40
JR Z,SUENAPISADA2
JR FINPASITO

SUENAPISADA1:
;              PUSH IX
;              PUSH IY
              ld hl,407     ; This is the pitch for our note
              ld de,1       ; This will be the duration it will play
              call 949
;              POP IY
;              POP IX
              LD A,6
              JR FINPASITO
SUENAPISADA2:
;              PUSH IX
;              PUSH IY
              ld hl,262     ; This is the pitch for our note
              ld de,2       ; This will be the duration it will play
              call 949
;              POP IY
;              POP IX
              XOR A
FINPASITO:
LD (PISADA),A
RET


;**************************************************
;SONIDO ALEATORIO
;**************************************************



;**************************************************
;EFECTO GALOPE    SONIDO SECO
;**************************************************

EFECTOGALOPE:
              PUSH IX
              PUSH IY
              ld hl,262     ;262 This is the pitch for our note
              ld de,2       ;2 This will be the duration it will play
              call 949
              POP IY
              POP IX
RET

;**************************************************
;SONIDO BIP
;**************************************************

BIP:
              PUSH IX
              PUSH IY
              ld hl,145     ; This is the pitch for our note
              ld de,13        ; This will be the duration it will play
              call 949
              POP IY
              POP IX
RET



;**************************************************
;EFECTO 1      HABLAR   EMBARCAR DESEMBARCAR
;**************************************************

;EFECTO1:

;LD B,2
;MARIACHI4:
;PUSH BC


;           LD B,5
;           MARIACHI5:
;           PUSH BC

;	   ld a, B		; borde azul, para actualizacin inmediata
;	   out (254), A
;           HALT             ;SI CAMBIO POR NOP RUIDO AGUDO METLICO
           ;NOP

;           LD (AUXEFECTO),HL

;              PUSH IX
;              PUSH IY
;              LD HL,189
;              ld de,1       ; This will be the duration it will play
;              call 949
;              POP IY
;              POP IX

;           POP BC
;           DJNZ MARIACHI5

;POP BC
;DJNZ MARIACHI4

;RET

;**************************************************
;EFECTO 2     COGER DAR USAR
;**************************************************


EFECTO2:

LD B,10
MARIACHI2:
PUSH BC

LD HL,2500
LD (AUXEFECTO),HL

        LD B,10
        MARIACHI:
        PUSH BC

        ld a, B		; borde azul, para actualizacin inmediata
        out (254), A

        LD HL,(AUXEFECTO)
        LD DE,-250
        ADD HL,DE
        LD (AUXEFECTO),HL

                 PUSH IX
                 PUSH IY
                 ld de,1       ; This will be the duration it will play
                 call 949
                 POP IY
                 POP IX

    POP BC
    DJNZ MARIACHI

POP BC
DJNZ MARIACHI2

RET

;**************************************************
;EFECTO 3    ENTRAR MINIJUEGO Y VICTORIA
;**************************************************


EFECTO3:

LD B,4
SALEROSO:
PUSH BC

LD HL,2500
LD (AUXEFECTO),HL

        LD B,23
        SALEROSA:
        PUSH BC

        LD HL,(AUXEFECTO)
        LD DE,-100
        ADD HL,DE
        LD (AUXEFECTO),HL

                 PUSH IX
                 PUSH IY
                 ld de,1       ; This will be the duration it will play
                 call 949
                 POP IY
                 POP IX

        POP BC
        DJNZ SALEROSA

POP BC
DJNZ SALEROSO

RET

;**************************************************
;EFECTO 4    MINI ESCALA        USADO EN COGER COSAS
;**************************************************

EFECTO4:

LD HL,2500
LD (AUXEFECTO),HL

        LD B,23
        MARICASTANA:
        PUSH BC

        LD HL,(AUXEFECTO)
        LD DE,-100
        ADD HL,DE
        LD (AUXEFECTO),HL

                 PUSH IX
                 PUSH IY
                 ld de,1       ; This will be the duration it will play
                 call 949
                 POP IY
                 POP IX

        POP BC
        DJNZ MARICASTANA
RET


;**************************************************
;EFECTO 5    DERROTA MINIJUEGO O QUITAR VIDA
;**************************************************

EFECTO_CAGADA:

LD B,5
MARIACHI12:
PUSH BC
LD HL,2620
LD (AUXEFECTO),HL

   ld a, 1		; borde AZUL, para actualizacin inmediata
   out (254), A
   HALT

       LD B,5
       MARIACHI13:
       PUSH BC
	 ld a, 2		; borde ROJO, para actualizacin inmediata
	 out (254), A
         HALT
       LD HL,(AUXEFECTO)
       LD DE,200
       ADD HL,DE
       LD (AUXEFECTO),HL
              PUSH IX
              PUSH IY
              ld de,5       ; This will be the duration it will play
              call 949
              POP IY
              POP IX
       POP BC
       DJNZ MARIACHI13
       POP BC
DJNZ MARIACHI12
	ld a, 0		; borde NEGRO, para actualizacin inmediata
	out (254), A
RET


;**************************************************
;EFECTO 6    Disparo
;**************************************************

EFECTO6:

LD HL,300
LD (AUXEFECTO),HL

        LD B,8
        chubasquero:
        PUSH BC

        LD HL,(AUXEFECTO)
        LD DE,120
        ADD HL,DE
        LD (AUXEFECTO),HL

                 PUSH IX
                 PUSH IY
                 ld de,2       ; This will be the duration it will play
                 call 949
                 POP IY
                 POP IX

        POP BC
        DJNZ chubasquero
RET

;**************************************************
;EFECTO 7    ACIERTO DEL BUENO   USADO EN SALTO
;**************************************************

EFECTO7:

LD HL,600
LD (AUXEFECTO),HL

        LD B,8
        CAMPAMENTO:
        PUSH BC

        LD HL,(AUXEFECTO)
        LD DE,-50
        ADD HL,DE
        LD (AUXEFECTO),HL

                 PUSH IX
                 PUSH IY
                 ld de,2       ; This will be the duration it will play
                 call 949
                 POP IY
                 POP IX

        POP BC
        DJNZ CAMPAMENTO
RET


;**************************************************
;EFECTO 8    ACIERTO DEL MALO
;**************************************************

EFECTO8:

LD HL,400
LD (AUXEFECTO),HL

        LD B,6
        SIRIBIRI:
        PUSH BC

           ld a, 2		; borde AZUL, para actualizacin inmediata
           out (254), A


        LD HL,(AUXEFECTO)
        LD DE,-50
        ADD HL,DE
        LD (AUXEFECTO),HL

                 PUSH IX
                 PUSH IY
                 ld de,2       ; This will be the duration it will play
                 call 949
                 POP IY
                 POP IX

           XOR A		; borde AZUL, para actualizacin inmediata
           out (254), A

        POP BC
        DJNZ SIRIBIRI

RET



;**************************************************
; *****************************************************************************
; * ROM BEEP Engine      - PARA EFCTOS PLAY CONTINUO HASTA ACABAR -
; *
; * By Chris Cowley
; *
; * Produced by Beepola v1.08.01
; ******************************************************************************
;**************************************************

;LOS LLAMAMOS:
;     LD HL,DATO
;     CALL START

;////////////////////////////////////////////////
FX_BIP:
LD HL,FX_BIP_DATA
JR STARTER
;////////////////////////////////////////////////
FX_TORIRORI:
LD HL,FX_TORIRORI_DATA
JR STARTER
;////////////////////////////////////////////////
FX_BIPBIP:
LD HL,FX_BIPBIP_DATA
JR STARTER
;////////////////////////////////////////////////
FX_NOCORTO:
LD HL,FX_NOCORTO_DATA
JR STARTER
;////////////////////////////////////////////////
FX_TRUENO:
LD HL,FX_TRUENO_DATA
JR STARTER

STARTER:
PUSH IX
PUSH IY
CALL START
POP IY
POP IX
RET

START:

                          ;LD   HL,MUSICDATA         ;  <- Pointer to Music Data. Change
                                                    ;     this to play a different song
                          LD A,(HL)
                          LD (TEMPO),A              ;ARREGLILLO PARA EL TEMPO
                          INC HL
                          LD   A,(HL)                         ; Get the loop start pointer
                          LD   (PATTERN_LOOP_BEGIN),A
                          INC  HL
                          LD   A,(HL)                         ; Get the song end pointer
                          LD   (PATTERN_LOOP_END),A
                          INC  HL
                          LD   (PATTERNDATA1),HL
                          LD   (PATTERNDATA2),HL
                          LD   A,254
                          LD   (PATTERN_PTR),A                ; Set the pattern pointer to zero
                          CALL  NEXT_PATTERN
                          EI
NEXTNOTE:
                          CALL  PLAYNOTE
                          JR    NEXTNOTE                    ; Play next note

                          EI
                          RET                                 ; Return from playing tune

PATTERN_PTR:              DEFB 0
NOTE_PTR:                 DEFB 0


; ********************************************************************************************************
; * NEXT_PATTERN
; *
; * Select the next pattern in sequence (and handle looping if we've reached PATTERN_LOOP_END
; * Execution falls through to PLAYNOTE to play the first note from our next pattern
; ********************************************************************************************************


NEXT_PATTERN:
                          LD   A,(PATTERN_PTR)
                          INC  A
                          INC  A
                          DEFB $FE                           ; CP n
PATTERN_LOOP_END:         DEFB 0
                          JR   NZ,NO_PATTERN_LOOP
                          DEFB $3E                           ; LD A,n
PATTERN_LOOP_BEGIN:       DEFB 0
                          POP  HL
                          EI
                          RET
NO_PATTERN_LOOP:          LD   (PATTERN_PTR),A
			                    DEFB $21                            ; LD HL,nn
PATTERNDATA1:             DEFW $0000
                          LD   E,A                            ; (this is the first byte of the pattern)
                          LD   D,0                            ; and store it at TEMPO
                          ADD  HL,DE
                          LD   E,(HL)
                          INC  HL
                          LD   D,(HL)
                          LD   A,(DE)                         ; Pattern Tempo -> A
	                	      LD   (TEMPO),A                      ; Store it at TEMPO

                          LD   A,1
                          LD   (NOTE_PTR),A

PLAYNOTE: 
			                    DEFB $21                            ; LD HL,nn
PATTERNDATA2:             DEFW $0000
                          LD   A,(PATTERN_PTR)
                          LD   E,A
                          LD   D,0
                          ADD  HL,DE
                          LD   E,(HL)
                          INC  HL
                          LD   D,(HL)                         ; Now DE = Start of Pattern data
                          LD   A,(NOTE_PTR)
                          LD   L,A
                          LD   H,0
                          ADD  HL,DE                          ; Now HL = address of note data
                          LD   D,(HL)

                          ; IF D = $0 then we are at the end of the pattern so set next pattern
                          LD   A,D
                          AND  A                              ; Optimised CP 0
                          JR   Z,NEXT_PATTERN

                          INC  HL
                          LD   E,(HL)

                          LD   A,(NOTE_PTR)
                          INC  A
                          INC  A
                          LD   (NOTE_PTR),A                   ; Increment the note pointer by 2 (one note per chan)

                          ; D = Note1 Value 0-255 (1=rest)
                          ; E = Note2 Value 0-255 (1=rest)

OUTPUT_NOTE:              LD   A,(TEMPO)
                          LD   B,A
OUTPUT_NOTE_LOOP:         PUSH BC
                          PUSH DE
                          LD   A,D
                          CALL BEEP_REST_A
OUTPUT_CH2:               POP  DE
                          PUSH DE
                          LD   A,E
                          CALL BEEP_REST_A
                          POP  DE
                          POP  BC
                          DJNZ OUTPUT_NOTE_LOOP
                          RET

BEEP_REST_A:              DEC  A
                          JR   Z,REST
                          ; Push duration onto calc stack
                          PUSH AF 
                          RST  $28 
                          DEFB $34
                          DEFB $EB,$23,$D7,$0A,$3D
                          DEFB $38
                          POP  AF
                          ; Push note value onto calc stacl
                          INC  A
                          CALL $2D28
                          LD   A,60
                          CALL $2D28
                          RST  $28 
                          DEFB $03,$38   ; SUBTRACT, END
                          CALL $03F8
                          RET
REST:                     HALT
                          HALT
                          LD   B,$FF
REST_LOOP:                LD   A,(BC)    ; Waste 7 Ts each iteration
                          DJNZ REST_LOOP
                          RET


; *** DATA ***
TEMPO:                    DEFB 0


;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

FX_TORIRORI_DATA:
                          DEFB 2   ;PONGO AQUI EL TEMPO
                          DEFB 0   ; Loop start point * 2
                          DEFB 2   ; Song Length * 2
                          DEFW PAT00
;PATTERNDATA0:             DEFW PAT00

; *** Pattern data consists of pairs of note values CH1,CH2 with a single $0 to
; *** mark the end of the pattern, and $01 for a rest
PAT00:
                          DEFB 2  ; Pattern tempo
                          DEFB 84,1
                          DEFB 89,1
                          DEFB 86,1
                          DEFB 96,1
                          DEFB $0

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

FX_BIP_DATA:
                          DEFB 2   ;PONGO AQUI EL TEMPO
                          DEFB 0   ; Loop start point * 2
                          DEFB 2   ; Song Length * 2
                          DEFW PAT10
;PATTERNDATA1:             DEFW PAT10

; *** Pattern data consists of pairs of note values CH1,CH2 with a single $0 to
; *** mark the end of the pattern, and $01 for a rest
PAT10:
                          DEFB 2  ; Pattern tempo
                          DEFB 107,1
                          DEFB $0


;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

FX_BIPBIP_DATA:
                          DEFB 3   ;PONGO AQUI EL TEMPO
                          DEFB 0   ; Loop start point * 2
                          DEFB 2   ; Song Length * 2
                          DEFW PAT20

; *** Pattern data consists of pairs of note values CH1,CH2 with a single $0 to
; *** mark the end of the pattern, and $01 for a rest
PAT20:
                          DEFB 3  ; Pattern tempo
                          DEFB 107,1
                          DEFB 112,1
                          DEFB $0
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
FX_NOCORTO_DATA:

                          DEFB 3   ;PONGO AQUI EL TEMPO
                          DEFB 0   ; Loop start point * 2
                          DEFB 2   ; Song Length * 2
                          DEFW PAT30

; *** Pattern data consists of pairs of note values CH1,CH2 with a single $0 to
; *** mark the end of the pattern, and $01 for a rest
PAT30:
                          DEFB 3  ; Pattern tempo
                          DEFB 71,1
                          DEFB 60,62
                          DEFB $0

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
FX_TRUENO_DATA:
                          DEFB 1   ;PONGO AQUI EL TEMPO
                          DEFB 0   ; Loop start point * 2
                          DEFB 2   ; Song Length * 2
                          DEFW PAT40

; *** Pattern data consists of pairs of note values CH1,CH2 with a single $0 to
; *** mark the end of the pattern, and $01 for a rest
PAT40:
                          DEFB 1  ; Pattern tempo
                          DEFB 50,50
                          DEFB $0





; *****************************************************************************
; * The Music Studio Player Engine
; *
; * Based on code written by Saa Puica for the utility, The Music Studio.
; * Modified by Chris Cowley
; *
; * Produced by Beepola v1.08.01
; ******************************************************************************




ROMANCE_SONG:
LD HL,ROMANCE_DATA
JR START2

ESQUELETOS_SONG:
LD HL,ESQUELETOS_DATA
JR START2

JSW_SONG:
LD HL,JSW_DATA
JR START2

MISSION_SONG:
LD HL,MISSION_DATA
JR START2


START2:
                          ;LD    HL,MUSICDATA         ;  <- Pointer to Music Data. Change
                          LD A,(HL)
                          LD (TEMPOX),A
                          INC HL

                          LD   A,(HL)                         ; Get the loop start pointer
                          LD   (PATTERN_LOOP_BEGINX),A
                          INC  HL
                          LD   A,(HL)                         ; Get the song end pointer
                          LD   (PATTERN_LOOP_ENDX),A
                          INC  HL
                          LD   (PATTERNDATA1X),HL
                          LD   (PATTERNDATA2X),HL
                          LD   A,254
                          LD   (PATTERN_PTRX),A                ; Set the pattern pointer to zero
                          DI
                          EXX
                          PUSH  HL
                          CALL  NEXT_PATTERNX
NEXTNOTEX:
                          CALL  PLAYNOTEX
                          JR    NEXTNOTEX                    ; Play next note

                          POP   HL
                          EXX                                 ; Restore HL' for return to BASIC
                          EI
                          RET                                 ; Return from playing tune

PATTERN_PTRX:              DEFB 0
NOTE_PTRX:                 DEFB 0

; ********************************************************************************************************
; * NEXT_PATTERN
; *
; * Select the next pattern in sequence (and handle looping if we've reached PATTERN_LOOP_END
; * Execution falls through to PLAYNOTE to play the first note from our next pattern
; ********************************************************************************************************
NEXT_PATTERNX:
                          LD   A,(PATTERN_PTRX)
                          INC  A
                          INC  A
                          DEFB $FE                           ; CP n
PATTERN_LOOP_ENDX:         DEFB 0
                          JR   NZ,NO_PATTERN_LOOPX
                          DEFB $3E                           ; LD A,n
PATTERN_LOOP_BEGINX:       DEFB 0
                          POP  HL
                          POP  HL
                          EXX
                          EI
                          RET
NO_PATTERN_LOOPX:          LD   (PATTERN_PTRX),A

			                    DEFB $21                            ; LD HL,nn
PATTERNDATA1X:            DEFW $0000
                          LD   E,A                            ; (this is the first byte of the pattern)
                          LD   D,0                            ; and store it at TEMPO
                          ADD  HL,DE
                          LD   E,(HL)
                          INC  HL
                          LD   D,(HL)
                          LD   A,(DE)                         ; Pattern Tempo -> A
	                	      LD   (TEMPOX),A                      ; Store it at TEMPO

                          LD   A,1
                          LD   (NOTE_PTRX),A

PLAYNOTEX:
                          DEFB $21                            ; LD HL,nn
PATTERNDATA2X:             DEFW $0000
                          LD   A,(PATTERN_PTRX)
                          LD   E,A
                          LD   D,0
                          ADD  HL,DE
                          LD   E,(HL)
                          INC  HL
                          LD   D,(HL)                         ; Now DE = Start of Pattern data
                          LD   A,(NOTE_PTRX)
                          LD   L,A
                          LD   H,0
                          ADD  HL,DE                          ; Now HL = address of note data
                          LD   D,(HL)
                          LD   E,1

; IF D = $0 then were at the end of the pattern so increment PATTERN_PTR by 2 and set NOTE_PTR=0
                          LD   A,D
                          CP   $FE                           ; $FE indicates end of pattern
                          JR   Z,NEXT_PATTERNX

CONTINUE0X:                PUSH DE
                          INC  HL
                          LD   D,(HL)
                          LD   E,1

                          LD   A,(NOTE_PTRX)
                          INC  A
                          INC  A
                          LD   (NOTE_PTRX),A                   ; Increment the note pointer by 2 (one note per chan)

                          EXX
                          POP  DE                             ; Now CH1 freq is in DE, and CH2 freq is in DE'

                          LD   A,(TEMPOX)
                          LD   C,A
                          LD   B,0
                          LD   A,BORDER_COLX
                          EX   AF,AF'
                          LD   A,BORDER_COLX                   ; So now BC = TEMPO, A and A' = BORDER_COL
                          EXX

OUTPUT_NOTEX:
                          LD   IXH,D                          ; Put note frequency for chan 1 into IXH
                          LD   H,D
                          LD   L,H
                          DEC  L
                          LD   E,L
                          JR   Z,CONTINUE1X
                          LD   E,$10
CONTINUE1X:
                          EXX
                          LD   IXL,D                          ; Put note frequency for chan 2 into IXL
                          LD   H,D
                          LD   L,H
                          DEC  L
                          LD   E,L
                          JR   Z,CONTINUE2X
                          LD   E,$10
CONTINUE2X:
                          EXX
                          EX   AF,AF'
                          OUT  ($FE),A
                          DEC  H             ; Dec H, which also holds the frequency value
                          JR   NZ,L8055
                          XOR  E
                          LD   H,D
                          PUSH AF
                          LD   A,IXH
                          CP   $20
                          JR   NC,L8054      ; if A > $20 then this is not a drum effect, skip the INC D
                          INC  D             ; create the "fast falling pitch" percussion effect
L8054:                    POP  AF
L8055:                    DEC  L
                          JR   NZ,L805B
                          XOR  E
                          LD   L,D
                          DEC  L
L805B:                    EXX
                          EX   AF,AF'
                          OUT  ($FE),A
                          DEC  H
                          JR   NZ,L806D
                          XOR  E
                          LD   H,D
                          PUSH AF
                          LD   A,IXL
                          CP   $20
                          JR   NC,L806C     ; if A > $20 then this is not a drum effect, skip the INC D
                          INC  D            ; create the "fast falling pitch" percussion effect
L806C:                    POP  AF
L806D:                    DEC  L
                          JR   NZ,L8073
                          XOR  E
                          LD   L,D
                          DEC  L
L8073:                    DJNZ CONTINUE2X
                          DEC  C
                          JR   NZ,CONTINUE2X
                          RET

; *** DATA ***
BORDER_COLX:               EQU $0
TEMPOX:                    DEFB 0

;***********************************************************************************************

ROMANCE_DATA:
                    DEFB 244
                    DEFB 0   ; Loop start point * 2
                    DEFB 2   ; Song Length * 2
                    DEFW      PAT0X

; *** Pattern data consists of pairs of frequency values CH1,CH2 with a single $FE to
; *** Mark the end of the pattern, and $01 for a rest
PAT0X:
         DEFB 13  ; Pattern tempo
             DEFB 81,1
             DEFB 81,1
             DEFB 81,1
             DEFB 81,1
             DEFB 91,1
             DEFB 96,1
             DEFB 96,1
             DEFB 108,54
             DEFB 121,61
             DEFB 121,61
             DEFB 96,48
             DEFB 81,40
             DEFB 61,1
             DEFB 61,1
             DEFB 61,1
             DEFB 61,1
             DEFB 68,1
             DEFB 76,1
             DEFB 76,1
             DEFB 81,1
             DEFB 91,1
             DEFB 91,1
             DEFB 81,1
             DEFB 76,1
             DEFB 81,1
             DEFB 76,1
             DEFB 81,1
             DEFB 64,1
             DEFB 76,1
             DEFB 81,1
             DEFB 81,40
             DEFB 91,45
             DEFB 96,48
             DEFB 96,48
             DEFB 108,54
             DEFB 121,61
             DEFB 108,54
             DEFB 108,54
             DEFB 108,1
             DEFB 108,1
             DEFB 96,1
             DEFB 108,1
             DEFB 121,1
         DEFB $FE




;***********************************************************************************************

ESQUELETOS_DATA:
                    DEFB 234
                    DEFB 0   ; Loop start point * 2
                    DEFB 2   ; Song Length * 2
                    DEFW      PAT2X

; *** Pattern data consists of pairs of frequency values CH1,CH2 with a single $FE to
; *** Mark the end of the pattern, and $01 for a rest
PAT2X:
         DEFB 28  ; Pattern tempo
             DEFB 108,54
             DEFB 108,54
             DEFB 121,61
             DEFB 108,54
             DEFB 108,54
             DEFB 136,68
             DEFB 136,68
             DEFB 144,72
             DEFB 161,81
             DEFB 161,81
             DEFB 108,30
             DEFB 108,54
             DEFB 121,61
             DEFB 108,54
             DEFB 108,54
             DEFB 136,68
             DEFB 136,68
             DEFB 136,68
             DEFB 144,72
             DEFB 161,81
             DEFB 161,81
         DEFB $FE

;***********************************************************************************************
JSW_DATA:



MUSICDATA:
                    DEFB 238
                    DEFB 0   ; Loop start point * 2
                    DEFB 16   ; Song Length * 2
                    DEFW      PAT0XX
                    DEFW      PAT1XX
                    DEFW      PAT0XX
                    DEFW      PAT2XX
                    DEFW      PAT3XX
                    DEFW      PAT4XX
                    DEFW      PAT3XX
                    DEFW      PAT5XX

; *** Pattern data consists of pairs of frequency values CH1,CH2 with a single $FE to
; *** Mark the end of the pattern, and $01 for a rest
PAT0XX:
         DEFB 22  ; Pattern tempo
             DEFB 96,192
             DEFB 96,1
             DEFB 86,1
             DEFB 86,1
             DEFB 81,128
             DEFB 81,1
             DEFB 72,1
             DEFB 72,1
             DEFB 64,192
             DEFB 64,1
             DEFB 81,1
             DEFB 81,1
             DEFB 64,128
             DEFB 64,1
         DEFB $FE
PAT1XX:
         DEFB 22  ; Pattern tempo
             DEFB 64,1
             DEFB 64,1
             DEFB 68,192
             DEFB 68,1
             DEFB 86,1
             DEFB 86,1
             DEFB 68,128
             DEFB 68,1
             DEFB 68,1
             DEFB 68,1
             DEFB 72,192
             DEFB 72,1
             DEFB 91,1
             DEFB 91,1
             DEFB 72,128
             DEFB 72,1
             DEFB 72,1
             DEFB 72,1
         DEFB $FE
PAT2XX:
         DEFB 22  ; Pattern tempo
             DEFB 48,1
             DEFB 48,1
             DEFB 54,161
             DEFB 54,1
             DEFB 64,1
             DEFB 64,1
             DEFB 81,108
             DEFB 81,1
             DEFB 64,1
             DEFB 64,1
             DEFB 54,161
             DEFB 54,1
             DEFB 54,1
             DEFB 54,1
             DEFB 54,108
             DEFB 54,1
             DEFB 54,1
             DEFB 54,1
         DEFB $FE
PAT3XX:
         DEFB 22  ; Pattern tempo
             DEFB 128,255
             DEFB 128,1
             DEFB 114,1
             DEFB 114,1
             DEFB 102,171
             DEFB 102,1
             DEFB 96,1
             DEFB 96,1
             DEFB 86,255
             DEFB 86,1
             DEFB 102,1
             DEFB 102,1
             DEFB 86,171
             DEFB 86,1
         DEFB $FE
PAT4XX:
         DEFB 22  ; Pattern tempo
             DEFB 86,1
             DEFB 86,1
             DEFB 81,161
             DEFB 81,1
             DEFB 102,1
             DEFB 102,1
             DEFB 81,203
             DEFB 81,1
             DEFB 81,1
             DEFB 81,1
             DEFB 86,255
             DEFB 86,1
             DEFB 102,1
             DEFB 102,1
             DEFB 86,171
             DEFB 86,1
             DEFB 86,1
             DEFB 86,1
         DEFB $FE
PAT5XX:
         DEFB 22  ; Pattern tempo
             DEFB 86,1
             DEFB 86,1
             DEFB 81,161
             DEFB 81,1
             DEFB 102,1
             DEFB 102,1
             DEFB 81,203
             DEFB 81,1
             DEFB 81,1
             DEFB 81,1
             DEFB 86,255
             DEFB 86,1
             DEFB 86,1
             DEFB 86,1
             DEFB 86,171
             DEFB 86,1
             DEFB 86,1
             DEFB 86,1
         DEFB $FE


;***********************************************************************************************
MISSION_DATA:

                    DEFB 240
                    DEFB 0   ; Loop start point * 2
                    DEFB 2   ; Song Length * 2
                    DEFW      PAT0DD

; *** Pattern data consists of pairs of frequency values CH1,CH2 with a single $FE to
; *** Mark the end of the pattern, and $01 for a rest
PAT0DD:
         DEFB 19  ; Pattern tempo
             DEFB 144,1
             DEFB 144,1
             DEFB 121,1
             DEFB 108,1
             DEFB 144,1
             DEFB 144,1
             DEFB 161,1
             DEFB 161,1
             DEFB 144,1
             DEFB 144,1
             DEFB 121,1
             DEFB 108,1
             DEFB 144,1
             DEFB 144,1
             DEFB 161,1
             DEFB 144,1
         DEFB $FE

