;*****************************************************************************************************************************************************
;*****************************************************************************************************************************************************
;*****************************************************   JUEGO PREVIO ANOTHER WORLD     **************************************************************
;*****************************************************************************************************************************************************
;*****************************************************************************************************************************************************


;**************************** BUCLE PREVIO AL JUEGO  ****************************
BUCLE_JUEGO_PREVIO:


CALL LEER_TECLADO
CP 0
JP Z,FIN_INTERPRETACION_PP


HAS_PULSADO_DERECHA_PP:
                   CP 3
                   JR NZ,HAS_PULSADO_IZQUIERDA_PP
                   
                   ;CAMBIO PANTALLA?
                   LD A,(X)
                   CP 208
                   JR NZ,NOCA
                      CALL BORRABUENO
                      LD A,(PANTALLA)
                      ADD A,10
                      LD (PANTALLA),A
                      LD A,40
                      LD (X),A
                      JP PREVIO_1
                   NOCA:

                   ;EN ESTE CASO FALTA COMPROBAR ATTR POR OBSTACULO EN PANTALLA 101 AL FINAL

                   LD A,(PANTALLA)
                   CP 101
                   JR NZ,VIVIPARO

                   CALL SACAJOTA_DERECHA
                   LD A,(JOTA)
                   CP 49
                   JP Z,FIN_INTERPRETACION_PP


                   VIVIPARO:
                   ;MOVEMOS: PRIMERO BORRAMOS
                   CALL BORRABUENO
                   ;INCREMENTAMOS DERECHA
                   LD A,(X)
                   INC A
                   INC A
                   LD (X),A
                   ;SPRITE MIRA DERECHA
                   XOR A
                   CALL FRAMEBUENO
                   CALL PINTABUENO
                   ;COMPROBAMOS LANZAMIENTO PERSECUCION
                   LD A,(PANTALLA)
                   CP 141
                   JR NZ,FIN_INTERPRETACION_PP
                   LD A,(X)
                   CP 120
                   JR NZ,FIN_INTERPRETACION_PP
                   JP PERSECUCION                   ;LANZAMOS PERSECUCION

HAS_PULSADO_IZQUIERDA_PP:
                   CP 4
                   JR NZ,FIN_INTERPRETACION_PP
                   ;CAMBIO PANTALLA?
                   LD A,(X)
                   CP 40
                   JR NZ,NOCA22
                      CALL BORRABUENO
                      LD A,(PANTALLA)
                      SUB 10
                      LD (PANTALLA),A
                      LD A,208
                      LD (X),A
                      JP PREVIO_1
                   NOCA22:
                   ;EN ESTE CASO FALTA COMPROBAR ATTR POR PUERTA
                   CP 56
                   JR NZ,PIXILON
                   LD HL,23013                  ;ATRIBUTOS DE Y15 X5
                   LD A,(HL)
                   CP 49
                   JR Z,FIN_INTERPRETACION_PP   ;PUERTA CERRADA NO AVANZAMOS
                   PIXILON:
                   ;MOVEMOS: PRIMERO BORRAMOS
                   CALL BORRABUENO
                   ;INCREMENTAMOS IZQUIERDA
                   LD A,(X)
                   DEC A
                   DEC A
                   LD (X),A
                   ;SPRITE MIRA IZQUIERDA
                   LD A,64
                   CALL FRAMEBUENO
                   CALL PINTABUENO
                   ;COMPROBAMOS LANZAMIENTO JUEGO PRINCIPAL
                   LD A,(PANTALLA)
                   CP 101
                   JR NZ,FIN_INTERPRETACION_PP
                   LD A,(X)
                   CP 42
                   JR NZ,FIN_INTERPRETACION_PP
                   JP JUEGO_PRINCIPAL                   ;LANZAMOS JUEGO PRINCIPAL


FIN_INTERPRETACION_PP:

                   HALT

JP  BUCLE_JUEGO_PREVIO



;*****************************************************************************************************************************************************
;*****************************************************************************************************************************************************
;*************************************************************   JUEGO PRINCIPAL     *****************************************************************
;*****************************************************************************************************************************************************
;*****************************************************************************************************************************************************


BUCLE_PRINCIPAL:


XOR A
LD (ACCION),A               ;ACCION A CERO
LD (MARCADOR),A             ;INDICADOR A CERO


;**************************************************
;**********   TECLADO & DIBUJO BUENO  *************
;**************************************************

CALL LEER_TECLADO
;LEE TECLAS Y JOYSTICK, SALIDA "PULSACION" Y A CON VALORES:
;     0  NADA
;     1  ARRIBA
;     2  ABAJO
;     3  DERECHA
;     4  IZQUIERDA
;     5  ACCION


;INTERPRETAMOS LECTURA
CP 0
JP Z,FIN_INTERPRETACION

HAS_PULSADO_ARRIBA:
                   CP 1
                   JR NZ,HAS_PULSADO_ABAJO
                   ;CAMBIO PANTALLA?
                   LD A,(Y)
                   CP 24
                   JR NZ,NOCA1
                      LD A,(PANTALLA)
                      INC A
                      LD (PANTALLA),A
                      LD A,136
                      LD (Y),A
                      JP CARGAPANTALLA
                   NOCA1:
                   ;COMPROBAR ATTR
                   CALL ATTRARRIBA     ;->ENTRA CON  "Y" EN "A", DEVUELVE "0" SI NO HAY CHOQUE Y "1" SI HAY CHOQUE
                   CP 0
                   JP NZ, CHOCAxARRIBA

                   ;MOVEMOS: PRIMERO BORRAMOS
                   CALL BORRABUENO
                   ;INCREMENTAMOS ARRIBA
                   LD A,(Y)
                   DEC A
                   DEC A
                   LD (Y),A
                   ;SPRITE MIRA ARRIBA
                   LD A,128
                   CALL FRAMEBUENO
                   CALL PINTABUENO
                   CALL PASITO
                   JP FIN_INTERPRETACION

HAS_PULSADO_ABAJO:
                   CP 2
                   JR NZ,HAS_PULSADO_DERECHA
                   ;CAMBIO PANTALLA?
                   LD A,(Y)
                   CP 136
                   JR NZ,NOCA2
                      LD A,(PANTALLA)
                      DEC A
                      LD (PANTALLA),A
                      LD A,24
                      LD (Y),A
                      JP CARGAPANTALLA
                   NOCA2:
                   ;COMPROBAR ATTR
                   CALL ATTRABAJO     ;->ENTRA CON  "Y" EN "A", DEVUELVE "0" SI NO HAY CHOQUE Y "1" SI HAY CHOQUE
                   CP 0
                   JP NZ, CHOCAxABAJO

                   ;MOVEMOS: PRIMERO BORRAMOS
                   CALL BORRABUENO
                   ;INCREMENTAMOS ABAJO
                   LD A,(Y)
                   INC A
                   INC A
                   LD (Y),A
                   ;SPRITE MIRA ABAJO
                   LD A,192
                   CALL FRAMEBUENO
                   CALL PINTABUENO
                   CALL PASITO
                   JP FIN_INTERPRETACION

HAS_PULSADO_DERECHA:
                   CP 3
                   JR NZ,HAS_PULSADO_IZQUIERDA
                   ;CAMBIO PANTALLA?
                   LD A,(X)
                   CP 208
                   JR NZ,NOCA3
                      LD A,(PANTALLA)
                      ADD A,10
                      LD (PANTALLA),A
                      LD A,40
                      LD (X),A
                      JP CARGAPANTALLA
                   NOCA3:
                   ;COMPROBAR ATTR
                   CALL ATTRDERECHA        ;->ENTRA CON  "X" EN "A", DEVUELVE "0" SI NO HAY CHOQUE Y "1" SI HAY CHOQUE
                   CP 0
                   JP NZ, CHOCAxDERECHA

                   ;MOVEMOS: PRIMERO BORRAMOS
                   CALL BORRABUENO
                   ;INCREMENTAMOS DERECHA
                   LD A,(X)
                   INC A
                   INC A
                   LD (X),A
                   ;SPRITE MIRA DERECHA
                   XOR A
                   CALL FRAMEBUENO
                   CALL PINTABUENO
                   CALL PASITO
                   JR FIN_INTERPRETACION


HAS_PULSADO_IZQUIERDA:
                   CP 4
                   JR NZ,HAS_PULSADO_ACCION
                   ;CAMBIO PANTALLA?
                   LD A,(X)
                   CP 40
                   JR NZ,NOCA4
                      LD A,(PANTALLA)
                      SUB 10
                      LD (PANTALLA),A
                      LD A,208
                      LD (X),A
                      JP CARGAPANTALLA
                   NOCA4:
                   ;COMPROBAR ATTR
                   CALL ATTRIZQUIERDA     ;->ENTRA CON  "X" EN "A", DEVUELVE "0" SI NO HAY CHOQUE Y "1" SI HAY CHOQUE
                   CP 0
                   JP NZ, CHOCAxIZQUIERDA

                   ;MOVEMOS: PRIMERO BORRAMOS
                   CALL BORRABUENO
                   ;INCREMENTAMOS IZQUIERDA
                   LD A,(X)
                   DEC A
                   DEC A
                   LD (X),A
                   ;SPRITE MIRA IZQUIERDA
                   LD A,64
                   CALL FRAMEBUENO
                   CALL PINTABUENO
                   CALL PASITO
                   JR FIN_INTERPRETACION

HAS_PULSADO_ACCION:
                  CP 5
                  JR NZ,FIN_INTERPRETACION
                  LD A,1
                  LD (ACCION),A

FIN_INTERPRETACION:


;**************************************************
;*****************   EVENTOS  *********************
;**************************************************


;/////////////////////////////  OBTENEMOS COORDENADAS EN BAJA RESOLUCIN
;//////////////////////////////////////////////////////////////////////////////////

LD A,(X)
LD D,A
LD A,(Y)
LD E,A
CALL HRaBR                           ;"DE" "XY" EN BAJA RESOLUCIN
LD A,D
LD (BX),A                            ;GUARDO XB - YB  COORDENADAS EN BAJA RESOLUCIN, TENER ENCUENTA QUE ES ANTES DE PINTARLO
LD A,E
LD (BY),A


LD HL,EVENTOS


;/////////////////////////////  BUCLE EVENTOS
;//////////////////////////////////////////////////////////////////////////////////

INICIOEVENTOS:

;PONEMOS EVENTOS EN IX ---------------------------------------------------------------

PUSH HL ;(**) GUARDAMOS HL
PUSH HL
POP IX

;HEMOS TERMINADO? --------------------------------------------------------------------
              LD A,(IX)
              CP 0
              JP Z,FINEVENTOS


;ESTAMOS EN POSICIN? --------------------------------------------------
              LD A,(BX)
              INC A
              INC A
              LD B,(IX+1)
              SUB B
              CP 4
              JP NC,BLOQUESIGUIENTE     ;BX+2=A  XACTIVA=B    A=A-B   ... 255NO 0SI 1SI 2SI 3SI 4NO ...
              LD A,(BY)
              INC A
              INC A
              LD B,(IX)
              SUB B
              CP 5
              JP NC,BLOQUESIGUIENTE     ;BY+2=A  YACTIVA=B    A=A-B   ... 255NO 0SI 1SI 2SI 3SI 4SI 5NO ...


;VALOR ESTADO ES CORRECTO? -------------------------------------------

              LD A,(IX+2)
              CP 255
              JR Z,OBJETO_EN_INVENTARIO

              CALL PESTADOS  ;ENTRADA "A" N ESTADO  SALIDA "A" VALOR DE ESTADO, usa "HL" - "DE" - "A"

              LD B,(IX+3)    ;"CARGAMOS VALOR ESTADO A COMPROBAR EN "B" Y COMPARAMOS
              CP B
              JP NZ,BLOQUESIGUIENTE

;VALOR OBJETO EN INVENTARIO ES CORRECTO? -------------------------------------------
              OBJETO_EN_INVENTARIO:

              LD A,(IX+4)
              CP 255
              JR Z,ACTIVA_MARCADOR
              
              INVENTARIO_IGUAL:
              CP 0
              JR NZ,INVENTARIO_DISTINTO
              LD A,(INVENTARIO)
              LD B,(IX+5)
              CP B
              JR Z,ACTIVA_MARCADOR
              JP BLOQUESIGUIENTE

              INVENTARIO_DISTINTO:
              LD A,(INVENTARIO)
              LD B,(IX+5)
              CP B
              JR NZ,ACTIVA_MARCADOR
              JP BLOQUESIGUIENTE

              ;JP NZ,BLOQUESIGUIENTE
              JP BLOQUESIGUIENTE

;ESTAS EN POSICION Y SE CUMPLE, EN SU CASO, CONDICION DE ESTADO Y DE INVENTARIO, ACTIVAMOS MARCADOR -------------------------------------------

              ACTIVA_MARCADOR:

              LD A,(IX+6)

              CP 1
              JP Z,ACTIVADO_MARCADOR1
              CP 2
              JP Z,ACTIVADO_MARCADOR2
              CP 6
              JP Z,ACTIVADO_MARCADOR2
              CP 4
              JP Z,ACTIVADO_MARCADOR3
              CP 7
              JP Z,ACTIVADO_MARCADOR3
              CP 8
              JP Z,ACTIVADO_MARCADOR3
              CP 11
              JP Z,ACTIVADO_MARCADOR3
              CP 12
              JP Z,ACTIVADO_MARCADOR3

              FIN_ACTIVADO_MARCADOR:


;CON MARCADOR ACTIVADO, COMPROBAMOS SI HAS PULSADO O NO ACCION -------------------------------------------
              LD A,(ACCION)
              CP 1
              JR Z,PULSANDO
              JP SIN_PULSAR


;/////////////////////////////  BUCLE EVENTOS: COSAS QUE SUCEDEN SOLO SI APRIETAS ACCION
;//////////////////////////////////////////////////////////////////////////////////
PULSANDO:


              LD A,(IX+6)

              ;H A B L A R ===============================================
              CP 1
              JR NZ,DAR


                     ;1GUARDAR FONDO
                       LD B,(IX+11)
                       LD C,8
                       LD DE,4098   ;16x2
                       CALL COPIYUPI
                     ;2 COLOREAR FONDO AZUL
                       CALL BORRA_FRASE
                     ;3 ESCRIBIR FRASES
                       LD A,78
                       LD (COLORFUENTE),A

                       POP HL                    ;(**)
                       PUSH HL                   ;(**)
                       LD DE,8
                       ADD HL,DE                 ;DIRECCION 1FRASE, EST EN IX+8, PERO NO SABEMOS SU DIRECCIN, USAMOS EL HL GUARDADO Y LO VOLVEMOS A PONER.

                       LD A,(IX+7)               ;N DE FRASES
                       LD B,A
                       FRASEA:
                       PUSH BC


                       LD A,(HL)
                       PUSH HL
                       LD DE,PUNTERO_FRASES
                       LD HL,0
                       CALL  TRUCO_CONTADOR_FRASES        ;HL=VALOR A SUMAR A FRASES


                       LD DE,FRASES
                       ADD HL,DE
                       EX DE,HL
                       LD B,(IX+11)
                       LD C,8
                       CALL UNAFRASEB

                       CALL ESPERATECLA
                       ;CALL EFECTO2          ;CAMBIAR POR EFECTO ESPECFICO
                       CALL FX_BIP
                       CALL BORRA_FRASE
                       POP HL
                       INC HL

                       POP BC
                       DJNZ FRASEA


                     ;4 RESTAURAR FONDO
                       LD B,(IX+11)
                       LD C,8
                       LD A,255
                       LD DE,ESPEJO
                       CALL DIBUJA

                     JP FINEVENTOS

              ;D A R  ===============================================
              DAR:
              CP 2
              JR NZ,IR_ESCALERA

                       
                       ;SOLO DEJAMOS METER PINTURA ROSA SI TENEMOS LA RUEDA... ES QUE SI NO LA CAGAS
                       LD A,(IX+5)
                       CP 14                     ;LLEVAMOS PINTURA ROSA?
                       JR NZ,PANGELUINGA

                       LD A,(ESTADOS+6)
                       CP 1
                       JR Z,PANGELUINGA         ;SI HAS COGIDO RUEDA , SI PUEDES

                          LD BC,1293
                          LD DE,TEXTOS+172
                          LD A,74
                          LD (COLORFUENTE),A
                          CALL UNAFRASE         ;NO TIENES LA RUEDA, TE DIGO QUE AUN NO
                          CALL EFECTO_CAGADA
                          LD BC,1293
                          LD DE,1793
                          CALL BORRAZONA
                          JP FINEVENTOS

                    PANGELUINGA:
                       XOR A                    ;GASTAMOS LO QUE LLEVAMOS EN INVENTARIO INVENTARIO =0
                       LD (INVENTARIO),A
                       CALL TRUKKI              ;PINTAMOS INTERFACE INVENTARIO

                       LD A,(IX+7)              ;METEMOS EN INVENTARIO LO QUE NOS DARAN
                       CALL METE_INVENTARIO

                       LD A,(IX+8)              ;N ESTADO
                       CALL PESTADOS            ;ENTRADA "A" N ESTADO  SALIDA "HL" DIRECCION ESTADO "A" VALOR DE ESTADO , usa "HL" - "DE" - "A"
                       LD A,(IX+9)              ;CAMBIAMOS VALOR ESTADO
                       LD (HL),A

                       
                       LD A,(IX+11)
                       CP 252                   ;SOLO VALE 252 EN TELETRANSPORTE, INDICA EL N DE OBJETOS COLOCADOS PARA CTIVAR TELETRANPORTE CUANDO ESTADO 14=3
                       JR NZ,NO_TLE
                       LD HL,ESTADOS+14
                       LD A,(HL)
                       INC A
                       LD (HL),A
                       NO_TLE:

                       LD A,(IX+10)
                       CP 251
                       JP NZ,FINEVENTOS
                       POP HL                   ;(**) PARA QUE NO SE CORROMPA LA PILA
                       JP CARGAPANTALLA

              ;IR E S C A L E R A  ===============================================
              IR_ESCALERA:
              CP 4
              JR NZ,COGER

              POP HL              ;(**) PARA QUE NO SE CORROMPA LA PILA
              JP MISIL

              ;C O G E R  ===============================================
              COGER:
              CP 6
              JR NZ,USAR_MAQUINA

                       LD A,(IX+7)              ;METEMOS EN INVENTARIO
                       CP 12                    ;SI ES BOMBILLICA COMPROBAMOS QUE NO LA HEMOS COGIDO YA
                       JR NZ,CONTIYU
                          LD A,(ESTADOS+10)     ;COGIDA BOMBILLA 0-NO 1-SI
                          CP 1
                          JP Z,FINEVENTOS

                          LD A,12               ;VOLVEMOS A PONER BOMBILLICA EN A

                     CONTIYU:

                       CALL METE_INVENTARIO
                       CALL EFECTO_COGER

                       CALL FX_BIPBIP
              
                       LD A,(IX+8)              ;N ESTADO
                       CALL PESTADOS            ;ENTRADA "A" N ESTADO  SALIDA "HL" DIRECCION ESTADO "A" VALOR DE ESTADO , usa "HL" - "DE" - "A"
                       LD A,(IX+9)              ;CAMBIAMOS VALOR ESTADO
                       LD (HL),A

                       JP FINEVENTOS


              ;USAR M A Q U I N A   P I N T A R ===============================================
              USAR_MAQUINA:   ;COLOCAR
              CP 7
              JR NZ,USAR_TELETRANSPORTE

                       XOR A                    ;GASTAMOS INVENTARIO =0
                       LD (INVENTARIO),A
                       CALL TRUKKI              ;PINTAMOS INTERFACE INVENTARIO

                       LD A,(IX+5)
                       CALL SACA_DE_OBJETO
                       LD B,(IX+10)
                       LD C,(IX+11)
                       LD A,255
                       CALL DIBUJA              ;COLOCAMOS LO QUE LLEVABAMOS EN INVENTARIO EN LAS COORDENADAS INDICADAS

                       LD A,(IX+8)              ;N ESTADO
                       CALL PESTADOS            ;ENTRADA "A" N ESTADO  SALIDA "HL" DIRECCION ESTADO "A" VALOR DE ESTADO , usa "HL" - "DE" - "A"
                       LD A,(IX+9)              ;CAMBIAMOS VALOR ESTADO
                       LD (HL),A

                       LD A,(PANTALLA)          ;SI ES PANTALLA 64 HAY QUE PONER ESTADO 12 A 65
                       CP 64
                       JR NZ,NO_ES_P_64
                       LD DE,ESTADOS+12
                       LD A,65
                       LD (DE),A
                       NO_ES_P_64:

                       ;CALL EFECTO2
                       CALL FX_TORIRORI

                       POP HL                   ;(**) PARA QUE NO SE CORROMPA LA PILA
                       JP CARGAPANTALLA


              ;USAR T E L E T R A N S P O R T E  ===============================================
              USAR_TELETRANSPORTE:
              CP 8
              JR NZ,PALANCAS

                       CALL PARPADEA_BUENO

                       ;CALL EFECTO2
                       CALL FX_TORIRORI
                       LD A,112
                       LD (X),A
                       LD A,72
                       LD (Y),A
                       LD A,50
                       LD (PANTALLA),A
                       POP HL                   ;(**) PARA QUE NO SE CORROMPA LA PILA
                       JP CARGAPANTALLA
              
              
              ;P A L A N C A S  ===============================================
              PALANCAS:
              CP 11
              JR NZ,IR_ELEFANTE

                       LD A,(IX+8)              ;N ESTADO
                       CALL PESTADOS            ;ENTRADA "A" N ESTADO  SALIDA "HL" DIRECCION ESTADO "A" VALOR DE ESTADO , usa "HL" - "DE" - "A"
                       CP 0
                       JR Z,RANKI
                       XOR A
                       JR RANKI2
                     RANKI:
                       LD A,1
                     RANKI2:
                       LD (HL),A
                       
                       CALL FX_BIPBIP

                       POP HL                   ;(**) PARA QUE NO SE CORROMPA LA PILA
                       JP CARGAPANTALLA

              ;IR O L I F A N T E  ===============================================
              IR_ELEFANTE:
              CP 12
              JP NZ,FINEVENTOS

                        ;BORRAMOS PUERTAS
                        LD BC,2323
                        LD DE,516
                        CALL BORRAZONA

                        ;BORRAMOS AL BUENO
                        CALL BORRABUENO

                        CALL EFECTO3
                        CALL EFECTO4
                        CALL PAUSADE50

                        ;LANZAMOS ANIMACION

                        POP HL                   ;(**) PARA QUE NO SE CORROMPA LA PILA
                        JP ANIMACION_OLIFANTE


;/////////////////////////////  BUCLE EVENTOS: COSAS QUE SUCEDEN SOLO POR ESTAR EN EL SITIO
;//////////////////////////////////////////////////////////////////////////////////
SIN_PULSAR:

              LD A,(IX+6)

              ;IR S N A K E  ===============================================
              IR_SNAKE:
              CP 3
              JR NZ,IR_FROG

              LD A,(IX+8)
              LD (PANTALLA_SNAKE),A

              LD A,(IX+9)
              LD (FINAL_FASE_SNK),A

              LD A,(IX+10)
              LD (PREMIO_SNK),A

              ;LD A,(IX+11)         ;DATO NO NECESARIO
              ;LD (FASE_SNK),A


              POP HL              ;(**) PARA QUE NO SE CORROMPA LA PILA
              JP SNAKE

              
              ;IR T A B L E R O  ===============================================
              ;IR_TABLERO:
              ;CP 5
              ;JR NZ,IR_FROG

              ;POP HL              ;(**) PARA QUE NO SE CORROMPA LA PILA
              ;JP TABLERO

              ;IR F R O G  ===============================================
              IR_FROG:
              CP 9
              JR NZ,IR_FINAL

              POP HL              ;(**) PARA QUE NO SE CORROMPA LA PILA
              JP FROG

              ;IR AVISO REPENTINO  ===============================================
              ;IR_AVISO_REPENTINO:
              ;CP 14
              ;JR NZ,IR_FINAL

                          ;LD B,(IX+8)  ;Y
                          ;LD C,(IX+9)  ;X
                          ;LD HL, TEXTOS
                          ;LD D,0
                          ;LD E,(IX+7)
                          ;ADD HL,DE
                          ;EX DE,HL
                          ;LD A,74
                          ;LD (COLORFUENTE),A
                          ;CALL UNAFRASE         ;"ESTA TRISTE" o "SI PUDIERA SUBIR"

                          ;LD B,(IX+8)
                          ;LD C,6
                          ;LD DE,4865
                          ;CALL BORRAZONA
                          ;JP FINEVENTOS

              ;IR F I N A L  ===============================================
              IR_FINAL:
              CP 13
              JR NZ,FINEVENTOS

              POP HL              ;(**) PARA QUE NO SE CORROMPA LA PILA
              JP TRANSICION_FINAL

BLOQUESIGUIENTE:
POP HL  ;(**)
LD DE,12
ADD HL,DE
JP INICIOEVENTOS


;FIN BUCLE EVENTOS -------------------------------------------------------------------
FINEVENTOS:
POP HL              ;(**) PARA QUE NO SE CORROMPA LA PILA





;****************************************************************
;******************   EVENTOS VIDAS EXTRAS  *********************
;****************************************************************


;LO HAGO SEPARADO SLO PORQUE SE AADIO MAS TARDE...


LD IX,EVENTOS_VEX

LD A,(IX)
CP 0
JR Z,FINEVENTOS_VEX

;HAS PULSADO ACCIN ? --------------------------------------------------
              LD A,(ACCION)
              CP 1
              JR NZ,FINEVENTOS_VEX

;ESTAMOS EN POSICIN? --------------------------------------------------
              LD A,(BX)
              INC A
              INC A
              LD B,(IX+1)
              SUB B
              CP 4
              JR NC,FINEVENTOS_VEX
              LD A,(BY)
              INC A
              INC A
              LD B,(IX)
              SUB B
              CP 5
              JR NC,FINEVENTOS_VEX

;VALOR ESTADO ES CORRECTO? -------------------------------------------

              LD A,(IX+2)
              LD DE,ESTADOS_VEX
              CALL XIUCCO            ;APROVECHO LA RUTINA DE PINTAR ESTADOS PRINCIPAL, SALIDA "A" CON VALOR ESTADO  "HL" DIRECCION ESTADO
              CP 0
              JR NZ,FINEVENTOS_VEX   ; SI ESTADO NO ES CERO ES QUE YA LA HEMOS COGIDO
              
;COGEMOS LA VIDA -------------------------------------------

               ;CAMBIAR ESTADO     HL YA VIENE CON DIRECCION ESTADO
               LD A,1
               LD (HL),A
 
               CALL FX_TORIRORI

              ;BORRAR CORAZON
               LD B,(IX+0)
               LD C,(IX+1)
               DEC C
               CALL BORRA2X2
              ;INCREMENTAR VIDA
               LD A,(IX+3)
               CP 1
               JR Z,XI_PRINCIPAL
               CP 2
               JR Z,XI_SNAKE

               XI_HORACE:
               CALL INCREMENTA_VIDA_FROG
               JR FINEVENTOS_VEX

               XI_PRINCIPAL:
               CALL INCREMENTA_VIDA_PRINCIPAL
               JR FINEVENTOS_VEX

               XI_SNAKE:
               CALL INCREMENTA_VIDA_SNAKE

FINEVENTOS_VEX:



;****************************************************************
;*********   SPRITES ANIMADOS MARCADOR ACCIONES  ****************
;****************************************************************


;****PINTARLO****
LD A,(MARCADOR)
CP 0
JR Z,FININDICADOR

LD A,(CONTADOR_MARCADOR)
INC A
CP 21    ;11
JR NZ,INDIKA
XOR A
INDIKA:
LD (CONTADOR_MARCADOR),A
CP 10   ;5
CALL Z, INDICASIGNA5      ;PRIMER FRAME
CP 20   ;10
CALL Z, INDICASIGNA10     ;SEGUNDO FRAME

FININDICADOR:

;****BORRARLO****
LD A,(MARCADOR)
CP 0
JR NZ,FINBORRAINDICADOR

LD A,(BORRAINDICADOR)
CP 1                     ;SI HA ESTADO ACTIVO RESTAURAMOS
CALL Z,ABORRARINDICADOR

FINBORRAINDICADOR:



;****************************************************************
;*********   G E S T I O N    I N V E N T A R I O   *************
;****************************************************************

LD BC, $DFFE                ; Semifila "P" a "Y"
IN A, (C)                   ; Leemos el puerto
BIT 2, A                    ; Testeamos el bit 2  "I"   -- LA TECLA I NO SE PUEDE DEFINIR POR EL JUGADOR, LO SIENTO, LA VIDA A VECES TIENE ESTAS COSAS
JP NZ, FIN_G_INVENTARIO     ; Si NO est a 0 (pulsado) salir.

;DIBUJAMOS TABLERO INVENTARIO    ************************

LD A,79
LD (COLORFUENTE),A

REINIZZIO:

LD BC,773
LD DE,2824
LD A,255
     LD (SELECCION1),A     ;APROVECHAMOS PARA DAR VALOR VACIO A SELECCION
     LD (SELECCION2),A
LD HL,VACIO2X2+608
CALL RELLENA2D

LD IX,POSICIONES_INVENTARIO
LD DE,INVENTARIO
PUSH DE

LD A,16
GEMOLINO:
LD (JOKER),A

LD B,(IX+0)
LD C,(IX+1)
LD DE,CALAVERA1
LD A,255
CALL DIBUJA

POP DE
LD A,(DE)
INC DE
PUSH DE

CALL SACA_DE_OBJETO    ;PONEMOS EN "DE" LA DIRECCION DE OBJETOS A COGER O PINTAR SEGUN SEGUN SU NUMERO
LD B,(IX+0)
INC B
LD C,(IX+1)
LD A,255
CALL DIBUJA

INC IX
INC IX
INC IX

LD A,(JOKER)
DEC A
CP 0
JR NZ,GEMOLINO
POP DE


LD BC,4630
LD DE,I_FUERA
LD A,255
CALL DIBUJA

LD HL, VACIO1X1
LD BC,4102
LD DE,2049
LD A,78
CALL RELLENA

LD HL, VACIO1X1
LD BC,4114
LD DE,2049
LD A,78
CALL RELLENA

;CALL EFECTO2
CALL FX_TORIRORI

;BUCLE GESTIN INVENTARIO    ************************

LD IX,POSICIONES_INVENTARIO
CALL COLOREA_PUNTERO_INVENTARIO


BUCLE_G_INVENTARIO:

LD BC, $DFFE                ; Semifila "P" a "Y"
IN A, (C)                   ; Leemos el puerto
BIT 2, A                    ; Testeamos el bit 2  "I"   -- LA TECLA I NO SE PUEDE DEFINIR POR EL JUGADOR, LO SIENTO, LA VIDA A VECES TIENE ESTAS COSAS
JP Z, EXIT_INVENTARIO


CALL LEER_TECLADO

           ;INTERPRETAMOS LECTURA
           CP 0
           JP Z,FIN_INTERPRETACION_INVENTARIO

            PARRIBA:
                   CP 1
                   JR NZ,PABAJO

                   LD A,(IX+0)
                   CP 4
                   JP Z,FIN_INTERPRETACION_INVENTARIO


                        CALL PINTA_CALAVERA

                        LD A,(IX+0)
                        CP 16
                        JR NZ,TRETRE
                        LD BC,39
                        JR TRETRE2
                        TRETRE:
                        LD BC,-15
                        TRETRE2:
                        ADD IX,BC
                        CALL COLOREA_PUNTERO_INVENTARIO
                        ;CALL EFECTO6
                        CALL FX_BIP

                   JP FIN_INTERPRETACION_INVENTARIO

            PABAJO:
                   CP 2
                   JR NZ,PADERECHA

                   LD A,(IX+0)
                   CP 12
                   JR NZ,TRATRA

                   LD A,(IX+1)
                   CP 15
                   JP NZ,FIN_INTERPRETACION_INVENTARIO

                       CALL PINTA_CALAVERA
                       LD BC,-39
                       JR TRATRA3
                       ADD IX,BC

                   TRATRA:
                   CP 16
                   JP Z,FIN_INTERPRETACION_INVENTARIO

                       CALL PINTA_CALAVERA
                       LD BC,15
                       TRATRA3:
                       ADD IX,BC
                       CALL COLOREA_PUNTERO_INVENTARIO
                        ;CALL EFECTO6
                        CALL FX_BIP

                   JP FIN_INTERPRETACION_INVENTARIO

            PADERECHA:
                   CP 3
                   JR NZ,PAIZQUIERDA

                   LD A,(IX+1)
                   CP 23
                   JP Z,FIN_INTERPRETACION_INVENTARIO
                   CP 15
                   JR NZ,TROTRO
                   LD A,(IX+0)
                   CP 16
                   JP Z,FIN_INTERPRETACION_INVENTARIO

                       TROTRO:
                       CALL PINTA_CALAVERA
                       INC IX
                       INC IX
                       INC IX
                       CALL COLOREA_PUNTERO_INVENTARIO
                        ;CALL EFECTO6
                        CALL FX_BIP

                   JP FIN_INTERPRETACION_INVENTARIO


            PAIZQUIERDA:
                   CP 4
                   JR NZ,PACCION

                   LD A,(IX+1)
                   CP 7
                   JP Z,FIN_INTERPRETACION_INVENTARIO
                   CP 15
                   JR NZ,TRUTRU
                   LD A,(IX+0)
                   CP 16
                   JP Z,FIN_INTERPRETACION_INVENTARIO

                       TRUTRU:
                       CALL PINTA_CALAVERA
                       DEC IX
                       DEC IX
                       DEC IX
                       CALL COLOREA_PUNTERO_INVENTARIO
                        ;CALL EFECTO6
                        CALL FX_BIP

                   JP FIN_INTERPRETACION_INVENTARIO

            PACCION:
                  CP 5
                  JP NZ,FIN_INTERPRETACION_INVENTARIO


                                ;1 DIBUJAMOS CALAVERA DE SELECCIONADO
                                CALL PINTA_CALAVERA_EXCITADA
                                ;CALL EFECTO2
                                CALL FX_BIPBIP
                                ;2 ANALIZAMOS...
                                LD A,(SELECCION1)
                         ELCASO1:
                                CP  255
                                JR NZ,ELCASO2
                                LD A,(IX+2)
                                LD (SELECCION1),A

                                JP FIN_INTERPRETACION_INVENTARIO       ;SI SELECCION1=255 ENTONCES DAMOS VALOR DE HUECO INVENTARIO Y NOS VAMOS

                         ELCASO2:
                                
                                LD B,A                                 ;VALOR SELECCION1 EN B
                                LD A,(IX+2)
                                CP B                                   ;SELECCION 1 ESTABA LLENA, COMPROBAMOS QUE NO ESTAMOS VOLVIENDO A SELECCIONAR EL MISMO
                                JR NZ,ELCASO3

                                LD A,255
                                LD (SELECCION1),A                      ;COMO ES EL MISMO DESELECCIONAMOS Y NOS VAMOS
                                CALL PINTA_CALAVERA_NORMAL
                                CALL COLOREA_PUNTERO_INVENTARIO
                                JP FIN_INTERPRETACION_INVENTARIO

                         ELCASO3:

                                LD (SELECCION2),A                      ;SELECCION2=IX+2, AHORA ANALIZAMOS A VER QUE PODEMOS HACER

                         ANALISIS_PAUSADO:


                             BANQUETA:

                                LD A,(SELECCION1)    ;N HUECO1
                                CALL PINVENTARIO     ;A=CONTENIDO HUECO 1  "HL" HUECO 1
                                PUSH HL              ;(****)
                                CP 5
                                JR Z,QUIZAS_BANQUETA
                                CP 7
                                JR Z,QUIZAS_BANQUETA

                                JR NO_SE_JUNTA

                                QUIZAS_BANQUETA:

                                LD A,(SELECCION2)    ;N HUECO2
                                CALL PINVENTARIO     ;A=CONTENIDO HUECO 2  "HL" HUECO 2
                                CP 5
                                JR Z,SI_SE_JUNTA
                                CP 7
                                JR Z,SI_SE_JUNTA

                                NO_SE_JUNTA:
                                POP HL               ;(****)
                                JR INTERKAMBIO       ;VAMOS A VER SI HAY INTERCAMBIO SI UNO DE LOS HUECOS ES EL CERO

                                SI_SE_JUNTA:

                                XOR A
                                LD (HL),A

                                LD A,9
                                POP HL               ;(****)     ;JUNTAMOS Y PONEMOS EN HUECO DE SELECCION1 LA MESA
                                LD (HL),A

                                           LD A,(SELECCION1)                       ;SI SELECCION1, DONDE QUEDA MESA, ES CERO PINTAMOS TAMBIEN EN INTERFEIS
                                           CP 0
                                           JR Z,PLINTA_INTERFEIS
                                           
                                           LD A,(SELECCION2)                       ;SI SELECCION2, DONDE QUEDA VACIO, ES CERO PINTAMOS CERO TAMBIEN EN INTERFEIS
                                           CP 0
                                           JR Z,PLINTA_INTERFEIS2

                                           JP REINIZZIO                            ;SI NI SLECCION1 SELECCION2 ES HUECO, NO HAY QUE PINTAR INTERFACE

                                PLINTA_INTERFEIS:
                                LD A,9
                                PLINTA_INTERFEIS2:
                                CALL TRUKKI          ;PINTAMOS INVENTARIO (O) EN PANTALLA    ---->>  OJO ESTO SOLO SI UNO DE ELLOS ES HUECO !!!!
                                JP REINIZZIO         ;EMPEZAMOS NUEVAMENTE

                               INTERKAMBIO:

                                LD A,(SELECCION1)
                                CP 0
                                JR Z,INTERCAMBIO_INVENTARIO

                                LD A,(SELECCION2)
                                CP 0
                                JR Z,INTERCAMBIO_INVENTARIO

                                LD BC,4105           ;MENSAJE "NO JUNTAR", SONIDO CHUNGO Y FUERA
                                LD DE, TEXTOS+61     ;"NO!"
                                CALL UNAFRASE
                                ;CALL EFECTO8
                                CALL FX_NOCORTO
                                CALL PAUSADE10
                                JP REINIZZIO

                             INTERCAMBIO_INVENTARIO:

                                LD A,(SELECCION1)    ;N HUECO1
                                CALL PINVENTARIO     ;A=CONTENIDO HUECO 1  "HL" HUECO 1

                                LD B,A               ;GUARDAMOS EN B
                                PUSH HL              ;GUARADAMOS DIRECCION HUECO1

                                LD A,(SELECCION2)    ;N HUECO2
                                CALL PINVENTARIO     ;A=CONTENIDO HUECO 2  "HL" HUECO 2
                                LD C,A               ;GUARDAMOS EN C

                                LD A,B               ;GUARDAMOS OBJETO HUECO 1 EN HUECO 2
                                LD (HL),A

                                LD A,C               ;OBJETO HUECO2
                                POP HL               ;DIRECCION HUECO1
                                LD (HL),A            ;GUARDAMOS OBJETO HUECO 2 EN HUECO 1
                                
                                LD A,(INVENTARIO)
                                CALL TRUKKI          ;PINTAMOS INVENTARIO (O) EN PANTALLA

                                JP REINIZZIO         ;EMPEZAMOS NUEVAMENTE


FIN_INTERPRETACION_INVENTARIO:

LD A,(SELECCION1)    ;N HUECO2
CALL PINVENTARIO     ;A=CONTENIDO HUECO 2  "HL" HUECO 2
CALL NOMBRARLO
LD BC,4114
CALL UNAFRASE

JP BUCLE_G_INVENTARIO

EXIT_INVENTARIO:
;CALL EFECTO4
CALL FX_NOCORTO
JP CARGAPANTALLA

FIN_G_INVENTARIO:


;**************************************************
;*************   SPRITES ANIMADOS  ****************
;**************************************************


LD A,(FONDITO)
CP 0
JR Z, FINFONDITO

      LD A,(FONDITO+2)     ;LIMITE
      LD B,A
      LD A,(FAVELOCIDAD)   ;CONTADOR
      INC A
      LD (FAVELOCIDAD),A
      CP B
      JR NZ,FINFONDITO

      XOR A
      LD (FAVELOCIDAD),A

      LD A,(FAPINTAR)
      INC A
      LD (FAPINTAR),A

      CP 1
      JR NZ,TXASCO6
       LD E,0
       JR TXASCOPINTA

      TXASCO6:
      CP 6
      JR NZ,TXASCO11
       LD A,(FATAMANIO)
       LD E,A
       JR TXASCOPINTA

      TXASCO11:
      CP 11
      JR NZ,TXASCO16
       LD A,(FATAMANIO)
       ADD A,A
       LD E,A
       JR TXASCOPINTA

      TXASCO16:
      CP 16
      JR NZ, FINFONDITO
      XOR A
      LD (FAPINTAR),A
      JR FINFONDITO


     TXASCOPINTA:
      LD HL,(FONDITO+4)
      LD D,0
      ADD HL,DE
      ;LD HL,FONDOX+33
      LD A,(FONDITO)
      LD B,A
      LD A,(FONDITO+1)
      LD C,A
      LD A,(FONDITO+3)
      EX DE,HL
      CALL DIBUJA

FINFONDITO:


;**************************************************
;******************   MALOS  **********************
;**************************************************


;:::::::::::::::::::::::::::: M A L O S ::::::::::::::::::::::


LD IX,MALVADOS

LD B,3
PARA_CADA_UNO:
PUSH BC             ;(**)

                    ;///////////////////// IX+0=0 NO HAY NADA
                    LD A,(IX+0)
                    CP 0
                    JR NZ,AAQUII

                    POP BC      ;(**)
                    JR FIN_MALVADOS

                    ;///////////////////// INCREMENTAMOS CONTADOR VELOCIDAD

                    AAQUII:

                    LD A,(IX+10)
                    INC A
                    LD (IX+10),A     ;CONTADOR
                    ;LD B,(IX+5)     ;VELOCIDAD
                    CP (IX+5)
                    JP NZ,OTRO_MALO

                    ;///////////////////// SI VELOCIDAD=CONTADOR ENTONCES:
                    XOR A
                    LD (IX+10),A     ;CONTADOR VELOCIDAD A CERO

                    ;///////////////////// INCREMENTAMOS COORDENADAS

                    CALL VARIAMOS_LAS_COORDENADAS    ;APROVECHO RUTINA DE FROG

                    ;///////////////////// GESTION DE CAMBIO COLOR ATRS

                    CALL BORRA_DETRAS

                    ;///////////////////// INCREMENTAMOS CONTADOR AVANCE

                    LD A,(IX+9)
                    INC A
                    LD (IX+9),A     ;CONTADOR AVANCE
                    CP (IX+4)       ;DISTANCIA
                    JR NZ,GESTIONA_FOTOGRAMA          ;SI CONTADOR AVANCE NO ES IGUAL A DISTANCIA VAMOS A FOTOGRAMA

                    ;///////////////////// CAMBIAMOS VARIACIONES

                    XOR A
                    LD (IX+9),A         ;CONTADOR AVANCE A CERO

                    LD A,(IX+2)
                    CALL INVIRTIENDO    ;APROVECHO RUTINA DE FROG
                    LD (IX+2),A

                    LD A,(IX+3)
                    CALL INVIRTIENDO
                    LD (IX+3),A

                    ;///////////////////// FOTOGRAMA

                    GESTIONA_FOTOGRAMA:

                    CALL FOTOGRAMA_MALOS         ;CALCULAMOS FOTOGRAMA Y PINTAMOS

                    ;///////////////////// COLISION CON BUENO

                    CALL CHOQUE_MALO_BUENO

                    ;///////////////////// OTRA TANDA

                    OTRO_MALO:

                    LD BC,12
                    ADD IX,BC


POP BC           ;(**)
DJNZ PARA_CADA_UNO


FIN_MALVADOS:






HALT


JP BUCLE_PRINCIPAL