
;*******************************************
;       *******   F R O G  ********
;*******************************************

;MINIJUEGO PARA "LIVING IN ANOTHER WORLD"

;BORRAESTOCONIO:

;LD A,1
;LD IX,ESPEJO+210
;LD (IX+8),A

FROG:
LD A,70
LD (FONDO),A
CALL CELESEJUEGO        ;BORRAMOS PANTALLA JUEGO



;*******************************************
; INTRO    *******************************************
;*******************************************
;CONVERSION A HORACE
CALL BUENO_A_HORACE

;*******************************************
; VALORES INICIALES   ***********************************
;*******************************************

LD HL,ESPEJO        ;VAMOS A USAR EL ESPACIO RESERVADO EN ESPEJO
LD B,220            ;220 BYTES RESERVAMOS
CALL TABLAACERO

;SEGUN ENTRE POR LA PANTALLA 43 O 27  O POR 17 NIVEL 4?

LD A,(IX+8)         ;PANTALLA POR LA QUE ENTRAS
LD (ESPEJO+105),A   ;LA GUARDO EN ESPEJO+105
CP 1
JR NZ,ENTRASPOR_27

LD A,32
LD (ESPEJO+100),A    ;Y FROG
LD A,112
LD (ESPEJO+101),A    ;X FROG
JR FIN_ENTRASPOR

ENTRASPOR_27:
CP 3
JR NZ,ENTRASPOR_17

LD A,40
LD (ESPEJO+100),A    ;Y FROG
LD A,48
LD (ESPEJO+101),A    ;X FROG
JR FIN_ENTRASPOR

ENTRASPOR_17:
LD A,88
LD (ESPEJO+100),A    ;Y FROG
LD A,208
LD (ESPEJO+101),A    ;X FROG

FIN_ENTRASPOR:

;*******************************************
;   ***********************************
;*******************************************


;*******************************************
; CARGAPANTALLA FROG ***********************************
;*******************************************

CARGAPANTALLA_FROG:

CALL CELESEJUEGO

LD DE,PUNTERO_MAPA_FROG
LD HL,0
LD A,(ESPEJO+105)                 ;PANTALLA FROG 1 - 2 - 3 - 4?
CALL TRUCO_CONTADOR_FRASES        ;HL=VALOR A SUMAR A LA BASE DEL MAPA PARA OBTENER PRIMER VALOR DEL MAPA
LD DE,MAPA_FROG
ADD HL,DE
CALL PINTAPANTALLA

LD A,(ESPEJO+105)                 ;SI ESTAMOS EN PANTALLA 1 0 2 PINTAMOS ZONA TRONCOS FROG
CP 3
CALL C,ZONA_TRONCO

LD A,(ESPEJO+105)                 ;SI ESTAMOS EN PANTALLA 4 PINTAREMOS LLAVE SI NO EST COGIDA Y APROVECHAMOS PARA CARGAR VALORES INICIALES PLATAFORMAS
CP 4
CALL Z,ZONA_LLAVE

LD A,70                           ;COLOR HORACE INICIAL
LD (ESPEJO+102),A




;*******************************************
; BUCLE FROG   ***********************************
;*******************************************

BUCLE_FROG:


;////////////////////////////////////////// LECTURA DEL TECLADO

CALL LEER_TECLADO

HORACE_ARRIBA:
                   CP 1
                   JR NZ,HORACE_ABAJO

                      ;CAMBIO PANTALLAS
                      LD A,(ESPEJO+100)
                      CP 24               ;SI ESTAMOS EN Y=24 Y PULSAMOS "Q"
                      JR NZ,NOKAMBIO1
                      LD A,(ESPEJO+105)
                      DEC A
                      LD(ESPEJO+105),A
                      CP 0
                      JP Z,SALIDA_P49
                      LD A,144
                      LD (ESPEJO+100),A
                      JR CARGAPANTALLA_FROG
                      NOKAMBIO1:

                   LD A,(ESPEJO+105)
                   CP 3
                   JR NC,NO_DEC16               ;EN PANTALLA 3 Y 4 NO HAY TRONCOS

                          LD A,(ESPEJO+100)       ;EN PANTALLA 1 Y 2 SOLO EN UNAS DETERMINADAS POSICIONES DE Y (48,64,80,96)
                          SUB 48
                          CP 50
                          JR NC,NO_DEC16
                          LD B,-16
                          LD C,0
                          JR ER_KALL2
                   NO_DEC16:
                   LD B,-8
                   LD C,0
                   ER_KALL2:
                   CALL TU_MIRA_AVER    ;ENTRADA VARIACION COORDENADAS, COMPRUEBA POSIBLE MOVIMIENTO; SI ES SI, BORRAS Y MODIFICAS COORDENADAS FROG
                   JP NO_HORACE
HORACE_ABAJO:
                   CP 2
                   JR NZ,HORACE_DERECHA

                      ;CAMBIO PANTALLAS
                      LD A,(ESPEJO+100)
                      CP 144               ;SI ESTAMOS EN Y=144 Y PULSAMOS "A"
                      JR NZ,NOKAMBIO2
                      LD A,2
                      LD(ESPEJO+105),A
                      LD A,24
                      LD (ESPEJO+100),A
                      JP CARGAPANTALLA_FROG
                      NOKAMBIO2:

                   LD A,(ESPEJO+105)
                   CP 3
                   JR NC,NO_INC16               ;EN PANTALLA 3 Y 4 NO HAY TRONCOS

                          LD A,(ESPEJO+100)       ;EN PANTALLA 1 Y 2 SOLO EN UNAS DETERMINADAS POSICIONES DE Y (32,48,64,80)
                          SUB 32
                          CP 50
                          JR NC,NO_INC16
                          LD B,16
                          LD C,0
                          JR ER_KALL
                   NO_INC16:
                   LD B,8
                   LD C,0
                   ER_KALL:
                   CALL TU_MIRA_AVER    ;ENTRADA VARIACION COORDENADAS, COMPRUEBA POSIBLE MOVIMIENTO; SI ES SI, BORRAS Y MODIFICAS COORDENADAS FROG
                   JP NO_HORACE

HORACE_DERECHA:
                   CP 3
                   JR NZ,HORACE_IZQUIERDA


                      ;CAMBIO PANTALLAS
                      LD A,(ESPEJO+101)
                      CP 208               ;SI ESTAMOS EN X=208
                      JR NZ,NOKAMBIO3
                      LD A,(ESPEJO+102)
                      CP 70               ;Y TINTA = 70 (NO RIO)
                      JR NZ,NOKAMBIO3
                      LD A,(ESPEJO+105)
                      CP 4
                      JP Z,SALIDA_P17
                      LD A,2
                      LD(ESPEJO+105),A
                      LD A,40
                      LD (ESPEJO+101),A
                      JP CARGAPANTALLA_FROG
                      NOKAMBIO3:

                   LD B,0
                   LD C,8
                   CALL TU_MIRA_AVER
                   JR NO_HORACE

HORACE_IZQUIERDA:
                   CP 4
                   JR NZ,HORACE_COGE_LLAVE

                      ;CAMBIO PANTALLAS
                      LD A,(ESPEJO+101)
                      CP 40               ;SI ESTAMOS EN X=40
                      JR NZ,NOKAMBIO4
                      LD A,(ESPEJO+102)
                      CP 70               ;Y TINTA = 70 (NO RIO)
                      JR NZ,NOKAMBIO4
                      LD A,(ESPEJO+105)
                      INC A
                      LD (ESPEJO+105),A
                      CP 4
                      JP Z,SALIDA_P27
                      LD A,208
                      LD (ESPEJO+101),A
                      JP CARGAPANTALLA_FROG
                      NOKAMBIO4:

                   LD B,0
                   LD C,-8
                   CALL TU_MIRA_AVER


HORACE_COGE_LLAVE:
                   CP 5
                   JR NZ,NO_HORACE
                   
                   LD A,(ESPEJO+105)   ;PANTALLA 4?
                   CP 4
                   JR NZ,NO_HORACE
                   
                   LD A,(ESTADOS+24)    ;LLAVE COGIDA?
                   CP 1
                   JR Z,NO_HORACE
                   
                   LD A,(ESPEJO+100)
                   CP 45
                   JR NC,NO_HORACE   ;ESTAS EN Y?
                   
                   LD A,(ESPEJO+101)
                   CP 60
                   JR NC,NO_HORACE   ;ESTAS EN X?

                   ;COGES LLAVE...

                       LD A,20                  ;METEMOS LLAVE EN INVENTARIO
                       CALL METE_INVENTARIO

                       LD BC,773
                       CALL BORRA2X2            ;BORRAMOS LO COGIDO

                       LD A,1                   ;ESTADO 24=1
                       LD (ESTADOS+24),A

NO_HORACE:


;////////////////////////////////////////// COMPROBAMOS QUE NO ESTAMOS EN MAL SITIO

CALL FRIE_HORACE

;////////////////////////////////////////// PINTAMOS HORACE

HALT

;CONTADOR FRAME
LD A,(ESPEJO+104)
INC A
LD (ESPEJO+104),A
CP 5
JR Z,POS_HORACE1
CP 10
JR Z,POS_HORACE2
JR FIN_PINTAR_HORACE

POS_HORACE1:
   LD A,8
   LD (ESPEJO+103),A
   JR PINTANDO_HORACE
POS_HORACE2:
   XOR A
   LD (ESPEJO+103),A
   LD (ESPEJO+104),A
PINTANDO_HORACE:
   CALL PINTAR_HORACE

FIN_PINTAR_HORACE:



;////////////////////////////////////////// GESTION DE ZONA TRONCOS EN RIO

;1 COMPROBAMOS QUE ESTAMOS EN PANTALLA CON RO..

LD A,(ESPEJO+105)               ;SI ESTAMOS EN PANTALLA 1 0 2 PINTAMOS ZONA TRONCOS FROG
CP 3
JR NC,FIN_ZONA_TRONCO

;ESCROL_DERECHA:
;ENTRADA "HL"  ->ULTIMA DIRECCION DEL CARCTER DE LA CADENA, LARGO QUE ESCROLEA 22 CARACTERES
;ENTRADA "BC" -> ULTIMA DIRECCION ATRIBUTOS DEL CARCTER DE LA CADENA, LARGO QUE ESCROLEA 22 CARACTERES

;ESCROL_IZQUIERDA:
;ENTRADA "HL"  ->PRIMERA DIRECCION DEL CARACTER DONDE DESAPARECE, LARGO QUE ESCROLEA 22 CARACTERES
;ENTRADA "BC" -> PRIMERA DIRECCION ATRIBUTOS DEL CARACTER QDONDE DESAPARECE, LARGO QUE ESCROLEA 22 CARACTERES

LD A,(ESPEJO+50)     ;CONTADOR SCROL FILA 6
INC A
LD (ESPEJO+50),A
CP 25
JR NZ,TERMINO_SC1
XOR A
LD (ESPEJO+50),A

      LD HL,16602                    ;FILA 6
      LD BC,22746
      CALL ESCROLL_DERECHA_CICLO

      LD D,8
      LD A,48
      CALL HORACE_ENCIMA

TERMINO_SC1:

LD A,(ESPEJO+51)     ;CONTADOR SCROL FILA 8
INC A
LD (ESPEJO+51),A
CP 15
JR NZ,TERMINO_SC2
XOR A
LD (ESPEJO+51),A
      LD HL,18437                    ;FILA 8
      LD BC,22789
      CALL ESCROLL_IZQUIERDA_CICLO

      LD D,-8
      LD A,64
      CALL HORACE_ENCIMA

TERMINO_SC2:

LD A,(ESPEJO+52)     ;CONTADOR SCROL FILA 10
INC A
LD (ESPEJO+52),A
CP 10
JR NZ,TERMINO_SC3
XOR A
LD (ESPEJO+52),A
      LD HL,18522                    ;FILA 10
      LD BC,22874
      CALL ESCROLL_DERECHA_CICLO

      LD D,8
      LD A,80
      CALL HORACE_ENCIMA

TERMINO_SC3:

FIN_ZONA_TRONCO:


;////////////////////////////////////////// GESTION DE ZONA ATROPELLOS

;0 COMPROBAMOS QUE ESTAMOS EN PANTALLA CON ATROPELLOS

LD A,(ESPEJO+105)
CP 1
JR Z,ATROPELLOS
CP 3
JR Z,ATROPELLOS
JP FIN_ZONA_ATROPELLO

ATROPELLOS:

LD IX,TABLA_ATROPELLO


                  LD B,4
                  LAS_4FILAS:
                  PUSH BC


                  ;CONTADOR
                  LD A,(IX+7)
                  INC A
                  LD (IX+7),A
                  CP (IX+8)
                  JR Z,CHACACHA
                  JR NO_PINTA_RAYO
                  
                  CHACACHA:
                  XOR A
                  LD (IX+7),A

                  ;INICIAMOS VALOR COMO RAYO O COMO VACIO SI NO EST YA INICIADO
                  LD A,(IX+0)
                  CP 0
                  JR NZ,YA_HAY_BICHO

                     LD BC,10
                     CALL LIMITE  ;A= 0 - 9
                     CP (IX+9)
                     JR C,ES_RAYO

                         ES_VACIO:
                         LD B,0
                         LD C,70

                         JR PINGUILIN

                         ES_RAYO:
                         LD B,8
                         LD C,68

                         PINGUILIN:

                         LD (IX+4),B
                         LD (IX+5),C
                         LD A,(IX+1)
                         LD (IX+0),A

                  YA_HAY_BICHO:

                  ;AJUSTAMOS X
                  LD A,(IX+0)
                  LD D,(IX+6)   ;LIMITE
                  ADD A,D
                  LD E,(IX+2)   ;SI HAS LLEGADO AL FINAL DESACTIVAS
                  CP E
                  JR NZ,NO_RINIZZIA
                     XOR A
                     LD (IX+0),A
                     JR NO_PINTA_RAYO
                  NO_RINIZZIA:

                  ;PINTAMOS
                  LD (IX+0),A
                  LD C,A        ;X
                  LD B,(IX+3)   ;Y
                  LD A,(IX+5)   ;COLOR
                  LD D,0
                  LD E,(IX+4)   ;TIPO
                  LD HL,RALLITO
                  ADD HL,DE
                  CALL HR1X1B
                     
                  ;COMPROBAMOS ATROPELLO

                  JP COMPROBAMOS_ATROPELLO

                     NO_PINTA_RAYO:

                  LD DE,10
                  ADD IX,DE

                  POP BC
                  DJNZ LAS_4FILAS


FIN_ZONA_ATROPELLO:

;//////////////////////////////////////////



;////////////////////////////////////////// GESTION DE ZONA TESTLA

;0 COMPROBAMOS QUE ESTAMOS EN PANTALLA CON TESTLA

LD A,(ESPEJO+105)
CP 2
JR Z,TETSLA
CP 3
JR Z,TETSLABIS
JP FIN_ZONA_TESTLA

TETSLA:
LD IX,TABLA_TESTLA1
JR JOPELINES
TETSLABIS:
LD IX,TABLA_TESTLA2

                  JOPELINES:
                  LD B,3
                  LOS_3TESTLAS:
                  PUSH BC


                  ;CONTADOR
                  LD A,(IX+0)
                  INC A
                  LD (IX+0),A
                  CP (IX+1)
                  JR NC,TESTLA_ABIERTO
                  JR TESTLA_CERRADO

                  TESTLA_ABIERTO:
                  CP(IX+2)
                  JR NZ,TESLILLA
                            LD B,(IX+4)
                            LD C,(IX+5)
                            LD DE,260
                            CALL BORRAZONA
                            XOR A
                            LD (IX+0),A
                  JR TESTLA_CERRADO
                  TESLILLA:


                            LD A,(IX+3)
                            CP 0
                            JR Z,POSIC1
                            CP 10
                            JR Z,POSIC2
                            INC A
                            LD (IX+3),A           ;GUARDAMOS CONTADOR FRAME
                            JR TESTLA_CERRADO     ;SOLO PINTAMOS EN 0 Y EN 5

                            POSIC1:
                            LD HL,TESTLAGFX+0
                            JR PINTATESTLA

                            POSIC2:
                            LD HL,TESTLAGFX+8
                            LD A,255

                            ;PINTAMOS
                            PINTATESTLA:
                            INC A
                            LD (IX+3),A           ;GUARDAMOS CONTADOR FRAME

                            LD B,(IX+4)
                            LD C,(IX+5)
                            LD DE,260
                            LD A,70
                            CALL RELLENA

                            ;DETECTAMOS ELECTROCUCIN
                            LD A,(IX+0)
                            CP (IX+1)                       ;COMPARAMOS CON LIMITE1 PARA VER SI RAYO FUNCIONANDO O NO
                            JR C,NO_ELECTROCUTA

                            LD B,(IX+4)            ;Y RAYO EN BR
                            LD C,(IX+5)            ;X RAYO EN BR
                            CALL BRaHR

                            LD A,(ESPEJO+101)      ;X FROG
                            CP C                   ;X RAYO
                            JR NZ,NO_ELECTROCUTA

                            LD A,(ESPEJO+100)      ;Y FROG
                            SUB B                  ;Y RAYO
                            CP 25
                            JR NC,NO_ELECTROCUTA

                            JP MUERTE_PARCIAL_HORACE

                  TESTLA_CERRADO:

                   NO_ELECTROCUTA:

                  LD DE,6
                  ADD IX,DE

                  POP BC
                  DJNZ LOS_3TESTLAS


FIN_ZONA_TESTLA:

;//////////////////////////////////////////

;////////////////////////////////////////// GESTION DE PANTALLA 4

;0 COMPROBAMOS QUE ESTAMOS EN PANTALLA CON TESTLA

LD A,(ESPEJO+105)
CP 4
JP NZ,FIN_ZONA_P4


                 ;CONTADOR PRIMERO, SI NO VA A TODA LECHE, PSAA LA RUTINA SOLO CON PAR O CON IMPAR
                 ;LD A,(ESPEJO+205)
                 ;INC A
                 ;LD (ESPEJO+205),A
                 ;BIT 0,A
                 ;;CP 0
                 ;JR Z, FIN_ZONA_P4

                 HALT
                 LD IX,ESPEJO+130

                 LD B,7
                 TRANKITRONKI:
                 PUSH BC

                 ;CONTADOR VELOCIDAD
                 INC (IX+7)    ;CONTADOR
                 LD A,(IX+7)
                 CP (IX+5)     ;LIMITE
                 JR NZ,NO_INVIERTO
                 XOR A
                 LD (IX+7),A

                 ;BORRAMOS
                 LD B,(IX+0)
                 LD C,(IX+1)
                 LD DE,771
                 LD A,104
                 CALL COLOREA

                            ;LD B,(IX+0)            ;Y PLATAFORMA BORRADA EN BR
                            ;LD C,(IX+1)            ;X PLATAFORMA BORRADA EN BR
                            ;CALL BRaHR

                            ;LD A,(ESPEJO+101)      ;X FROG
                            ;SUB C                  ;X PLATAFROMA BORRADA
                            ;CP 24
                            ;JR NC,NO_TUNDES

                            ;LD A,(ESPEJO+100)      ;Y FROG
                            ;SUB B                  ;Y RAYO
                            ;CP 24
                            ;JR NC,NO_TUNDES

                            ;JP MUERTE_PARCIAL_HORACE

                            ;NO_TUNDES:

                 ;VARIAMOS DATOS
                 CALL VARIAMOS_LAS_COORDENADAS    ;PARA PODER METERLO EN UN BUCLE TODO Y FUNCIONE DJNZ

                 ;PINTAMOS
                 LD B,(IX+0)
                 LD C,(IX+1)
                 LD DE,771
                 LD A,16
                 CALL COLOREA
                 

                            ;->COMPROBAMOS QUE HORACE NO SE HA QUEDADO EN 3X3 BORRADO
                            LD A,(ESPEJO+100)
                            LD B,A
                            LD A,(ESPEJO+101)
                            LD C,A
                            CALL COLOCAR
                            CALL RESIDENCIATRIBUTO
                            LD A,(HL)
                            CP 104
                            JP Z, MUERTE_PARCIAL_HORACE




                 ;INCREMENTAMOS DISTANCIA
                 INC(IX+6)
                 LD A,(IX+6)
                 CP (IX+4)
                 JR NZ,NO_INVIERTO
                       LD A,(IX+2)   ;VAR Y
                       CALL INVIRTIENDO
                       LD (IX+2),A
                       LD A,(IX+3)   ;VAR X
                       CALL INVIRTIENDO
                       LD (IX+3),A
                       XOR A         ;CONTADOR DISTANCIA A CERO
                       LD (IX+6),A
                 NO_INVIERTO:

                 LD BC,8
                 ADD IX,BC
                 
                 POP BC
                 DJNZ TRANKITRONKI


FIN_ZONA_P4:



JP BUCLE_FROG

;//////////////////////////////////////////


;*******************************************
; RUTINILLAS FROG   ***********************************
;*******************************************

;*******************************************
;*******************************************
TU_MIRA_AVER:
; ENTRADA "BC" VARIACION COORDENADAS
; COMPRUEBA POSIBLE MOVIMIENTO; SI ES SI, BORRAS Y MODIFICAS COORDENADAS FROG
; ATRIBUTOS VLIDOS... 70 (F:NEGRO I:AMARILLO BRILLANTE:1 ) 16 (F:ROJO I:NEGRO BRILLANTE:0) 104 (F:CYAN I:NEGRO BRILLANTE:1)

LD A,(ESPEJO+100)
ADD A,B
LD B,A
LD D,A

LD A,(ESPEJO+101)
ADD A,C
LD C,A
LD E,A

CALL COLOCAR
CALL RESIDENCIATRIBUTO
LD A,(HL)
CP 70
JR Z,HORACE_SE_MUEVE
CP 16
JR Z,HORACE_SE_MUEVE
CP 104
JR Z,HORACE_SE_MUEVE

RET

HORACE_SE_MUEVE:

LD (ESPEJO+106),A           ;TINTA HORACE, PARA BORRAR CON EL DE SALIDA Y NO CON EL DE LLEGADA

;1BORRAMOS EL ANTIGUO
PUSH DE
CALL BORRAR_HORACE
POP DE
;2NUEVAS COORDENADAS

LD A,D
LD (ESPEJO+100),A

LD A,E
LD (ESPEJO+101),A

;CALL BIP
;HALT                                             ;**********************************  BIP O GALOPE DEMASIADO CORTO
;CALL EFECTOGALOPE                                ;**********************************  HALT PARPADEO                            
CALL EFECTO6                                      ;**********************************  EFCETO6 DEMASIADO LARGO

LD A,(ESPEJO+106)           ;TINTA HORACE
LD (ESPEJO+102),A

CALL PINTAR_HORACE

LD A,(ESPEJO+106)           ;TINTA HORACE
CP 104
JP Z, MUERTE_PARCIAL_HORACE

XOR A
LD (ESPEJO+104),A

RET
;*******************************************
;*******************************************
BORRAR_HORACE:
LD A,(ESPEJO+100)
LD B,A
LD A,(ESPEJO+101)
LD C,A
LD A,(ESPEJO+102)
LD HL,VACIO1X1
CALL HR1X1B
RET
;*******************************************
;*******************************************
PINTAR_HORACE:
LD A,(ESPEJO+100)
LD B,A
LD A,(ESPEJO+101)
LD C,A
LD A,(ESPEJO+103)
LD D,0
LD E,A
LD HL,HORACE
ADD HL,DE
LD A,(ESPEJO+102)
CALL HR1X1B
RET
;*******************************************
;*******************************************
ZONA_TRONCO:
LD HL,MAPA_FROG_TRONCOS
CALL PINTAPANTALLA
RET
;*******************************************
;*******************************************
ZONA_LLAVE:

        ;APROVECHAMOS PARA CARGAR VALORES DE PLATAFORMAS

        LD HL,PLATAFORMAS_FROG_VALORi
        LD DE,ESPEJO+130
        LD BC,56
        LDIR

LD A,(ESTADOS+24)   ;LLAVE COGIDA SI/NO
CP 0
RET NZ
LD BC,773       ;Y3 X5
LD A,255
LD DE,TARRO+722
CALL DIBUJA
RET
;*******************************************
;*******************************************
HORACE_ENCIMA:
;ENTRADA "A" CON VALOR Y DE REFERENCIA
;        "D" VARIACION HORACE HORIZONTAL

  ;1VEMOS SI HORACE EN ESA FILA...
  LD B,A              ;Y REFERENCIA
  LD A,(ESPEJO+100)   ;Y HORACE
  CP B
  RET NZ              ;NO EST, VOLVEMOS

  ;2VEMOS SI EST EN TRONCO...
  LD A,(ESPEJO+102)
  CP 16
  JR Z,HULIA
       POP BC      ;VENIMOS DE UN CALL, Y SALIMOS A MUERTE SIN VOLVER A RET
       JP MUERTE_PARCIAL_HORACE
  HULIA:

  ;3 SI EST EN TRONCO:
        ;- BORRAMOS
        PUSH DE
;       CALL BORRAR_HORACE
        POP DE
        ;-MODIFICAMOS X
        LD A,(ESPEJO+101)
        ADD A,D
        LD (ESPEJO+101),A
        ;-PINTAMOS
        CALL PINTAR_HORACE
        ;COMPROBAMOS QUE NO ESTAMOS EN MAL SITIO
        CALL FRIE_HORACE

  ;4 VOLVEMOS
  RET

;*******************************************
;*******************************************
PARPADEA_HORACE:

LD B,100
KLIKEANDO:
PUSH BC

LD B,7
KLIKEA:
PUSH BC

LD A,B
lD (ESPEJO+102),A
CALL PINTAR_HORACE

POP BC
DJNZ KLIKEA

POP BC
DJNZ KLIKEANDO

RET

;*******************************************
;*******************************************
FRIE_HORACE:
;EN TRONCOS SI TINTA=16 Y X= 40 o X=208 TE FRIE UN RAYO...

;0 PANTALLA=4 FUERA
LD A,(ESPEJO+105)
CP 4
RET Z

;1 TINTA=16?
LD A,(ESPEJO+102)
CP 16
RET NZ

;2X=40 o X=208
LD A,(ESPEJO+101)
CP 40
JR Z,SI_SE_FRIE
CP 208
JR Z,SI_SE_FRIE
RET

;3FRIE
SI_SE_FRIE:

SRA A
SRA A
SRA A
AND 31
LD C,A       ;X EN BR
LD B,5       ;Y
LD DE,263    ;1X7
LD A,106     ;FONDO CYAN TINTA ROJA BRILLO 1
LD HL, VACIO1X1+72
CALL RELLENA

POP BC      ;POPEAMOS PQ VENIMOS DE UN CALL
JP MUERTE_PARCIAL_HORACE

;*******************************************
;*******************************************
          
                  COMPROBAMOS_ATROPELLO:
                  LD A,(ESPEJO+100)    ;Y FROG
                  CP (IX+3)
                  JP NZ, NO_PINTA_RAYO
                  LD A,(ESPEJO+101)    ;X FROG
                  CP (IX+0)
                  JP NZ, NO_PINTA_RAYO
                  LD A,(IX+5)          ;COLOR RALLITO
                  CP 70
                  JP Z, NO_PINTA_RAYO
                  CALL MUERTE_PARCIAL_HORACE

;*******************************************
;*******************************************
                  INVIRTIENDO:
                  ;INVERTIMOS NUMERO DADO EN A (SI ES 1, PASA A -1, SI ES -8 PASA A 8), ETC
                  LD B,A
                  LD A,255
                  SUB B
                  INC A
                  RET
;*******************************************
;*******************************************
                 VARIAMOS_LAS_COORDENADAS:       ;LO PONGO EN RUTINA PARA QUE FUNCIONE DJNZ DEL BUCLE DE LAS 8 PLATAFORMAS
                 LD A,(IX+0)     ;Y
                 ADD A,(IX+2)    ;VAR Y
                 LD (IX+0),A
                 LD A,(IX+1)     ;X
                 ADD A,(IX+3)    ;VAR X
                 LD (IX+1),A
                 RET
;*******************************************
;*******************************************

;*******************************************
;*******************************************
MUERTE_PARCIAL_HORACE:

CALL PARPADEA_HORACE
LD A,(ESPEJO+106)        ;TINTA HORACE GUARDADA
LD (ESPEJO+102),A
CALL PINTAR_HORACE

LD A,(VIDAS_HORACE)
DEC A
LD (VIDAS_HORACE),A
CP 0
JP Z,MUERTE_TOTAL

CALL PINTA_VIDA_FROG

CALL ESPERATECLA

LD HL,INZIO_FROG
LD D,0
LD A,(ESPEJO+105)
DEC A
SLA A
LD E,A
ADD HL,DE
LD A,(HL)
LD (ESPEJO+100),A
INC HL
LD A,(HL)
LD (ESPEJO+101),A

JP CARGAPANTALLA_FROG


;*******************************************
;*******************************************
BUENO_A_HORACE:
CALL CELESEJUEGO
LD A,120
LD (X),A
LD A,80
LD (Y),A
CALL PARPADEA_BUENO
CALL BORRABUENO
LD A,88
LD (ESPEJO+100),A    ;Y FROG
LD A,120
LD (ESPEJO+101),A    ;X FROG
CALL PARPADEA_HORACE
CALL FX_TORIRORI
RET

HORACE_A_BUENO:
CALL CELESEJUEGO
LD A,88
LD (ESPEJO+100),A    ;Y FROG
LD A,120
LD (ESPEJO+101),A    ;X FROG
CALL PARPADEA_HORACE
LD A,120
LD (X),A
LD A,80
LD (Y),A
CALL PARPADEA_BUENO
CALL FX_TORIRORI
RET


;*******************************************
;*******************************************
;SALIR DEL FROG

SALIDA_P49:
CALL HORACE_A_BUENO
LD A,120
LD (Y),A
LD A,128
LD (X),A
LD A,49
LD (PANTALLA),A
JR SALIMOS_FROG

SALIDA_P27:
CALL HORACE_A_BUENO
LD A,40
LD (Y),A
LD A,176
LD (X),A
LD A,27
LD (PANTALLA),A
JR SALIMOS_FROG

SALIDA_P17:
CALL HORACE_A_BUENO
LD A,88
LD (Y),A
LD A,64
LD (X),A
LD A,17
LD (PANTALLA),A

SALIMOS_FROG:
LD A,1
LD (FONDO),A
JP CARGAPANTALLA


;*******************************************
; TABLAS FROG   *******************************************
;*******************************************

TABLA_ATROPELLO:
DEFB  0,40,208,104,0,0,8,0,4,5
DEFB  0,208,40,112,0,0,-8,0,3,3
DEFB  0,40,208,120,0,0,8,0,5,2
DEFB  0,208,40,128,0,0,-8,0,2,5

TABLA_TESTLA1:
DEFB  0,50,120,0,14,12
DEFB  0,60,100,0,14,14
DEFB  0,60,120,0,14,16

TABLA_TESTLA2:
DEFB  0,50,120,0,5,12
DEFB  0,60,100,0,5,14
DEFB  0,60,120,0,5,16

INZIO_FROG:          ;COORDENADAS INICIO POR MUERTE FROG
DEFB 32,112, 32,112, 136,200, 88,200

PLATAFORMAS_FROG_VALORi:
DEFB  4,20,1,0,6,20,0,0
DEFB  4,17,0,-1,6,20,0,0
DEFB  13,11,-1,0,6,20,0,0
DEFB  16,11,0,-1,6,20,0,0
DEFB  7,5,1,0,6,20,0,0
DEFB  12,17,1,0,3,14,0,0
DEFB  15,20,0,1,3,14,0,0






;*******************************************
; SPRITES FROG   *******************************************
;*******************************************
HORACE:
DEFB  62,101,229,183,30,114,66,3
DEFB  62,101,229,183,30,19,16,24

RALLITO:
DEFB  0,0,0,0,0,0,0,0              ;ATRIBUTO=70
DEFB  0,0,0,34,85,136,0,0          ;ATRIBUTO=68

TESTLAGFX:
DEFB  16,32,64,32,28,2,4,8
DEFB  8,4,2,4,56,64,32,16

