
;*******************************************
;       *******   S N A K E  ********
;*******************************************



SNAKE:

CALL CELESEJUEGO        ;BORRAMOS PANTALLA JUEGO


;*******************************************
; INTRO SNAKE   *******************************************
;*******************************************

CALL PINTA_FASE_SNK

;*******************************************
; INICIAMOS VARIABLES DE FASE  ***********************************
;*******************************************

;LD A,(VIDAS_SNAKE)               ;VALE 5 AL PRINCIPIO DEL JUEGO, SI GANAMOS MISIL INCREMENTAMOS UNA, PODEMOS COGER OTRA EN CAMPO ABIERTO
;LD (ESPEJO+155),A   ;VIDAS SNAKE

;*******************************************
; INICIAMOS VARIABLES DE PANTALLA  ***********************************
;*******************************************

CARGA_LEVEL:

LD HL,ESPEJO        ;VAMOS A USAR EL ESPACIO RESERVADO EN ESPEJO
LD B,220            ;220 BYTES RESERVAMOS
CALL TABLAACERO

XOR A
LD (MODULOS_SNK),A      ;N DE MODULOS INICIAL DE LA SERPIENTE
LD (VEL_PROGRESIVA),A   ;EMPIEZA VELOCIDAD LENTA

;*******************************************
; DIBUJAMOS TABLERO SNAKE Y VALORES INICIALES ***********************************
;*******************************************

CARGA_TABLERO_SNAKE:

CALL CELESEJUEGO

LD HL,COMUN_SNK                 ;MARCO COMN A TODOS LOS NIVELES
CALL PINTAPANTALLA

LD DE,PUNTERO_MAPA_SNK
LD HL,0
LD A,(PANTALLA_SNAKE)           ;DIBUJOS PROPIOS DE LA PANTALLA
CALL TRUCO_CONTADOR_FRASES      ;HL=VALOR A SUMAR A LA BASE DEL MAPA PARA OBTENER PRIMER VALOR DEL MAPA
LD DE,MAPA_SNK
ADD HL,DE
CALL PINTAPANTALLA

LD A,(PANTALLA_SNAKE)           ;DA VALORES YX - VARY  - VARX  - NABRIR - YX CONTADOR - YX FINAL
CALL INICIANDO_SNAKE

LD A,255
CALL  DIBUJA_CONTADOR_SNAKE     ;DIBUJAMOS LA PARTE DE  ABAJO DEL CONTADOR CON EL ATRIBUTO SEALADO EN "A" CON EL N DE MODULOS NECESARIOS

  LD IX,ESPEJO                  ;DIBUJAMOS CABEZA PARA VER HACIA DONDE VA
  LD B,(IX+0)
  LD C,(IX+1)
  LD A,68
  LD HL,CABEZA_SNAKE
  CALL HR1X1B

  ;LD DE,PUERTA_ELECTRICA_PTX    ;CARGAMOS EN SU CASO EN ESPEJO+180 LOS VALORES DE LAS PUERTAS ELCTRICAS
  LD A,(PANTALLA_SNAKE)
  CP 1
  JR Z,FIN_CARGA_P_ELECTRICA      ;PANTALLA=1 ES LA UNICA SIN CERRADURA
  ;DEC A
  ;LD H,0
  ;LD L,A
  ;ADD HL,DE
  ;LD A,(HL)
  ;CP 0
  ;JR Z,FIN_CARGA_P_ELECTRICA

  LD DE,PUERTA_ELECTRICA_PTX
  LD HL,0
  LD A,(PANTALLA_SNAKE)
  CALL TRUCO_CONTADOR_FRASES   ;HL=VALOR A SUMAR A LA BASE DEL MAPA PARA OBTENER PRIMER VALOR DEL MAPA
  LD DE,PUERTA_ELECTRICA
  ADD HL,DE                    ;HL 1 VALOR A CARGAR

  LD DE,ESPEJO+180

  KIARGANDO:
  LD A,(HL)
  CP 255
  JR Z,FIN_CARGA_P_ELECTRICA
  LD (DE),A
  INC HL
  INC DE
  JR KIARGANDO

FIN_CARGA_P_ELECTRICA:

  ;MUSIQUILLA                    ;>-------------------------------------------------------------------------------------------------------------
;  CALL ROMANCE_SONG
  CALL ESPERATECLA               ;QUITO ESTE ESPERATECLA ??

;*******************************************
; BUCLE SNAKE   ***********************************
;*******************************************

   ;PANTALLA DE CONSEGUIDO


BUCLE_SNAKE:

LD A,(23560)             ;LAST_K

CP 81
JR Z,GO_ARRIBA
CP 113
JR Z,GO_ARRIBA
CP 65
JR Z,GO_ABAJO
CP 97
JR Z,GO_ABAJO
CP 79
JR Z,GO_IZQUIERDA
CP 111
JR Z,GO_IZQUIERDA
CP 80
JR Z,GO_DERECHA
CP 112
JR Z,GO_DERECHA

JR NO_GIRO


;CALL LEER_TECLADO
;CP 0
;JR Z,NO_GIRO

GO_ARRIBA:
                   ;CP 1
                   ;JR NZ,GO_ABAJO
                   LD A,-8
                   LD (ESPEJO+150),A     ;VARIACION DE Y
                   XOR A
                   LD (ESPEJO+151),A     ;VARIACION DE X
                   JR NO_GIRO
GO_ABAJO:
                   ;CP 2
                   ;JR NZ,GO_DERECHA
                   LD A,8
                   LD (ESPEJO+150),A     ;VARIACION DE Y
                   XOR A
                   LD (ESPEJO+151),A     ;VARIACION DE X
                   JR NO_GIRO
GO_DERECHA:
                   ;CP 3
                   ;JR NZ,GO_IZQUIERDA
                   XOR A
                   LD (ESPEJO+150),A     ;VARIACION DE Y
                   LD A,8
                   LD (ESPEJO+151),A     ;VARIACION DE X
                   JR NO_GIRO
GO_IZQUIERDA:
                   ;CP 4
                   ;JR NZ,NO_GIRO
                   XOR A
                   LD (ESPEJO+150),A     ;VARIACION DE Y
                   LD A,-8
                   LD (ESPEJO+151),A     ;VARIACION DE X

NO_GIRO:


;//////////////////////////////////////////  PINTAR SERPIENTE

;1 COPIAMOS VALORES CON BUCLE Y NO CON LDDR POR ATRIBUTOS QUE NO SE DESPLAZAN...

LD A,(MODULOS_SNK)
LD DE,3
CALL Mul8              ;HL=DE*A=3*MODULOS
INC HL                 ;+1
LD DE,ESPEJO
ADD HL,DE
EX DE,HL               ;PONEMOS EN "DE" DIRECCION DESTINO A COPIAR
PUSH DE ;(****)
                       ;APROVECHAMOS Y BORRAMOS EL LTIMO MDULO
                       LD A,(DE)
                       LD C,A
                       DEC DE
                       LD A,(DE)
                       LD B,A
                       LD A,1
                       LD HL,VACIO1X1
                       CALL HR1X1B
POP DE ;(****)
LD H,D
LD L,E
DEC HL
DEC HL
DEC HL                 ;PONEMOS EN "HL" DIRECCION ORIGEN A COPIAR

LD A,(MODULOS_SNK)
CP 0
JR Z,NO_SERPENTEA
LD B,A
SERPENTEA:

                       LD A,(HL)
                       LD (DE),A     ;COPIAMOS DATO DE LA X
                       DEC HL
                       DEC DE
                       LD A,(HL)
                       LD (DE),A     ;COPIAMOS DATO DE LA Y
                       DEC HL
                       DEC HL
                       DEC DE
                       DEC DE
DJNZ SERPENTEA
NO_SERPENTEA:

;2 ACTUALIZAMOS DATOS DEL LA CABEZA DE LA SERPIENTE

LD A,(ESPEJO+150)    ;VARIACION DE LA Y
LD B,A
LD A,(ESPEJO+0)
ADD A,B
LD (ESPEJO+0),A

LD A,(ESPEJO+151)    ;VARIACION DE LA X
LD B,A
LD A,(ESPEJO+1)
ADD A,B
LD (ESPEJO+1),A



       ;ANTES DE PINTAR LA CABEZA VEMOS SI HEMOS CHOCADO Y LO REFLEJAMOS EN VARIABLE ESPEJO+156 (0 NO CHOQUE  1 COGIDO MODULO  2 MUERTE PARCIAL)
       ;PORQUE EN CUALQUIER CASO VAMOS A PINTAR ENCIMA...

             LD C,A                  ;X CABEZA  DONDE VAMOS A PINTAR HR
             LD A,(ESPEJO+0)
             LD B,A                  ;Y CABEZA  DONDE VAMOS A PINTAR HR
             CALL COLOCAR
             CALL RESIDENCIATRIBUTO
             LD A,(HL)
             CP 1
             JR NZ,KULIBRI1
             XOR A                   ;SI ATRIBUTOS=1 NO CHOQUE INDICADOR=0
             JR KULIBRI
           KULIBRI1:
             CP 192
             JR C,KULIBRI2
             LD A,1                  ;SI ATRIBUTOS NO ES MENOR DE 192 COGISTE MODULO
             JR KULIBRI
           KULIBRI2:
             LD A,2                  ;SI ATRIBUTOS MENOR DE 192 MUERTE QUE TE CRIO
           KULIBRI:
             LD (ESPEJO+156),A       ;INDICADOR DE CHOQUE


;3 PINTAMOS CABEZA

CALL PA_DONDE_MIRAS   ;OBTENEMOS HL=DIRECCION CARA SNAKE

LD IX,ESPEJO

LD B,(IX+0)
LD C,(IX+1)
LD A,68
;LD HL,(CARA_SNK)
CALL HR1X1B

;4 PINTAMOS MODULOS

HALT

LD IX,ESPEJO+3

LD A,(MODULOS_SNK)
CP 0
JR Z,NO_PINTA_MODULOS
LD B,A
SERPENTEAX:
PUSH BC

LD B,(IX+0)
LD C,(IX+1)
LD A,(IX+2)
LD HL,CUERPO_SNAKE
CALL HR1X1B

INC IX
INC IX
INC IX

POP BC
DJNZ SERPENTEAX

NO_PINTA_MODULOS:


;//////////////////////////////////////////  ESTUDIAMOS POSIBLE CHOQUE
LD A,(ESPEJO+156)                    ;INDICADOR   (0 NO CHOQUE // 1 COGIDO MODULO // 2 MUERTE PARCIAL)
CP 0
JR Z,NO_PASO_NA
CP 2
JP Z,MUERTE_SNAKE_PARCIAL

;SI LLEGAMOS AQUI HEMOS COGIDO MDULO O ES META ABIERTA

           ;0 META?
           LD HL,ESPEJO+173            ;YX DE LA META
           CALL POSIZION_SNAKE         ;RUTINA QUE COMPARA EL YX DE LA DIRECCION CON CABEZA SNAKE, SALIDA A=0 CUANDO NO ESTAS EN LA POSICIN INDICADA  A=1 CUANDO SI LO ESTAS
           CP 1
           JP Z,VICTORIA_SNAKE_PARCIAL


           LD A,(ESPEJO+173)          ;Y META
           LD B,A
           LD A,(ESPEJO+0)            ;Y CABEZA
           CP B
           JR NZ,CABISPASKIS

           LD A,(ESPEJO+174)          ;X META
           LD B,A
           LD A,(ESPEJO+1)            ;X CABEZA
           CP B
           JP Z,VICTORIA_SNAKE_PARCIAL

           ;1 INDICADOR MODULO NO PINTADO
           CABISPASKIS:
           XOR A
           LD (ESPEJO+200),A          ;MODULO NO GENERADO

           ;2INCREMENTAMOS N MODULOS
           LD A,(MODULOS_SNK)
           INC A
           LD (MODULOS_SNK),A
           
           ;3ASIGNAMOS VALORES
           LD DE,3
           CALL Mul8              ;HL=DE*A=3*MODULOS
           LD DE,ESPEJO
           ADD HL,DE              ;HL=DIRECCION 1 VALOR NUEVO MODULO

           LD A,(ESPEJO+210)      ;Y EN BR
           SLA A
           SLA A
           SLA A                  ;Y EN HR
           LD (HL),A

           INC HL
           LD A,(ESPEJO+211)      ;X EN BR
           SLA A
           SLA A
           SLA A                  ;X EN HR
           LD (HL),A

           INC HL
           LD A,(ESPEJO+212)
           ADD A,64               ;COLOR MODULO BRILLANTE
           LD (HL),A

           CALL EFECTO4

NO_PASO_NA:


;//////////////////////////////////////////  CONTADOR DE MDULOS

LD HL,ESPEJO+171             ;YX DEL CONTADOR
CALL POSIZION_SNAKE          ;RUTINA QUE COMPARA EL YX DE LA DIRECCION CON CABEZA SNAKE, SALIDA A=0 CUANDO NO ESTAS EN LA POSICIN INDICADA  A=1 CUANDO SI LO ESTAS
CP 0
JP Z,FIN_CONTADOR_MODULOS

LD A,(ESPEJO+151)
CP -8
JP NZ,FIN_CONTADOR_MODULOS   ;SI NO HAS ENTRADO POR LA DERECHA NO FUNCIONA

        ;1 ANIMACION CONTADOR

        LD B,7
        CKACKA:
        PUSH BC
               
               LD B,7
               CKACKA2:
               PUSH BC

               LD A,B
               CALL DIBUJA_CONTADOR_SNAKE

               POP BC
               DJNZ CKACKA2

        CALL BIP

        POP BC
        DJNZ CKACKA

        LD A,255
        CALL DIBUJA_CONTADOR_SNAKE                       ;DIBUJAMOS LA PARTE DE  ABAJO DEL CONTADOR CON EL ATRIBUTO SEALADO EN "A"


        ;2 PINTAMOS LOS MODULOS COGIDOS

        LD A,113                     ;TINTA AZUL FONDO AMARILLO BRILLANTE
        LD (COLORFUENTE),A
        LD A,(ESPEJO+171)
        SUB 8
        LD D,A
        LD A,(ESPEJO+172)
        ADD A,8
        LD E,A
        CALL HRaBR                 ;TRANSFORMA "DE" HR EN "DE" BR
        LD B,D
        LD C,E
        LD A,(MODULOS_SNK)
        CALL DOSNUMEROS

        ;3 COMPARAMOS CON OBJETIVO

        LD A,(ESPEJO+170)            ;LIMITE
        LD B,A
        LD A,(MODULOS_SNK)           ;MODULOS
        CP B
        JR C,NO_ABRE_META

        SI_ABRE_META:

                     CALL PAUSADE5

                     LD A,(ESPEJO+173)
                     LD D,A
                     LD A,(ESPEJO+174)
                     LD E,A
                     CALL HRaBR
                     LD B,D
                     LD C,E
                     LD DE,257
                     LD A,199         ;TINTA BLANCA FONDO NEGRO BRILLANTE FLASH
                     CALL COLOREA

                     LD A,(ESPEJO+171)
                     SUB 8
                     LD D,A
                     LD A,(ESPEJO+172)
                     LD E,A
                     CALL HRaBR
                     LD B,D
                     LD C,E
                     LD A,254           ;2 COLOR DEL CONTADOR ARRIBA
                     LD DE,OBJETOX+1346
                     CALL DIBUJA

                     CALL EFECTO4
                     JR FIN_CONTADOR_MODULOS

        NO_ABRE_META:

                     CALL EFECTO_CAGADA

                     LD A,(ESPEJO+171)
                     SUB 8
                     LD D,A
                     LD A,(ESPEJO+172)
                     LD E,A
                     CALL HRaBR
                     LD B,D
                     LD C,E
                     LD A,255           ;1 COLOR DEL CONTADOR ARRIBA
                     LD DE,OBJETOX+1346
                     CALL DIBUJA


FIN_CONTADOR_MODULOS:


;//////////////////////////////////////////  GENERAR MDULOS PARA COGER

;   ESPEJO+200  -> 0/1 MODULO NO PINTADO / SI PINTADO
;   ESPEJO+210  -> Y MODULO A COGER
;   ESPEJO+211  -> X MODULO A COGER
;   ESPEJO+212  -> COLOR MODULO A COGER

LD A,(ESPEJO+200)
CP 0
JR NZ,NO_GENERA_MODULO

GENERA_UNO:

LD BC,20
CALL LIMITE                ;ENTRADA BC VALOR MXIMO,, RESULTADO VALOR ENTRE 0 Y (MAXIMO-1)
ADD A,6
LD (ESPEJO+211),A               ;X

LD BC,14
CALL LIMITE
ADD A,4
LD (ESPEJO+210),A               ;Y
LD B,A

LD A,(ESPEJO+211)
LD C,A

CALL RESIDENCIA
CALL RESIDENCIATRIBUTO
LD A,(HL)
CP 1
JR NZ,GENERA_UNO           ;CASILLA OCUPADA, BUSCAMOS OTRA


GENERA_COLOR:
LD BC,8                    ;COLOR DE 1 A 7
CALL LIMITE
CP 0
JR Z,GENERA_COLOR
LD (ESPEJO+212),A

LD A,(ESPEJO+210)
LD B,A
LD A,(ESPEJO+211)
LD C,A
CALL BRaHR                 ;PASAMOS A HR
LD A,(ESPEJO+212)
ADD A,192
LD HL,CUERPO_SNAKE
CALL HR1X1B

LD A,1
LD (ESPEJO+200),A          ;MODULO GENERADO

NO_GENERA_MODULO:



;//////////////////////////////////////////  PINTAR ANIMACION PUERTA ELCTRICA



;1 CONTADOR
LD A,(ESPEJO+215)
INC A
LD (ESPEJO+215),A
CP 4                    ;CADA 4 CICLOS CAMBIAMOS
JR NZ,SALTA_PUERTAS
XOR A
LD (ESPEJO+215),A

;2DEFINIMOS FRAME +0 O MAS 8 EN DE, QUE LUEGO SE SUMARA A HL=PLASMA

LD A,(ESPEJO+216)
CP 0
JR Z,OOOPPP

XOR A
JR FIN_OOOPPP

OOOPPP:
LD A,8

FIN_OOOPPP:
LD (ESPEJO+216),A
LD D,0
LD E,A

;3VEMOS LAS PUERTAS ANIMADAS...

LD IX,ESPEJO+180

HHHHJJJJ:
  LD A,(IX+0)           ;HAY O NO HAY PUERTA
  CP 0
  JR Z,SALTA_PUERTAS

  LD A,(IX+2)           ;PUERTA YA ABIERTA=1
  CP 1
  JR Z,OTRA_PUERTA

  PUSH DE
  LD B,(IX+3)           ;PINTAMOS ANIMACION
  LD C,(IX+4)
  LD A,68
  LD HL,PLASMA
  ADD HL,DE
  CALL HR1X1B
  POP DE

  OTRA_PUERTA:
  LD DE,5
  ADD IX,DE
  JR HHHHJJJJ

SALTA_PUERTAS:



CALL BIP
LD A,(VEL_PROGRESIVA)
CP 251
JR Z,VELOZ5
INC A
LD (VEL_PROGRESIVA),A

CP 50
JR C,VELOZ1
CP 100
JR C,VELOZ2
CP 150
JR C,VELOZ3
CP 200
JR C,VELOZ4
CP 250
JR C,VELOZ5

VELOZ1:
LD B,10
JR PARON
VELOZ2:
LD B,9
JR PARON
VELOZ3:
LD B,8
JR PARON
VELOZ4:
LD B,7
JR PARON
VELOZ5:
LD B,6

PARON:
HALT
DJNZ PARON


;- NIVELES SNAKE FASE 4 5 6




JP BUCLE_SNAKE

;*******************************************
; RUTINILLAS SNAKE   ***********************************
;*******************************************

;*******************************************
;*******************************************
INICIANDO_SNAKE:
;DA VALORES YX - VARY  - VARX  - NABRIR - YX CONTADOR - YX FINAL
;ENTRADA A=N PANTALLA

DEC A
LD D,A
LD E,9
CALL Multiply                    ; this routine performs the operation HL=D*E
LD DE,BALORES_INICIALES
ADD HL,DE                        ;HL EN DIRECCION CORRECTA DE BALORES_INICIALES

LD A,(HL)                        ;Y
LD (ESPEJO+0),A

INC HL
LD A,(HL)                        ;X
LD (ESPEJO+1),A

INC HL
LD A,(HL)                        ;VARIACION DE Y
LD (ESPEJO+150),A

INC HL
LD A,(HL)                        ;VARIACION DE X
LD (ESPEJO+151),A

INC HL
LD A,(HL)                        ;N DE MODULOS PARA ABRIR
LD (ESPEJO+170),A

INC HL
LD A,(HL)                        ;Y DEL CONTADOR DE MODULOS
LD (ESPEJO+171),A

INC HL
LD A,(HL)                        ;X DEL CONTADOR DE MODULOS
LD (ESPEJO+172),A

INC HL
LD A,(HL)                        ;Y DE LA META FINAL
LD (ESPEJO+173),A

INC HL
LD A,(HL)                        ;X DE LA META FINAL
LD (ESPEJO+174),A

RET

;*******************************************
;*******************************************
PA_DONDE_MIRAS:

  LD HL,ESPEJO+150
  LD A,(HL)

SERPIENTE_ARRIBA:
  CP -8
  JR NZ,SERPIENTE_ABAJO
       LD HL,CABEZA_SNAKE+0
       RET

SERPIENTE_ABAJO:
  CP 8
  JR NZ,SERPIENTE_DERECHA
       LD HL,CABEZA_SNAKE+8
       RET

SERPIENTE_DERECHA:
  INC HL
  LD A,(HL)
  CP 8
  JR NZ,SERPIENTE_IZQUIERDA
       LD HL,CABEZA_SNAKE+24
       RET

SERPIENTE_IZQUIERDA:
       LD HL,CABEZA_SNAKE+16
       RET


;*******************************************
;*******************************************

POSIZION_SNAKE:           ;RUTINA QUE COMPARA EL YX DE LA DIRECCION CON CABEZA SNAKE, SALIDA A=0 CUANDO NO ESTAS EN LA POSICIN INDICADA  A=1 CUANDO SI LO ESTAS

LD A,(HL)                  ;Y A COMPARAR
LD B,A
LD A,(ESPEJO+0)            ;Y CABEZA
CP B
JR NZ,CHACHY

INC HL
LD A,(HL)                  ;X A COMPARAR
LD B,A
LD A,(ESPEJO+1)            ;X CABEZA
CP B
JR Z,CHACHY2

CHACHY:
XOR A
RET

CHACHY2:
LD A,1
RET


;*******************************************
;*******************************************

        DIBUJA_CONTADOR_SNAKE:     ;DIBUJAMOS LA PARTE DE  ABAJO DEL CONTADOR CON EL ATRIBUTO SEALADO EN "A" CON EL N DE MODULOS NECESARIOS
        LD(JOKER),A
        LD A,(ESPEJO+171)
        LD D,A
        LD A,(ESPEJO+172)
        LD E,A
        CALL HRaBR                 ;TRANSFORMA "DE" HR EN "DE" BR
        INC D
        LD B,D
        LD C,E
        PUSH BC                    ;(*****)
        LD A,(JOKER)
        LD DE,OBJETOX+1388
        CALL DIBUJA

        LD A,48                    ;TINTA NEGRA FONDO AMARILLO
        LD (COLORFUENTE),A
        POP BC                     ;(*****)
        INC C
        LD A,(ESPEJO+170)
        CALL DOSNUMEROS

        RET

;*******************************************
;*******************************************

PINTA_FASE_SNK:

CALL CELESEJUEGO
LD IX,PINTAR_PP_SNAKE

LD B,9
FLINTON:
PUSH BC

     LD B,(IX+0)
     LD C,(IX+1)
     LD HL,SIERPE
     LD D,0
     LD E,(IX+2)
     ADD HL,DE
     EX DE,HL
     LD A,255
     CALL DIBUJA

INC IX
INC IX
INC IX

POP BC
DJNZ FLINTON

LD A,71
LD (COLORFUENTE),A
LD BC,1549
LD DE,TEXTOS+166        ;"SNAKE"
CALL UNAFRASE

LD A,69
LD (COLORFUENTE),A
LD BC,2572
LD DE,TEXTOS+65        ;"FASE -"
CALL UNAFRASE

LD BC,2579
LD A,(PANTALLA_SNAKE)
CALL UNNUMERO

LD A,(ESTADOS+1)       ;VEMOS QUE PREMIO CONSIGUE, 1 o NADA o VIDA FROG
CP 1
JR Z,TEDANLIFEFROG     ;SI ESTADO+1=1 ES QUE YA CONSEGUIMOS EN BOTE CON MOSCA, ENTONCES SOLO PUEDE SER YA VIDA FROG PARA HORACE

LD A,(PREMIO_SNK)
CALL SACA_DE_OBJETO
LD BC,3599
LD A,255
CALL DIBUJA

;MUSIQUILLA                    ;>-------------------------------------------------------------------------------------------------------------
CALL ROMANCE_SONG
CALL ESPERATECLA               ;QUITO ESTE ESPERATECLA

RET

TEDANLIFEFROG:

LD DE,VIDA_EXTRA+0
LD BC,3599
LD A,255
CALL DIBUJA

;MUSIQUILLA                    ;>-------------------------------------------------------------------------------------------------------------
CALL ROMANCE_SONG
CALL ESPERATECLA               ;QUITO ESTE ESPERATECLA

RET



;*******************************************
;*******************************************
MUERTE_SNAKE_PARCIAL:

;1 VEMOS SI NO ES QUE ERA UNA CERRADURA DE PUERTA ELECTRICA

LD HL,ESPEJO+180

HHHJJJ:
  LD A,(HL)
  CP 0
  JR Z,NOLOERA

  CALL POSIZION_SNAKE           ;RUTINA QUE COMPARA EL YX DE LA DIRECCION CON CABEZA SNAKE, SALIDA A=0 CUANDO NO ESTAS EN LA POSICIN INDICADA  A=1 CUANDO SI LO ESTAS
  CP 1
  JR Z,SICERRADURA
  LD DE,5
  ADD HL,DE
  JR HHHJJJ

SICERRADURA:

  LD A,1
;  INC HL
  INC HL
  LD (HL),A                   ;CAMBIAMOS ESTADO PUERTA A 1

  INC HL
  LD A,(HL)     ;B - (Y)      ;BORRAMOS PUERTA
  LD B,A
  INC HL
  LD A,(HL)     ;C - (X)
  LD C,A
  LD A,1          ;A - (ATRIBUTO)
  LD HL,VACIO1X1  ;HL- SPRITE
  CALL HR1X1B

  CALL EFECTO4

  XOR A
  LD (ESPEJO+156),A
  JP NO_PINTA_MODULOS           ;VOLVEMOS AL BUCLE COMO SI NO HUBIERAMOS CHOCADO

NOLOERA:


;2 SI NO LO ERA MUERTE PARCIAL Y POSIBLE MUERTE TOTAL

;EXPLOSION
LD A,(ESPEJO+0)
LD B,A
LD A,(ESPEJO+1)
LD C,A
LD HL,CALAVERA_SNAKE
LD A,194               ;TINTA ROJA FONDO NEGRO BRILLANTE Y FLASH 1
CALL HR1X1B

CALL EFECTO_CAGADA

CALL ESPERATECLA

LD A,(VIDAS_SNAKE)
DEC A
LD (VIDAS_SNAKE),A
CP 0
JP Z,MUERTE_TOTAL

CALL PINTA_VIDA_SNAKE

JP SNAKE




;*******************************************
;*******************************************

VICTORIA_SNAKE_PARCIAL:

CALL EFECTO2
CALL EFECTO4

LD A,(PANTALLA_SNAKE)
INC A
LD (PANTALLA_SNAKE),A
LD B,A
LD A,(FINAL_FASE_SNK)
CP B
JR Z,VICTORIA_SNAKE_TOTAL

CALL PINTA_FASE_SNK

JP CARGA_LEVEL

VICTORIA_SNAKE_TOTAL:


CALL CELESEJUEGO
     LD BC,2315
     LD A,71
     LD (COLORFUENTE),A
     LD DE,TEXTOS+142      ;"VICTORIA !"
     CALL UNAFRASE

;MUSIQUILLA  ;------------------------------------------------------------------------------------------------------------------------
CALL FX_TORIRORI
CALL ESPERATECLA

LD A,(FINAL_FASE_SNK)      ;O VALE 4 O VALE 7
CP 4
JR NZ,SALIMOS_SNAKE_PANTALLA80

      ;SI ES PANTALLA 4 VEMOS SI YA LO HEMOS COGIDO O NO EL PREMIO
      LD A,(ESTADOS+1)
      CP 1
      JR NZ,PREMIO_CONSEGUIDO

       CALL INCREMENTA_VIDA_FROG    ;SI REPETIMOS EL JUEGO CONSEGUIMOS UNA VIDA PARA FROG
       JR SALIMOS_SNAKE

       PREMIO_CONSEGUIDO:
       LD A,1                  ; PONEMOS ESTADOS-1 EN 1
       LD (ESTADOS+1),A
       LD A,(PREMIO_SNK)
       CALL METE_INVENTARIO    ; Y METEMOS EN INVENTARIO PREMIO

SALIMOS_SNAKE:

CALL EFECTO3

LD A,176
LD (X),A
LD A,88
LD (Y),A
JP CARGAPANTALLA

SALIMOS_SNAKE_PANTALLA80:

CALL EFECTO3

CALL INCREMENTA_VIDA_FROG    ;CONSEGUIMOS UNA VIDA PARA FROG DE REGALO

LD A,72
LD (X),A
LD A,48
LD (Y),A
LD A,80
LD (PANTALLA),A
JP CARGAPANTALLA


;*******************************************
;*******************************************





;*******************************************
; TABLAS SNAKE   *******************************************
;*******************************************

BALORES_INICIALES:         ;Y-X-VARY-VRX-MODULOS ABRIR-YX CONTADOR-YX META
;DEFB  96,176,  -8,0, 5,   56,104,   80,40
;DEFB  96,176,  -8,0, 7,   56,104,   80,40
;DEFB  120,152, -8,0, 9,   56,152,   112,40

DEFB  96,176,  -8,0, 5,   56,104,   80,40
DEFB  96,176,  -8,0, 7,   56,104,   80,40
DEFB  72,160,  -8,0, 7,   56,104,   80,40
DEFB  112,144, -8,0, 9,   64,152,   56,40
DEFB  120,136, -8,0, 6,   112,152,  120,40
DEFB  120,152, -8,0, 9,   56,152,   112,40


PUERTA_ELECTRICA_PTX:
DEFB 0,6,6,6,6,11

PUERTA_ELECTRICA:
DEFB 104,136, 0, 80,72,                          255
DEFB 120,168, 0, 120,72,                         255
DEFB 112,168, 0, 112,120,                        255
DEFB 48,72,   0, 48,120,                         255
DEFB 120,184, 0, 112,120,  56,88, 0, 80,72,      255

PINTAR_PP_SNAKE:
DEFB  7,10,87, 7,12,67, 7,14,67, 7,16,67, 7,18,67, 5,20,0, 5,22,56, 10,9,107, 10,22,107


;*******************************************
; SPRITES SNAKE   *******************************************
;*******************************************

CABEZA_SNAKE:
DEFB  48,188,178,162,162,230,126,60    ;+0
DEFB  60,126,230,162,162,178,188,48    ;+8
DEFB  0,62,71,67,227,255,6,124         ;+16
DEFB  0,124,226,194,199,255,96,62      ;+24
CUERPO_SNAKE:
DEFB  24,24,60,231,231,60,24,24

CALAVERA_SNAKE:
DEFB  126,153,153,231,126,82,36,60

PLASMA:
DEFB  8,16,32,32,16,8,8,16             ;+0
DEFB  16,8,4,4,8,16,16,8               ;+8

SIERPE:
DEFB  2,3, 15,199,8,63,14,57,63,193,127,4,231,226,226,62,225,0,114,128,56,64,12,160,13,16,6,40,6,72,3,4,3,4,193,172,255,132,191,4,42,60,0,8,18,8,0,16,255,224,  68,68,68,70,68,70  ;CABEZA
DEFB  1,1, 0,0,0,0,227,28,2,1,  2    ;LENGUA
DEFB  2,1, 224,7,254,63,63,252,85,200,32,130,0,32,0,0,255,255,  68,68   ;CUERPO SERPIENTE
DEFB  2,1, 0,3,0,15,7,252,31,229,121,32,240,0,31,128,0,255, 68,68       ;COLA SERPIENTE

FILIGRANA:  
;FILIGRANA 1x4
DEFB  1,4, 16,16,56,84,84,84,146,130,146,130,68,68,40,40,16,84,16,186,84,16,186,84,16,16,0,16,0,16,16,16,16,16, 68,68,68,68




